########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_cashe.4gs/arheader.4gl  1.7  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#######################################################################
function llh_input1()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
# used to input from screen1, a/r cash receipts
#
    define
        gen_desc char(35), # generic description for checking validities
        scratch char(1),
        old_rcpt_amt like strcashe.cash_amt,
        old_cust_code like strcustr.cust_code,
        old_acct like strcashe.cash_acct,
        old_department like strcashe.cash_department

    if m_rcashe.doc_no is null then let m_rcashe.doc_no = al_uniq() end if

    let old_cust_code = p_rcashe.cust_code
    input p_rcashe.* without defaults from s_rcashe.*
        on key (control-i)
            return -1
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxtranrCR",m_rcashe.doc_no,"-UNPOSTED","")
        on key (control-z)
            case
                when infield(cust_code)
                    let old_cust_code = p_rcashe.cust_code
                    call ar_custz() returning p_rcashe.cust_code
                    if p_rcashe.cust_code is null
                    then
                        let p_rcashe.cust_code = old_cust_code
                    end if
                    display by name p_rcashe.cust_code
                    next field cust_code
                when infield(cash_acct)
                    let old_acct = p_rcashe.cash_acct
                    call al_chrtz() returning p_rcashe.cash_acct
                    if p_rcashe.cash_acct is null
                    then
                        let p_rcashe.cash_acct = old_acct
                    end if
                    display by name p_rcashe.cash_acct
                    next field cash_acct
                when infield(cash_department)
                    let old_department = p_rcashe.cash_department
                    call al_deptz() returning p_rcashe.cash_department
                    if p_rcashe.cash_department is null
                    then
                        let p_rcashe.cash_department = old_department
                    end if
                    display by name p_rcashe.cash_department
                    next field cash_department
            end case
        after field rcpt_date
            if p_rcashe.rcpt_date is null
            then
                let p_rcashe.rcpt_date = today
                display by name p_rcashe.rcpt_date
            end if
        after field cust_code
            if p_rcashe.cust_code is null
            then
                call fg_err(6) # Customer code must be entered
                let p_rcashe.cust_code = curr_cust_code
                display by name p_rcashe.cust_code
                next field cust_code
            end if

            call ar_custn(p_rcashe.cust_code)
                returning p_rcashe.bus_name
            display by name p_rcashe.bus_name
            if p_rcashe.bus_name = "NOT FOUND"
            then
                call fg_err(8) # Invalid customer code
                next field cust_code
            end if


            if p_rcashe.cust_code != old_cust_code or
               old_cust_code is null
            then
                if not new_cust()
                then
                    if int_flag != 0
                    then
                        exit input
                    end if
                    let p_rcashe.cust_code = old_cust_code
                    display by name p_rcashe.cust_code
                    next field cust_code
                end if
                let old_cust_code = p_rcashe.cust_code
            end if

        before field rcpt_amt
            let old_rcpt_amt = p_rcashe.rcpt_amt

        after field rcpt_amt
            let p_rcashe.rcpt_amt = al_round( "a", p_rcashe.rcpt_amt )
            if p_rcashe.rcpt_amt is null
            then
                let p_rcashe.rcpt_amt = 0
            end if
            let p_rcashe.bal_remaining = p_rcashe.bal_remaining -
                old_rcpt_amt + p_rcashe.rcpt_amt
            display by name p_rcashe.rcpt_amt,
                p_rcashe.bal_remaining
        after field cash_acct
            if not chk_acct(p_rcashe.cash_acct)
            then
                next field cash_acct
            end if
        after field cash_department
            if not chk_department(p_rcashe.cash_department)
            then
                next field cash_department
            end if
        after field auto_pay
            if p_rcashe.auto_pay = "Y"
            then
                call automatic_pay()
            end if
            let p_rcashe.auto_pay = " "
            display by name p_rcashe.auto_pay
    end input
    call cust_unlock()
    return 0
end function
# llh_input1()

#######################################################################
function dup_cust()
#   returns true/false based upon dup/no dup
#######################################################################
#   - This checks if this customer has already been entered.
#
    define
        scratch integer, # something to select into
        scratch1 integer # temporary doc_no

    if m_rcashe.doc_no is null
    then
        let scratch1 = 0
    else
        let scratch1 = m_rcashe.doc_no
    end if

    select count(*) into scratch from strcashe
        where cust_code = p_rcashe.cust_code
            and doc_no != scratch1
    if scratch = 0  # no duplicate is found
    then
        return false
    else
        return true
    end if

end function
# dup_cust()

#######################################################################
function automatic_pay()
#######################################################################
# pays the on account balance first, then scans through the invoice
# lines and pays those that have a balance left in them.  any money
# left over is applied to "on account".
#
    define
        n integer # generic counter

    let p_rcashe.bal_remaining = p_rcashe.rcpt_amt -
        p_rcashe.on_acct_amt - p_rcashe.oa_amt
    if p_rcashe.bal_remaining < 0
    then
        let p_rcashe.bal_remaining = 0
    end if
    let p_rcashe.paid_tot = 0
    let p_rcashe.disc_tot = 0
    for n = 1 to rec1_cnt
        if q_rcashd[n].balance is null
        then
            continue for
        end if
        let q_rcashd[n].balance = q_rcashd[n].balance + q_rcashd[n].paid
        let q_rcashd[n].paid = 0
        let q_rcashd[n].disc_bal = q_rcashd[n].disc_bal +
                                   q_rcashd[n].disc_amt
        let q_rcashd[n].disc_amt = 0
        call pay_ar_line(n,1)
    end for
    let p_rcashe.on_acct_amt = p_rcashe.on_acct_amt + p_rcashe.oa_amt -
        p_rcashe.rcpt_amt + p_rcashe.paid_tot - p_rcashe.disc_tot
    let p_rcashe.oa_amt = p_rcashe.rcpt_amt - p_rcashe.paid_tot +
        p_rcashe.disc_tot
    let p_rcashe.bal_remaining = 0
    call sync_records()
    call llh_display()
    call lld_display()
end function
# automatic_pay

#######################################################################
function new_cust()
#######################################################################
# get a new customer's information and open items
#
    select bus_name, ar_acct_dflt, ar_department_dflt, on_acct_amt into
        p_rcashe.bus_name, oa_acct, oa_department,
        p_rcashe.on_acct_amt from strcustr
        where cust_code = p_rcashe.cust_code
    if sqlca.sqlcode = notfound
    then
        call fg_err(8) # Invalid customer code
        let sqlca.sqlcode = 0
        return false
    end if
    if not cust_lock(p_rcashe.cust_code)
    then
        call fg_err(11) # "Cannot lock customer record."
        return false
    end if
    call init_cust_header()
    call llh_display()
    call init_cust_detail(0)
    if sqlca.sqlcode = -1
    then
        call fg_err(9) # Too many invoices in stropend to read
        let sqlca.sqlcode = 0
        let int_flag = -1
        return false
    end if
    call lld_display()
    return true
end function
# new_cust()

#######################################################################
function init_cust_header()
#######################################################################
# sets up all the header amounts for a new or changed customer

    let m_rcashe.cust_code = p_rcashe.cust_code
    if p_rcashe.rcpt_amt is null
    then
        let p_rcashe.rcpt_amt = 0
    end if
    if p_rcashe.on_acct_amt is null
    then
        let p_rcashe.on_acct_amt = 0
    end if
    call calc_on_acct()
    let p_rcashe.disc_tot = 0
    let p_rcashe.paid_tot = 0
    let p_rcashe.oa_amt = 0
    let p_rcashe.bal_remaining = p_rcashe.rcpt_amt
    if oa_acct is null
    then
        let oa_acct = m_rcntrc.ar_acct_no
    end if
    if oa_department is null
    then
        let oa_department = "000"
    end if
end function
# init_cust_header

#######################################################################
function init_cust_detail(n)
#######################################################################
#   - this function reads all the customer's non-zero invoices into
#     the p_rcashd array
#   - it uses a cursor, but doesn't lock any rows.
#   - it reads into the m_* record, and moves each item to the p_* array
#
    define
        n           smallint,   # working number
        scratch_date date

    if n = 0
    then
        call mld_clear()
    end if

    let m_rcashd.dist_amt = 0
    let m_rcashd.disc_amt = 0

    whenever error continue
    declare e_cursor cursor for
        select doc_no, due_date from stropend where
            stropend.cust_code = p_rcashe.cust_code and
            stropend.balance != 0 and
            stropend.doc_no not in 
              (select inv_doc_no from strcashe, strcashd where
                 strcashe.cust_code = p_rcashe.cust_code and 
                 strcashe.doc_no = strcashd.doc_no)
            order by stropend.due_date, stropend.doc_no

    foreach e_cursor into m_rcashd.inv_doc_no, scratch_date
        let n = n + 1
        if n > rec1_max
        then
            let n = 0
            let sqlca.sqlcode = -1
            exit foreach
        end if
        call lld_p_prep(n)            # move data from m_* to p_[].*
    end foreach

    whenever error call error_handler
    let rec1_cnt = n
    return
end function
# init_cust_detail()

#######################################################################
function calc_on_acct()
# returning the calculated on account amount
#######################################################################
# this function calculates the actual on account amount by total
# all similar cash receipts's applied on account amount
#
    define
        db_oa_amt like strcustr.on_acct_amt,
        cr_oa_amt like strcustr.on_acct_amt

    if m_rcashe.doc_no is null then let m_rcashe.doc_no = 0 end if

    select sum(oa_amt) into db_oa_amt from strcashe where
        strcashe.cust_code = p_rcashe.cust_code and
        strcashe.doc_no != m_rcashe.doc_no and
        strcashe.oa_deb_cred = "DB"

    select sum(oa_amt) into cr_oa_amt from strcashe where
        strcashe.cust_code = p_rcashe.cust_code and
        strcashe.doc_no != m_rcashe.doc_no and
        strcashe.oa_deb_cred = "CR"

    if db_oa_amt is null then let db_oa_amt = 0 end if
    if cr_oa_amt is null then let cr_oa_amt = 0 end if

    let p_rcashe.on_acct_amt = p_rcashe.on_acct_amt - p_rcashe.oa_amt + 
                               db_oa_amt - cr_oa_amt
end function
# calc_on_acct
