########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_cashe.4gs/detail.4gl  1.11  Delta: 9/4/90
########################################################################

globals "globals.4gl"

#######################################################################
function lld_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#   - calls lld_input1 for screen1 and lld_input2 for screen2
#
    if curr_form = 1
    then
        return lld_input1()
    end if
    return lld_input2()
end function
# lld_input()

#######################################################################
function lld_input1()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#   - scrolling input array
#   - must call set_count before input array
#   1) auto pay.  take discount if within date.  pay all or whats left
#   2) take discount.  like 1 except discount always taken
#   3) no discount.  like 1 except discount never taken
#   4) manual.  ask discount and amount.
#
    define
        m integer, # screen array record number
        n integer, # array record number
        o integer, # array count (for delete)
        tab_flag smallint
    let tab_flag = false
    call set_count(rec1_cnt)    # this must be called before input array
    input array q_rcashd without defaults from s_rcashd.*
        on key (control-i)
            display "" at 2,3
            let tab_flag = true
            exit input
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(2)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxtranrCR",m_rcashe.doc_no,"-UNPOSTED","")
        before row
            let m = scr_line()
            let n = arr_curr()
        before delete
            let p_rcashe.disc_tot = p_rcashe.disc_tot - q_rcashd[n].disc_amt
            let p_rcashe.paid_tot = p_rcashe.paid_tot - q_rcashd[n].paid
            let p_rcashe.bal_remaining = p_rcashe.bal_remaining +
                q_rcashd[n].paid - q_rcashd[n].disc_amt
            display p_rcashe.disc_tot to s_rcashe.disc_tot
            display p_rcashe.paid_tot to s_rcashe.paid_tot
            display p_rcashe.bal_remaining to s_rcashe.bal_remaining
        after delete
            let o = arr_count() + 1
            initialize q_rcashd[o].* to null
            call p_delete(n,o)
            call r_delete(n,o)
        after insert
            let o = arr_count()
            call p_insert(n,o)
            call r_insert(n,o)
        after field pay_method
            if q_rcashd[n].pay_method matches "[iI]"
            then
                call ar_invcz(p_rcashd[n].inv_doc_no)
                let q_rcashd[n].pay_method = null
                display by name q_rcashd[n].pay_method
                next field pay_method
            end if
            if q_rcashd[n].pay_method < "1" or
               q_rcashd[n].pay_method > "4"
            then
                call fg_err(10) # Payment method must be between 1 and 4
                let q_rcashd[n].pay_method = null
                display by name q_rcashd[n].pay_method
                next field pay_method
            end if
            call pay_ar_line(n,q_rcashd[n].pay_method)
            let q_rcashd[n].pay_method = null
            display q_rcashd[n].pay_method, q_rcashd[n].disc_bal,
                    q_rcashd[n].balance, q_rcashd[n].disc_amt,
                    q_rcashd[n].paid, p_rcashe.paid_tot,
                    p_rcashe.disc_tot, p_rcashe.bal_remaining
                 to s_rcashd[m].pay_method, s_rcashd[m].disc_bal,
                    s_rcashd[m].balance, s_rcashd[m].disc_amt,
                    s_rcashd[m].paid, s_rcashe.paid_tot,
                    s_rcashe.disc_tot, s_rcashe.bal_remaining
    end input
    display p_rcashe.paid_tot, p_rcashe.disc_tot,
            p_rcashe.bal_remaining
         to s_rcashe.paid_tot, s_rcashe.disc_tot,
            s_rcashe.bal_remaining
    call sync_records()
    display ""
        at 2,2
    if tab_flag
    then
        return -1
    end if
    call cust_unlock()
    return 0
end function
# lld_input1()

#######################################################################
function lld_input2()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#   - scrolling input array
#   - must call set_count before input array
#
    define
        m integer, # screen array record number
        n integer, # array record number
        o integer, # array count (for delete)
        scratch char(10), # generic description
        old_paid like strcashd.dist_amt,
        old_acct like strcashd.dist_acct,
        old_department like strcashd.dist_department,
        tab_flag smallint
    let tab_flag = false

    call set_count(rec1_cnt)    # this must be called before input array
    input array r_rcashd without defaults from t_rcashd.*
        on key (control-i)
            let tab_flag = true
            exit input
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(4)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxtranrCR",m_rcashe.doc_no,"-UNPOSTED","")
        on key (control-z)
            case
                when infield(dist_acct)
                    let old_acct = r_rcashd[n].dist_acct
                    call al_chrtz() returning r_rcashd[n].dist_acct
                    if r_rcashd[n].dist_acct is null
                    then
                        let r_rcashd[n].dist_acct = old_acct
                    end if
                    display by name r_rcashd[n].dist_acct
                    next field dist_acct
                when infield(dist_department)
                    let old_department = r_rcashd[n].dist_department
                    call al_chrtz() returning r_rcashd[n].dist_department
                    if r_rcashd[n].dist_department is null
                    then
                        let r_rcashd[n].dist_department = old_department
                    end if
                    display by name r_rcashd[n].dist_department
                    next field dist_department
            end case
        before row
            let m = scr_line()
            let n = arr_curr()
        before delete
            let r_rcashe.paid_tot = r_rcashe.paid_tot - r_rcashd[n].paid
            let r_rcashe.bal_remaining = r_rcashe.bal_remaining +
                r_rcashd[n].paid
            display r_rcashe.paid_tot to t_rcashd.paid_tot
            display r_rcashe.bal_remaining to t_rcashe.bal_remaining
        after delete
            let o = arr_count() + 1
            initialize r_rcashd[o].* to null
            call p_delete(n,o)
            call q_delete(n,o)
        after insert
            let o = arr_count()
            call p_insert(n,o)
            call q_insert(n,o)
        after field dist_acct
            if r_rcashd[n].dist_acct is not null
            then
                call al_chrtn(r_rcashd[n].dist_acct) returning
                    r_rcashd[n].acct_desc, scratch
                let r_rcashd[n].dist_deb_cred = "CR"
                display r_rcashd[n].acct_desc, r_rcashd[n].dist_deb_cred
                     to t_rcashd[m].acct_desc, t_rcashd[m].dist_deb_cred
                if r_rcashd[n].acct_desc = "NOT FOUND"
                then
                    call fg_err(4) # Invalid account number
                    next field dist_acct
                end if
                if r_rcashd[n].paid < 0
                then
                    let r_rcashd[n].dist_deb_cred = "DB"
                    display  r_rcashd[n].dist_deb_cred to
                             t_rcashd[m].dist_deb_cred
                end if
            end if
            if r_rcashd[n].dist_acct is not null and
               r_rcashd[n].dist_department is null
            then
                next field dist_department
            end if
        after field dist_department
            if r_rcashd[n].dist_department is not null
            then
                call al_deptn(r_rcashd[n].dist_department) returning
                    scratch
                if scratch = "NOT FOUND"
                then
                    call fg_err(5) # Invalid department code
                    next field dist_department
                end if
            end if
            if r_rcashd[n].dist_acct is not null and
               r_rcashd[n].dist_department is null
            then
                let r_rcashd[n].dist_department = "000"
                display r_rcashd[n].dist_department to
                        t_rcashd[m].dist_department
            end if
        before field paid
            let old_paid = r_rcashd[n].paid
            if old_paid is null
            then
                let old_paid = 0
            end if
        after field paid
            let r_rcashd[n].paid = al_round( "a", r_rcashd[n].paid )
            if r_rcashd[n].paid is null
            then
                let r_rcashd[n].paid = 0
            end if
            let r_rcashd[n].dist_amt = r_rcashd[n].paid
            let r_rcashd[n].dist_deb_cred = "CR"
            if r_rcashd[n].paid < 0
            then
                let r_rcashd[n].dist_amt = 0 - r_rcashd[n].paid
                let r_rcashd[n].dist_deb_cred = "DB"
            end if
            let r_rcashe.paid_tot = r_rcashe.paid_tot -
                old_paid + r_rcashd[n].paid
            let r_rcashe.bal_remaining = r_rcashe.bal_remaining +
                old_paid - r_rcashd[n].paid
            display r_rcashd[n].dist_deb_cred,
                    r_rcashd[n].dist_amt,
                    r_rcashe.paid_tot,
                    r_rcashe.bal_remaining
                to  t_rcashd[m].dist_deb_cred,
                    t_rcashd[m].dist_amt,
                    t_rcashe.paid_tot,
                    t_rcashe.bal_remaining
            if r_rcashd[n].paid != 0 and r_rcashd[n].dist_acct is null
            then
                next field dist_acct
            end if
    end input
    call sync_records()
    if tab_flag
    then
        return -1
    end if
    return 0
end function
# lld_input2()

#######################################################################
function lld_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   - this function is called upon exiting the input statement.
#     the "after input" clause in the input statement can't call this
#     because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
        define
            prompt_response char(1)

        if curr_form = 2 and r_rcashe.bal_remaining != 0
        then
            while prompt_response matches "[^yYnN]" or
                  prompt_response is null
                prompt "There is a balance remaining.  ",
                       "Receipt amount will be adjusted.  Ok? (Y/N)"
                    for prompt_response
                if upshift(prompt_response) = "N"
                then
                    return false
                end if
            end while
        end if
    return true
end function
# lld_chkinput()

#######################################################################
function lld_display()
#######################################################################
#   - display the first array elements onto the screen
#
    define
        n   smallint    # working number
    for n = 1 to scr1_max
        if curr_form = 1
        then
            display q_rcashd[n].* to s_rcashd[n].*
        end if
        if curr_form = 2
        then
            display r_rcashd[n].* to t_rcashd[n].*
        end if
    end for
end function
# lld_display()

#######################################################################
function lld_p_prep(n)
#######################################################################
#   - this function creates the p_* record array (element n)
#     from the m_* record it then creates the r_* and q_* records
#
    define
        n   smallint,               # array element number
        deb_cred like strcashd.dist_deb_cred,
        scratch char(10)

    if m_rcashd.dist_amt is null
    then
        let m_rcashd.dist_amt = 0
    end if

    if m_rcashd.disc_amt is null
    then
        let m_rcashd.disc_amt = 0
    end if

    if m_rcashe.cust_code is not null
    then
        select * into m_ropend.* from stropend
            where stropend.doc_no = m_rcashd.inv_doc_no

        if sqlca.sqlcode = notfound
        then
            let m_ropend.disc_bal = 0
            let m_ropend.balance = 0
        end if

        let p_rcashd[n].inv_no = m_ropend.inv_no
        let p_rcashd[n].inv_doc_no = m_ropend.doc_no
        let p_rcashd[n].due_date = m_ropend.due_date
        let p_rcashd[n].disc_date = m_ropend.disc_date
        let p_rcashd[n].disc_bal = m_ropend.disc_bal - m_rcashd.disc_amt
        if m_rcashd.dist_deb_cred = "DB"
        then
            let p_rcashd[n].balance = m_ropend.balance + m_rcashd.dist_amt
        else
            let p_rcashd[n].balance = m_ropend.balance - m_rcashd.dist_amt
        end if
        let m_rcashd.dist_acct = m_ropend.ar_acct_no
        let m_rcashd.dist_department = m_ropend.ar_department
    else
        let p_rcashd[n].disc_bal = 0
        let p_rcashd[n].balance = 0
    end if
    let p_rcashd[n].pay_method = null
    let p_rcashd[n].dist_acct = m_rcashd.dist_acct
    if m_rcashd.dist_acct is not null
    then
        call al_chrtn(m_rcashd.dist_acct) returning
            p_rcashd[n].acct_desc, scratch
    end if
    let p_rcashd[n].dist_department = m_rcashd.dist_department
    let p_rcashd[n].dist_amt = m_rcashd.dist_amt
    let p_rcashd[n].paid = m_rcashd.dist_amt
    if m_rcashd.dist_deb_cred = "DB"
    then
        let p_rcashd[n].paid = 0 - m_rcashd.dist_amt
    end if
    let p_rcashd[n].dist_deb_cred = m_rcashd.dist_deb_cred
    let p_rcashd[n].disc_amt = m_rcashd.disc_amt
    if m_rcashd.disc_deb_cred = "CR"
    then
        let p_rcashd[n].disc_amt = 0 - m_rcashd.disc_amt
    end if
    let p_rcashe.disc_tot = p_rcashe.disc_tot + p_rcashd[n].disc_amt
    let p_rcashe.paid_tot = p_rcashe.paid_tot + p_rcashd[n].disc_amt

    call p_to_q_prep(n)
    call p_to_r_prep(n)

end function
# lld_p_prep()

#######################################################################
function lld_m_prep(n)
#######################################################################
#   - this function creates the m_* record from the
#     p_* record array (element n) and from the elements of the
#     header record that ties the header to the detail lines.
#
    define
        n   smallint,                # array element number
        scratch char(10)

    # items from the header...
    let m_rcashd.doc_no = m_rcashe.doc_no

    # items from the p_ record array...
    let m_rcashd.inv_doc_no = p_rcashd[n].inv_doc_no
    let m_rcashd.inv_no = p_rcashd[n].inv_no
    let m_rcashd.due_date = p_rcashd[n].due_date
    let m_rcashd.disc_amt = p_rcashd[n].disc_amt
    let m_rcashd.dist_acct = p_rcashd[n].dist_acct
    let m_rcashd.dist_department = p_rcashd[n].dist_department
    let m_rcashd.dist_amt = p_rcashd[n].dist_amt
    let m_rcashd.dist_deb_cred = p_rcashd[n].dist_deb_cred

    if curr_form = 1
    then
        let m_rcashd.disc_acct = m_rcntrc.cr_disc_acct_no
        let m_rcashd.disc_department = m_rcashd.dist_department
        let m_rcashd.disc_deb_cred = "DB"
        if m_rcashd.disc_amt < 0
        then
            let m_rcashd.disc_amt = m_rcashd.disc_amt * -1
            let m_rcashd.disc_deb_cred = "CR"
        end if
    else
    let m_rcashd.inv_doc_no = n
    end if

end function
# lld_m_prep()

#######################################################################
function lld_read()
#######################################################################
#   - this function reads in all of the array elements from disk
#   - it uses a cursor, but doesn't lock any rows.
#   - it reads into the m_* record, and calls p_prep for all array elements
#
    define
        n           smallint    # working number
    whenever error continue
    declare d_cursor cursor for
        select * from strcashd where
            strcashd.doc_no = m_rcashe.doc_no
            order by due_date, inv_doc_no
    let n = 0
    foreach d_cursor into m_rcashd.*
        let n = n + 1
        if n > rec1_max
        then
            error " Error: Too many rows in strcashd to read. "
            let n = 0
            let sqlca.sqlcode = -1
            exit foreach
            return
        end if
        call lld_p_prep(n)                # move data from m_* to p_[].*
    end foreach
    let rec1_cnt = n
    call set_count(rec1_cnt)
    return
end function
# lld_read()

#######################################################################
function lld_delete()
#######################################################################
#   - this function is for deleting all rows in the array
#
    delete from strcashd where
            strcashd.doc_no = m_rcashe.doc_no
end function
# lld_delete()

#######################################################################
function lld_add()
#######################################################################
#   - this function is for writing all rows in the array
#
    define
        n   smallint    # working number
    whenever error continue
    for n = 1 to rec1_cnt       # for all active array elements
        call lld_m_prep(n)
        if m_rcashd.dist_amt != 0 or
           m_rcashd.disc_amt != 0
        then
            insert into strcashd values(m_rcashd.*)
        end if
    end for
    whenever error call error_handler
    return
end function
# lld_add()

#######################################################################
function sync_records()
#######################################################################
#   - this function is for synchronizing window rows with the real guy
#   - this function creates the p_* record array from the q_* or r_*
#     record.  it also updates the opposite record
#
    define
        n   smallint               # array element number

    for n = 1 to rec1_max
        if curr_form = 1
        then
            call q_to_p_prep(n)
            call p_to_r_prep(n)
        else
            call r_to_p_prep(n)
            call p_to_q_prep(n)
        end if
    end for
end function
# sync_records()

#######################################################################
function q_to_p_prep(n)
#######################################################################
#
    define
        n   smallint               # array element number

    let p_rcashd[n].inv_no = q_rcashd[n].inv_no
    let p_rcashd[n].due_date = q_rcashd[n].due_date
    let p_rcashd[n].disc_date = q_rcashd[n].disc_date
    let p_rcashd[n].disc_bal = q_rcashd[n].disc_bal
    let p_rcashd[n].balance = q_rcashd[n].balance
    let p_rcashd[n].pay_method = q_rcashd[n].pay_method
    let p_rcashd[n].paid = q_rcashd[n].paid
    let p_rcashd[n].disc_amt = q_rcashd[n].disc_amt
    if q_rcashd[n].paid is not null
    then   
        let p_rcashd[n].dist_deb_cred = "CR"
        let p_rcashd[n].dist_amt = q_rcashd[n].paid
        if q_rcashd[n].paid < 0
        then
            let p_rcashd[n].dist_amt = 0 - q_rcashd[n].paid
            let p_rcashd[n].dist_deb_cred = "DB"
        end if
    else
        let p_rcashd[n].dist_deb_cred = null
        let p_rcashd[n].dist_amt = null
    end if
end function
# q_to_p_prep()

#######################################################################
function r_to_p_prep(n)
#######################################################################
#
    define
        n   smallint               # array element number

    if r_rcashd[n].dist_amt is not null
    then
        let p_rcashd[n].dist_acct = r_rcashd[n].dist_acct
        let p_rcashd[n].dist_department = r_rcashd[n].dist_department
        let p_rcashd[n].acct_desc = r_rcashd[n].acct_desc
        let p_rcashd[n].paid = r_rcashd[n].paid
        let p_rcashd[n].dist_amt = r_rcashd[n].dist_amt
        let p_rcashd[n].dist_deb_cred = r_rcashd[n].dist_deb_cred
    else
        let p_rcashd[n].dist_acct = null
        let p_rcashd[n].dist_department = null
        let p_rcashd[n].acct_desc = null
        let p_rcashd[n].paid = null
        let p_rcashd[n].dist_amt = null
        let p_rcashd[n].dist_deb_cred = null
    end if

end function
# r_to_p_prep(n)

#######################################################################
function p_to_q_prep(n)
# prepare q record from p record for a given n
#######################################################################
#
    define
        n smallint

    let q_rcashd[n].pay_method = p_rcashd[n].pay_method
    let q_rcashd[n].inv_no = p_rcashd[n].inv_no
    let q_rcashd[n].due_date = p_rcashd[n].due_date
    let q_rcashd[n].disc_date = p_rcashd[n].disc_date
    let q_rcashd[n].disc_bal = p_rcashd[n].disc_bal
    let q_rcashd[n].balance = p_rcashd[n].balance
    let q_rcashd[n].paid = p_rcashd[n].paid
    let q_rcashd[n].disc_amt = p_rcashd[n].disc_amt

end function
# p_to_q_prep()

#######################################################################
function p_to_r_prep(n)
# prepare r record from p record for a given n
#######################################################################
#
    define
        n smallint

    let r_rcashd[n].dist_acct = p_rcashd[n].dist_acct
    let r_rcashd[n].dist_department = p_rcashd[n].dist_department
    let r_rcashd[n].acct_desc = p_rcashd[n].acct_desc
    let r_rcashd[n].paid = p_rcashd[n].paid
    let r_rcashd[n].dist_amt = p_rcashd[n].dist_amt
    let r_rcashd[n].dist_deb_cred = p_rcashd[n].dist_deb_cred

end function
# p_to_r_prep()

#######################################################################
function p_delete(m,o)
# deletes p_* records from array
#######################################################################
#
    define
        m smallint,
        n smallint,
        o smallint

    for n = m to o - 1
        let p_rcashd[n].* = p_rcashd[n+1].*
    end for
    initialize p_rcashd[o].* to null

end function
# p_delete()

#######################################################################
function q_delete(m,o)
# deletes q_* records from array
#######################################################################
#
    define
        m smallint,
        n smallint,
        o smallint

    for n = m to o - 1
        let q_rcashd[n].* = q_rcashd[n+1].*
    end for
    initialize q_rcashd[o].* to null

end function
# q_delete()

#######################################################################
function r_delete(m,o)
# deletes r_* records from array
#######################################################################
#
    define
        m smallint,
        n smallint,
        o smallint

    for n = m to o - 1
        let r_rcashd[n].* = r_rcashd[n+1].*
    end for
    initialize r_rcashd[o].* to null

end function
# r_delete()

#######################################################################
function p_insert(m,o)
# inserts blank p_* records into array
#######################################################################
#
    define
        m smallint,
        n smallint,
        o smallint

    for n = m to o - 1
        let p_rcashd[n+1].* = p_rcashd[n].*
    end for
    initialize p_rcashd[m].* to null

end function
# p_insert()

#######################################################################
function q_insert(m,o)
# inserts blank q_* records into array
#######################################################################
#
    define
        m smallint,
        n smallint,
        o smallint

    for n = m to o - 1
        let q_rcashd[n+1].* = q_rcashd[n].*
    end for
    initialize q_rcashd[m].* to null

end function
# q_insert()

#######################################################################
function r_insert(m,o)
# inserts blank r_* records into array
#######################################################################
#
    define
        m smallint,
        n smallint,
        o smallint

    for n = m to o - 1
        let r_rcashd[n+1].* = r_rcashd[n].*
    end for
    initialize r_rcashd[m].* to null

end function
# r_insert()

#######################################################################
function pay_ar_line(n,pay_type)
#######################################################################
# pays an invoice line based on the pay type as follows:
#   1) auto pay.  take discount if within date.  pay all or whats left
#   2) take discount.  like 1 except discount always taken
#   3) no discount.  like 1 except discount never taken
#   4) manual.  ask discount and amount.
#
    define
        n smallint,
        pay_type char(1),
        old_pay_amt like strcashd.dist_amt,
        pay_amt like strcashd.dist_amt,
        old_discount like strcashd.disc_amt,
        discount like strcashd.disc_amt,
        prompt_response char(1)

    if q_rcashd[n].balance is null or pay_type is null or pay_type = " "
    then
        return
    end if
    let old_pay_amt = q_rcashd[n].paid - q_rcashd[n].disc_amt
    let q_rcashd[n].balance = q_rcashd[n].balance + q_rcashd[n].paid
    let q_rcashd[n].paid = 0
    let old_discount = q_rcashd[n].disc_amt
    let q_rcashd[n].disc_bal = q_rcashd[n].disc_bal +
                               q_rcashd[n].disc_amt
    let q_rcashd[n].disc_amt = 0
    let pay_amt = q_rcashd[n].balance
    let discount = 0
    let p_rcashe.bal_remaining = p_rcashe.bal_remaining + old_pay_amt
    let p_rcashe.disc_tot = p_rcashe.disc_tot - old_discount
    let p_rcashe.paid_tot = p_rcashe.paid_tot -
                            old_pay_amt - old_discount

    if (q_rcashd[n].disc_date >= p_rcashe.rcpt_date and
        pay_type = "1") or
        pay_type = "2"
    then
        let discount = q_rcashd[n].disc_bal
        let pay_amt = pay_amt - discount
    end if

    if pay_amt > p_rcashe.bal_remaining
    then
        let pay_amt = p_rcashe.bal_remaining
        if ((q_rcashd[n].disc_date >= p_rcashe.rcpt_date and
             pay_type = "1") or
             pay_type = "2") and
             discount != 0
        then
            let discount =  al_round( "a",
                pay_amt * discount / (q_rcashd[n].balance - discount) )
        end if
    end if

    if pay_type = "4"
    then

        while prompt_response is null
          prompt "Enter the amount of cash to apply: " for pay_amt
          if int_flag != 0
          then
              let int_flag = 0
              return
          end if

          if (p_rcashe.bal_remaining - pay_amt) < 0
          then
            open window end_setup at 14,16 with 8 rows, 51 columns
                attribute (border, blue)
            let prompt_response = null
            display "===================================================" at 3,1
            display " Warning: The total applied amount is greater      " at 4,1
            display " than the receipt amount.  If you wish to continue," at 5,1
            display " the surplus amount will be applied to the on      " at 6,1
            display " account amount.                                   " at 7,1
            display "===================================================" at 8,1
            while prompt_response matches "[^yYnN]" or
                  prompt_response is null
                prompt " Continue? " for char prompt_response
            end while
            close window end_setup
            if prompt_response = "N" or prompt_response = "n"
            then
                return
            end if
          end if

          if prompt_response is null
          then
              exit while
          end if

        end while

        prompt "Enter the amount of discount to apply: " for discount
        if int_flag != 0
        then
            let int_flag = 0
            return
        end if
        if pay_amt is null
        then
            let pay_amt = 0
        end if
        if discount is null
        then
            let discount = 0
        end if
    end if
    let p_rcashe.bal_remaining = p_rcashe.bal_remaining - pay_amt
    let p_rcashe.disc_tot = p_rcashe.disc_tot + discount
    let p_rcashe.paid_tot = p_rcashe.paid_tot + pay_amt + discount
    let q_rcashd[n].paid = q_rcashd[n].paid + pay_amt + discount
    let q_rcashd[n].disc_amt = q_rcashd[n].disc_amt + discount
    let q_rcashd[n].balance = q_rcashd[n].balance - pay_amt - discount
    let q_rcashd[n].disc_bal = q_rcashd[n].disc_bal - discount
end function
# pay_ar_line(n,pay_type)
