##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_cashe.4gs/header.4gl  1.7  Last Delta: 8/31/90
##############################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    define
        return_flag integer
    let return_flag = 0
    call llh_dflt_input()
    if curr_form = 1
    then
        call llh_input1() returning return_flag
    end if
    if curr_form = 2
    then
        call llh_input2() returning return_flag
    end if
    return return_flag
end function
# llh_input()

#######################################################################
function llh_input2()
# used to input from screen2, non a/r cash receipts
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    define
        old_rcpt_amt like strcashe.cash_amt,
        old_acct like strcashe.cash_acct,
        old_department like strcashe.cash_department

    if m_rcashe.doc_no is null then let m_rcashe.doc_no = al_uniq() end if

    input r_rcashe.* without defaults from t_rcashe.*
        on key (control-i)
            return -1
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(3)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxtranrCR",m_rcashe.doc_no,"-UNPOSTED","")
        on key (control-z)
            case
                when infield(cash_acct)
                    let old_acct = r_rcashe.cash_acct
                    call al_chrtz() returning r_rcashe.cash_acct
                    if r_rcashe.cash_acct is null
                    then
                        let r_rcashe.cash_acct = old_acct
                    end if
                    display by name r_rcashe.cash_acct
                    next field cash_acct
                when infield(cash_department)
                    let old_department = r_rcashe.cash_department
                    call al_deptz() returning r_rcashe.cash_department
                    if r_rcashe.cash_department is null
                    then
                        let r_rcashe.cash_department = old_department
                    end if
                    display by name r_rcashe.cash_department
                    next field cash_department
            end case
        after field rcpt_date
            if r_rcashe.rcpt_date is null
            then
                let r_rcashe.rcpt_date = today
                display by name r_rcashe.rcpt_date
            end if
        before field rcpt_amt
            let old_rcpt_amt = r_rcashe.rcpt_amt
            if r_rcashe.rcpt_amt is null
            then
                let old_rcpt_amt = 0
            end if
        after field rcpt_amt
            let r_rcashe.rcpt_amt = al_round( "a", r_rcashe.rcpt_amt )
            if r_rcashe.rcpt_amt is null
            then
                let r_rcashe.rcpt_amt = 0
            end if
            let r_rcashe.bal_remaining = r_rcashe.bal_remaining -
                old_rcpt_amt + r_rcashe.rcpt_amt
            display by name r_rcashe.rcpt_amt,
                r_rcashe.bal_remaining
        after field cash_acct
            if not chk_acct(r_rcashe.cash_acct)
            then
                next field cash_acct
            end if
        after field cash_department
            if not chk_department(r_rcashe.cash_department)
            then
                next field cash_department
            end if
    end input
    return 0
end function
# llh_input2()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#

    if curr_form = 1
    then
        if mustfill(p_rcashe.rcpt_date,"Receipt Date")
        then
            return false
        end if
        if mustfill(p_rcashe.cash_acct,"Cash Account Number")
        then
            return false
        end if
        if mustfill(p_rcashe.cash_department,"Cash Department Code")
        then
            return false
        end if
    end if
    if curr_form = 2
    then
        if mustfill(r_rcashe.cash_acct,"Cash Account Number")
        then
            return false
        end if
        if mustfill(r_rcashe.cash_department,"Cash Department Code")
        then
            return false
        end if
    end if
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    if curr_form = 1
    then
        display p_rcashe.* to s_rcashe.*
    else
        display r_rcashe.* to t_rcashe.*
    end if
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* and r-* record from the m_* record
#
    let p_rcashe.rcpt_date = m_rcashe.rcpt_date
    let p_rcashe.cust_code = m_rcashe.cust_code
    let p_rcashe.on_acct_amt = 0
    if p_rcashe.cust_code is not null
    then
        select bus_name, on_acct_amt into
            p_rcashe.bus_name, p_rcashe.on_acct_amt
            from strcustr
            where cust_code = p_rcashe.cust_code
        if sqlca.sqlcode = notfound
        then
            let sqlca.sqlcode = 0
            let p_rcashe.bus_name = "UNKNOWN CUSTOMER"
        end if
    end if
    let p_rcashe.check_no = m_rcashe.check_no
    let p_rcashe.doc_desc = m_rcashe.doc_desc
    let p_rcashe.rcpt_amt = m_rcashe.cash_amt
    if m_rcashe.cash_deb_cred = "CR"
    then
        let p_rcashe.rcpt_amt = 0 - m_rcashe.cash_amt
    end if
    let p_rcashe.oa_amt = m_rcashe.oa_amt
    if m_rcashe.oa_deb_cred = "DB"
    then
        let p_rcashe.oa_amt = 0 - m_rcashe.oa_amt
    end if
    let p_rcashe.cash_acct = m_rcashe.cash_acct
    let p_rcashe.cash_department = m_rcashe.cash_department
    let oa_acct = m_rcashe.oa_acct
    let oa_department = m_rcashe.oa_department
    # if other cash receipts with same customer code
    # then recalculate the p_rcashe.on_acct_amt variable
    if p_rcashe.cust_code is not null
    then
        if dup_cust() 
        then
            call calc_on_acct()
        end if
    end if
    let p_rcashe.paid_tot = p_rcashe.rcpt_amt - p_rcashe.oa_amt
    let p_rcashe.bal_remaining = 0
    let p_rcashe.disc_tot = 0
# prepare r-* for screen2
    let r_rcashe.rcpt_date = p_rcashe.rcpt_date
    let r_rcashe.check_no = p_rcashe.check_no
    let r_rcashe.doc_desc = p_rcashe.doc_desc
    let r_rcashe.rcpt_amt = p_rcashe.rcpt_amt
    let r_rcashe.cash_acct = p_rcashe.cash_acct
    let r_rcashe.cash_department = p_rcashe.cash_department
    let r_rcashe.bal_remaining = 0
    let r_rcashe.paid_tot = p_rcashe.rcpt_amt
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    if curr_form = 1
    then
        let p_rcashe.oa_amt = p_rcashe.oa_amt + p_rcashe.bal_remaining
        let p_rcashe.on_acct_amt = p_rcashe.on_acct_amt - p_rcashe.bal_remaining
        let p_rcashe.bal_remaining = 0
        let r_rcashe.rcpt_date = p_rcashe.rcpt_date
        let r_rcashe.check_no = p_rcashe.check_no
        let r_rcashe.doc_desc = p_rcashe.doc_desc
        let r_rcashe.rcpt_amt = p_rcashe.rcpt_amt
        let r_rcashe.cash_acct = p_rcashe.cash_acct
        let r_rcashe.cash_department = p_rcashe.cash_department
        let r_rcashe.paid_tot = p_rcashe.paid_tot
        let r_rcashe.bal_remaining = p_rcashe.bal_remaining
    else
        let r_rcashe.rcpt_amt = r_rcashe.rcpt_amt -
                                r_rcashe.bal_remaining
        let r_rcashe.bal_remaining = 0
        let p_rcashe.rcpt_date = r_rcashe.rcpt_date
        let p_rcashe.check_no = r_rcashe.check_no
        let p_rcashe.doc_desc = r_rcashe.doc_desc
        let p_rcashe.rcpt_amt = r_rcashe.rcpt_amt
        let p_rcashe.cash_acct = r_rcashe.cash_acct
        let p_rcashe.cash_department = r_rcashe.cash_department
        let p_rcashe.paid_tot = r_rcashe.paid_tot
        let p_rcashe.disc_tot = 0
        let p_rcashe.bal_remaining = r_rcashe.bal_remaining
    end if
    let m_rcashe.rcpt_date = p_rcashe.rcpt_date
    let m_rcashe.cust_code = p_rcashe.cust_code
    let m_rcashe.check_no = p_rcashe.check_no
    let m_rcashe.doc_desc = p_rcashe.doc_desc
    let m_rcashe.cash_amt = p_rcashe.rcpt_amt
    let m_rcashe.cash_deb_cred = "DB"
    if p_rcashe.rcpt_amt < 0
    then
        let m_rcashe.cash_amt = 0 - p_rcashe.rcpt_amt
        let m_rcashe.cash_deb_cred = "CR"
    end if
    let m_rcashe.cash_acct = p_rcashe.cash_acct
    let m_rcashe.cash_department = p_rcashe.cash_department
    let m_rcashe.oa_amt = p_rcashe.oa_amt
    let m_rcashe.oa_deb_cred = "CR"
    if p_rcashe.oa_amt < 0
    then
        let m_rcashe.oa_amt = 0 - p_rcashe.oa_amt
        let m_rcashe.oa_deb_cred = "DB"
    end if
    let m_rcashe.oa_acct = oa_acct
    let m_rcashe.oa_department = oa_department
    let m_rcashe.ok_to_post = "N"
    call llh_display()
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_rcashe.* from strcashe where rowid = ring_rowid
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        return
    end if
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer,     # rowid passed
        scratch char(20)
    delete from strcashe where rowid = ring_rowid
    if sqlca.sqlcode = 0
    then
        # delete user defined fields
        let scratch = m_rcashe.doc_no using "<<<<<<<<<<", "-UNPOSTED"
        call al_addld("stxtranrCR",scratch)
    end if
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    let m_rcashe.doc_no = 0
    insert into strcashe values(m_rcashe.*)
    whenever error call error_handler
    let m_rcashe.doc_no = sqlca.sqlerrd[2]
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update strcashe set strcashe.* = m_rcashe.*
        where rowid = ring_rowid
end function
# llh_update()

#######################################################################
function chk_acct(acct_no)
#######################################################################
#
    define
        acct_no like stxchrtr.acct_no,
        scratch char(1),
        description char(30)

    if acct_no is null
    then
        return true
    end if
    call al_chrtn(acct_no) returning description, scratch
    if description = "NOT FOUND"
    then
        call fg_err(4) # Invalid account number
        return false
    end if
    return true
end function
# chk_acct(acct_no)

#######################################################################
function chk_department(department)
#######################################################################
#
    define
        department like strcashe.cash_department,
        scratch char(1),
        description char(30)

    if department is null
    then
        return true
    end if
    call al_deptn(department) returning description
    if description = "NOT FOUND"
    then
        call fg_err(5) # Invalid department
        return false
    end if
    return true
end function
# chk_department(department)

#######################################################################
function llh_dflt_input()
#######################################################################
# sets defaults for any header fields that are not set
#
    if p_rcashe.rcpt_date is null
    then
        let p_rcashe.rcpt_date = today
        let r_rcashe.rcpt_date = today
    end if
    if p_rcashe.rcpt_amt is null
    then
        let p_rcashe.rcpt_amt = 0
        let r_rcashe.rcpt_amt = 0
    end if
    if p_rcashe.on_acct_amt is null
    then
        let p_rcashe.on_acct_amt = 0
    end if
    if p_rcashe.oa_amt is null
    then
        let p_rcashe.oa_amt = 0
    end if
    if p_rcashe.cash_acct is null
    then
        let p_rcashe.cash_acct = m_rcntrc.cr_cash_acct_no
        let r_rcashe.cash_acct = m_rcntrc.cr_cash_acct_no
    end if
    if p_rcashe.cash_department is null
    then
        let p_rcashe.cash_department = "000"
        let r_rcashe.cash_department = "000"
    end if
    if p_rcashe.rcpt_amt is null
    then
        let p_rcashe.rcpt_amt = 0
        let r_rcashe.rcpt_amt = 0
    end if
    if p_rcashe.disc_tot is null
    then
        let p_rcashe.disc_tot = 0
    end if
    if p_rcashe.paid_tot is null
    then
        let p_rcashe.paid_tot = 0
        let r_rcashe.paid_tot = 0
    end if
    if p_rcashe.bal_remaining is null
    then
        let p_rcashe.bal_remaining = 0
        let r_rcashe.bal_remaining = 0
    end if
    let p_rcashe.auto_pay = " "
    call llh_display()

end function
# llh_dflt_input()
