########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_contrl.4gs/header.4gl  1.8  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    define
        in_zoom smallint,
        which_field smallint,
        due_days like strtermr.due_days,
        disc_days like strtermr.disc_days,
        disc_pct like strtermr.disc_pct,
        old_terms_code like strcntrc.terms_code,
        old_acct like strcntrc.ar_acct_no,
        old_ar_balanced like strcntrc.ar_balanced

    let in_zoom = false
    input p_rcntrc.* without defaults from s_rcntrc.*
      on key (control-e)
        call fg_err(0)
      on key (control-w)
        call fg_help(1)
      on key (control-f)
        # add/update user defined fields...
        call al_addlz("strcntrc","1","","")
      on key (control-z)
        case
          when infield(terms_code)
            let in_zoom = true
            let old_terms_code = p_rcntrc.terms_code
            call ar_termz() returning p_rcntrc.terms_code
            if p_rcntrc.terms_code is null
              then let p_rcntrc.terms_code = old_terms_code end if
            display by name p_rcntrc.terms_code
            next field terms_code
          when infield(ar_acct_no)
            let old_acct = p_rcntrc.ar_acct_no
            call al_chrtz() returning p_rcntrc.ar_acct_no
            if p_rcntrc.ar_acct_no is null
              then let p_rcntrc.ar_acct_no = old_acct end if
            display by name p_rcntrc.ar_acct_no
            next field ar_acct_no
          when infield(ar_sales_acct_no)
            let old_acct = p_rcntrc.ar_sales_acct_no
            call al_chrtz() returning p_rcntrc.ar_sales_acct_no
            if p_rcntrc.ar_sales_acct_no is null
              then let p_rcntrc.ar_sales_acct_no = old_acct end if
            display by name p_rcntrc.ar_sales_acct_no
            next field ar_sales_acct_no
          when infield(ar_tax_acct_no)
            let old_acct = p_rcntrc.ar_tax_acct_no
            call al_chrtz() returning p_rcntrc.ar_tax_acct_no
            if p_rcntrc.ar_tax_acct_no is null
              then let p_rcntrc.ar_tax_acct_no = old_acct end if
            display by name p_rcntrc.ar_tax_acct_no
            next field ar_tax_acct_no
          when infield(ar_fc_acct_no)
            let old_acct = p_rcntrc.ar_fc_acct_no
            call al_chrtz() returning p_rcntrc.ar_fc_acct_no
            if p_rcntrc.ar_fc_acct_no is null
              then let p_rcntrc.ar_fc_acct_no = old_acct end if
            display by name p_rcntrc.ar_fc_acct_no
            next field ar_fc_acct_no
          when infield(ar_frght_acct_no)
            let old_acct = p_rcntrc.ar_frght_acct_no
            call al_chrtz() returning p_rcntrc.ar_frght_acct_no
            if p_rcntrc.ar_frght_acct_no is null
              then let p_rcntrc.ar_frght_acct_no = old_acct end if
            display by name p_rcntrc.ar_frght_acct_no
            next field ar_frght_acct_no
          when infield(ar_misc_acct_no)
            let old_acct = p_rcntrc.ar_misc_acct_no
            call al_chrtz() returning p_rcntrc.ar_misc_acct_no
            if p_rcntrc.ar_misc_acct_no is null
              then let p_rcntrc.ar_misc_acct_no = old_acct end if
            display by name p_rcntrc.ar_misc_acct_no
            next field ar_misc_acct_no
          when infield(cr_cash_acct_no)
            let old_acct = p_rcntrc.cr_cash_acct_no
            call al_chrtz() returning p_rcntrc.cr_cash_acct_no
            if p_rcntrc.cr_cash_acct_no is null
              then let p_rcntrc.cr_cash_acct_no = old_acct end if
            display by name p_rcntrc.cr_cash_acct_no
            next field cr_cash_acct_no
          when infield(cr_disc_acct_no)
            let old_acct = p_rcntrc.cr_disc_acct_no
            call al_chrtz() returning p_rcntrc.cr_disc_acct_no
            if p_rcntrc.cr_disc_acct_no is null
              then let p_rcntrc.cr_disc_acct_no = old_acct end if
            display by name p_rcntrc.cr_disc_acct_no
            next field cr_disc_acct_no
        end case

      before field terms_code
        if in_zoom
        then
            let in_zoom = false
        else
            let old_terms_code = p_rcntrc.terms_code
        end if

      after field terms_code
        if p_rcntrc.terms_code is not null
        then
            if p_rcntrc.terms_code = old_terms_code
            then else
                call ar_termn(p_rcntrc.terms_code) returning
                    p_rcntrc.terms_desc, due_days, disc_days, disc_pct
                display by name p_rcntrc.terms_desc
                if p_rcntrc.terms_desc = "NOT FOUND"
                then
                    call fg_err(33) # Warning: terms code not found
                    next field terms_code
                end if
            end if
        else 
            let p_rcntrc.terms_desc = null
        end if
        display by name p_rcntrc.terms_desc
        
      before field ar_balanced
        if not age_per_in_seq() then next field age_per3 end if
        let old_ar_balanced = p_rcntrc.ar_balanced
      after field ar_balanced
        if p_rcntrc.ar_balanced is null or
          (p_rcntrc.ar_balanced != "Y" and
           p_rcntrc.ar_balanced != "N")
        then
           call fg_err(2) # A/R setup complete must be a "Y" or "N"
           let p_rcntrc.ar_balanced = old_ar_balanced
           display by name p_rcntrc.ar_balanced
           next field ar_balanced
        end if
        if old_ar_balanced is null then let old_ar_balanced = "N" end if
        if p_rcntrc.ar_balanced = "Y" and old_ar_balanced = "N"
          then call close_setup() end if
        if p_rcntrc.ar_balanced = "N" and old_ar_balanced = "Y"
          then call open_setup() end if

      after field age_datetype
        if p_rcntrc.age_datetype is null
        then
            let p_rcntrc.age_datetype = "D"
            display by name p_rcntrc.age_datetype
        end if
        if p_rcntrc.age_datetype != "D" and p_rcntrc.age_datetype != "I"
        then
            call fg_err(3) # Finance on type must be a "D" or "I"
            let p_rcntrc.age_datetype = null
            display by name p_rcntrc.age_datetype
            next field age_datetype
        end if

      after field ar_acct_no
        if p_rcntrc.ar_acct_no is not null
        then
            if chkacct(p_rcntrc.ar_acct_no)
            then
                if p_rcntrc.ar_acct_no < m_xcntrc.curr_asset or
                    p_rcntrc.ar_acct_no >= m_xcntrc.fixed_asset
                then
                    # AR account must be within asset range
                    call fg_err(4) 
                    next field ar_acct_no
                end if
            else
                next field ar_acct_no
            end if
        end if

      after field ar_sales_acct_no
        if p_rcntrc.ar_acct_no is not null
        then
            if chkacct(p_rcntrc.ar_acct_no)
            then
                if p_rcntrc.ar_sales_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_sales_acct_no >= m_xcntrc.cost_goods
                then
                    # sales account must be within income range
                    call fg_err(5) 
                    next field ar_sales_acct_no
                end if 
            else 
                next field ar_sales_acct_no
            end if
        end if

      after field ar_tax_acct_no
        if p_rcntrc.ar_tax_acct_no is not null
        then
            if chkacct(p_rcntrc.ar_tax_acct_no)
            then
                if p_rcntrc.ar_tax_acct_no < m_xcntrc.curr_liab or
                    p_rcntrc.ar_tax_acct_no >= m_xcntrc.long_term_liab
                then
                    call fg_err(6) # tax account must be within current liability range
                    next field ar_tax_acct_no
                end if
            else
                next field ar_tax_acct_no
            end if
        end if

      after field ar_fc_acct_no
        if p_rcntrc.ar_fc_acct_no is not null
        then
            if chkacct(p_rcntrc.ar_fc_acct_no)
            then
                if p_rcntrc.ar_fc_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_fc_acct_no >= m_xcntrc.cost_goods
                then
                    call fg_err(7) # finance charge account must be within income range
                    next field ar_fc_acct_no
                end if
            else
                next field ar_fc_acct_no
            end if
        end if

      after field ar_frght_acct_no
        if p_rcntrc.ar_frght_acct_no is not null
        then
            if chkacct(p_rcntrc.ar_frght_acct_no)
            then
                if p_rcntrc.ar_frght_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_frght_acct_no >= m_xcntrc.cost_goods
                then
                    call fg_err(8) # freight account must be with income range
                    next field ar_frght_acct_no
                end if
            else
                next field ar_frght_acct_no
            end if
        end if

      after field ar_misc_acct_no
        if p_rcntrc.ar_misc_acct_no is not null
        then
            if chkacct(p_rcntrc.ar_misc_acct_no)
            then
                if p_rcntrc.ar_misc_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_misc_acct_no >= m_xcntrc.cost_goods
                then
                    call fg_err(9) # misc. AR account must be within income range
                    next field ar_misc_acct_no
                end if
            else
                next field ar_misc_acct_no
            end if
        end if

      after field cr_cash_acct_no
        if p_rcntrc.cr_cash_acct_no is not null
        then
            if chkacct(p_rcntrc.cr_cash_acct_no)
            then
                if p_rcntrc.cr_cash_acct_no < m_xcntrc.curr_asset or
                    p_rcntrc.cr_cash_acct_no >= m_xcntrc.fixed_asset
                then
                    call fg_err(10) # cash account must be within current assets range
                    next field cr_cash_acct_no
                end if
            else
                next field cr_cash_acct_no
            end if
        end if

      after field cr_disc_acct_no
        if p_rcntrc.cr_disc_acct_no is not null
        then
            if chkacct(p_rcntrc.cr_disc_acct_no)
            then
                if p_rcntrc.cr_disc_acct_no < m_xcntrc.income or
                    p_rcntrc.cr_disc_acct_no >= m_xcntrc.cost_goods
                then
                    call fg_err(11) # discount account must be within income range
                    next field cr_disc_acct_no
                end if
            else
                next field cr_disc_acct_no
            end if
        end if

      before field age_dsc4
        if not age_per_in_seq() then next field age_per1 end if

    end input
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
     if mustfill(p_rcntrc.tax_pct,"Default Tax Rate") or
        mustfill(p_rcntrc.terms_code,"Terms Code") or
        mustfill(p_rcntrc.ar_acct_no,"A/R Account Number") or
        mustfill(p_rcntrc.ar_sales_acct_no,"Sales Account Number") or
        mustfill(p_rcntrc.ar_tax_acct_no,"Tax Account Number") or
        mustfill(p_rcntrc.ar_fc_acct_no,"Finance Charge Account Number") or
        mustfill(p_rcntrc.ar_frght_acct_no,"Freight Account Number") or
        mustfill(p_rcntrc.ar_misc_acct_no,"Misc. Account Number") or
        mustfill(p_rcntrc.cr_cash_acct_no,"Cash Account Number") or
        mustfill(p_rcntrc.cr_disc_acct_no,"Discount Account Number") or
        not age_per_in_seq()
     then
         return false
     end if

    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    display p_rcntrc.* to s_rcntrc.*
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    define
        due_days like strtermr.due_days,
        disc_days like strtermr.disc_days,
        disc_pct like strtermr.disc_pct

    let p_rcntrc.tax_pct = m_rcntrc.tax_pct
    let p_rcntrc.terms_code = m_rcntrc.terms_code
    call ar_termn(p_rcntrc.terms_code) returning
        p_rcntrc.terms_desc, due_days, disc_days, disc_pct
    let p_rcntrc.disc_misc = m_rcntrc.disc_misc
    let p_rcntrc.disc_frght = m_rcntrc.disc_frght
    let p_rcntrc.disc_tax = m_rcntrc.disc_tax
    let p_rcntrc.ar_acct_no = m_rcntrc.ar_acct_no
    let p_rcntrc.ar_sales_acct_no = m_rcntrc.ar_sales_acct_no
    let p_rcntrc.ar_tax_acct_no = m_rcntrc.ar_tax_acct_no
    let p_rcntrc.ar_fc_acct_no = m_rcntrc.ar_fc_acct_no
    let p_rcntrc.ar_frght_acct_no = m_rcntrc.ar_frght_acct_no
    let p_rcntrc.ar_misc_acct_no = m_rcntrc.ar_misc_acct_no
    let p_rcntrc.cr_cash_acct_no = m_rcntrc.cr_cash_acct_no
    let p_rcntrc.cr_disc_acct_no = m_rcntrc.cr_disc_acct_no
    let p_rcntrc.age_datetype = m_rcntrc.age_datetype
    let p_rcntrc.age_per1 = m_rcntrc.age_per1
    let p_rcntrc.age_per2 = m_rcntrc.age_per2
    let p_rcntrc.age_per3 = m_rcntrc.age_per3
    let p_rcntrc.age_dsc1 = m_rcntrc.age_dsc1
    let p_rcntrc.age_dsc2 = m_rcntrc.age_dsc2
    let p_rcntrc.age_dsc3 = m_rcntrc.age_dsc3
    let p_rcntrc.age_dsc4 = m_rcntrc.age_dsc4
    let p_rcntrc.ar_balanced = m_rcntrc.ar_balanced
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    let m_rcntrc.tax_pct = p_rcntrc.tax_pct
    let m_rcntrc.terms_code = p_rcntrc.terms_code
    let m_rcntrc.disc_misc = p_rcntrc.disc_misc
    let m_rcntrc.disc_frght = p_rcntrc.disc_frght
    let m_rcntrc.disc_tax = p_rcntrc.disc_tax
    let m_rcntrc.ar_acct_no = p_rcntrc.ar_acct_no
    let m_rcntrc.ar_sales_acct_no = p_rcntrc.ar_sales_acct_no
    let m_rcntrc.ar_tax_acct_no = p_rcntrc.ar_tax_acct_no
    let m_rcntrc.ar_fc_acct_no = p_rcntrc.ar_fc_acct_no
    let m_rcntrc.ar_frght_acct_no = p_rcntrc.ar_frght_acct_no
    let m_rcntrc.ar_misc_acct_no = p_rcntrc.ar_misc_acct_no
    let m_rcntrc.cr_cash_acct_no = p_rcntrc.cr_cash_acct_no
    let m_rcntrc.cr_disc_acct_no = p_rcntrc.cr_disc_acct_no
    if m_rcntrc.ar_doc_no is null then let m_rcntrc.ar_doc_no = 1 end if
    if m_rcntrc.ar_post_no is null
      then let m_rcntrc.ar_post_no = 1 end if
    if m_rcntrc.cr_doc_no is null then let m_rcntrc.cr_doc_no = 1 end if
    if m_rcntrc.cr_post_no is null
      then let m_rcntrc.cr_post_no = 1 end if
    let m_rcntrc.age_datetype = p_rcntrc.age_datetype
    let m_rcntrc.age_per1 = p_rcntrc.age_per1
    let m_rcntrc.age_per2 = p_rcntrc.age_per2
    let m_rcntrc.age_per3 = p_rcntrc.age_per3
    let m_rcntrc.age_dsc1 = p_rcntrc.age_dsc1
    let m_rcntrc.age_dsc2 = p_rcntrc.age_dsc2
    let m_rcntrc.age_dsc3 = p_rcntrc.age_dsc3
    let m_rcntrc.age_dsc4 = p_rcntrc.age_dsc4
    if p_rcntrc.ar_balanced is null
    then
        let p_rcntrc.ar_balanced = "N"
        display by name p_rcntrc.ar_balanced
    end if
    let m_rcntrc.ar_balanced = p_rcntrc.ar_balanced
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_rcntrc.* from strcntrc where rowid = ring_rowid
    whenever error call error_handler
    if sqlca.sqlcode != 0 then return end if
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from strcntrc where rowid = ring_rowid
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    insert into strcntrc values(m_rcntrc.*)
    whenever error call error_handler
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update strcntrc set strcntrc.* = m_rcntrc.* where rowid = ring_rowid
end function
# llh_update()

#######################################################################
function chkacct(acct_no)
# returns true if account number is invalid
#######################################################################
#
    define
        acct_no like stxchrtr.acct_no,
        scratch char(10),
        description like stxchrtr.acct_desc

    call al_chrtn(acct_no) returning description, scratch

    if description = "NOT FOUND"
    then
        call fg_err(1) #Account No. not valid
        return false
    end if
    return true

end function
# chkacct(acct_no)

#######################################################################
function age_per_in_seq()
# returns true if the aging period days are non-null and sequential
#######################################################################
#

    if p_rcntrc.age_per1 is null or
       p_rcntrc.age_per2 is null or
       p_rcntrc.age_per3 is null or
       p_rcntrc.age_per1 < 0 or
       p_rcntrc.age_per2 <= p_rcntrc.age_per1 or
       p_rcntrc.age_per3 <= p_rcntrc.age_per1 or
       p_rcntrc.age_per3 <= p_rcntrc.age_per2
     then
         call fg_err(34) # Aging periods must be ascending sequence
         return false
     end if
    return true
end function
# age_per_in_seq()

