##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_contrl.4gs/midlevel.4gl  1.2  Last Delta: 1/4/89
##############################################################################

globals "globals.4gl"

#######################################################################
# "ok" functions:
#  - the following "ok" functions can be placed here:
#    ok_add(), ok_update(), ok_delete(), ok_find(), ok_browse(), ok_next(),
#    ok_prev(), ok_tab(), ok_options(), ok_exit(), and ok_bang().
#  - their purpose is to allow/disallow that function from the ring menu.
#  - if their return value is true, then the function is allowed, and
#    if it is false, then the function is not allowed.
#  - following is an example of a smart delete function:
#
#    ##################################################################
#    function ok_delete()
#    # returning true or false based upon ok to delete
#    ##################################################################
#    #
#        if posted = "Y"
#        then
#            error " Cannot delete a posted record "
#            return false
#        end if
#        return true
#    end function
#    # ok_delete()
#
#######################################################################

##################################################################
function ok_browse()
# returning true or false based upon ok to delete
##################################################################
#
call fg_err(32) #This function has been disabled 
return false
end function
# ok_browse

##################################################################
function ok_delete()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_delete

##################################################################
function ok_add()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_add

##################################################################
function ok_find()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_find

##################################################################
function ok_next()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_next

##################################################################
function ok_prev()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_prev


#######################################################################
function mlh_init()
# returning the where clause string
#######################################################################
#  - this functions only purpose is to return a string that will be used
#    for the where clause in the initial document grouping that takes
#    place when the program is loaded.
#  - examples:
#   return "1=1" (select all rows)
#   return "1=2" (select no rows)
#   return "posted = 0" (select only unposted documents)
#   return "rowid = 1" (select only the first row - for control files)
#
    return "1=1"
end function
# mlh_init()

#######################################################################
function mlh_validate()
#######################################################################
#   mid level data validation.  this function is called before any
#   disk writes.  if informix tries to write invalid data, part of the row
#   will be written, and part of it won't.  sql bomb's out.  the data
#   should have been checked in ll_input(), but us programmers can't
#   be perfect all of the time.  instead of data being compromised, the
#   end user doesn't get to write that screen.  it ticks them off, but
#   at least they don't have partial records on disk.
#
    whenever error continue
    call llh_m_prep()
    validate m_rcntrc.* like strcntrc.*
    whenever error call error_handler
end function
# mlh_validate()

#######################################################################
function mlh_clear()
#######################################################################
#
    initialize p_rcntrc.* to null
    initialize m_rcntrc.* to null
end function
# mlh_clear

#######################################################################
function mlh_construct()
# returning criteria
#######################################################################
#
    define
        criteria    char(256)   # selection criteria holding bin
    # construct the search criteria from the screen
    construct criteria
        on
            strcntrc.tax_pct,
            strcntrc.disc_misc,
            strcntrc.disc_frght,
            strcntrc.disc_tax,
            strcntrc.ar_acct_no,
            strcntrc.ar_sales_acct_no,
            strcntrc.ar_tax_acct_no,
            strcntrc.ar_frght_acct_no,
            strcntrc.ar_misc_acct_no,
            strcntrc.cr_cash_acct_no,
            strcntrc.cr_disc_acct_no,
            strcntrc.age_per1,
            strcntrc.age_per2,
            strcntrc.age_per3,
            strcntrc.age_per4,
            strcntrc.age_dsc1,
            strcntrc.age_dsc2,
            strcntrc.age_dsc3,
            strcntrc.age_dsc4,
            strcntrc.ar_balanced
        from
            s_rcntrc.tax_pct,
            s_rcntrc.disc_misc,
            s_rcntrc.disc_frght,
            s_rcntrc.disc_tax,
            s_rcntrc.ar_acct_no,
            s_rcntrc.ar_sales_acct_no,
            s_rcntrc.ar_tax_acct_no,
            s_rcntrc.ar_frght_acct_no,
            s_rcntrc.ar_misc_acct_no,
            s_rcntrc.cr_cash_acct_no,
            s_rcntrc.cr_disc_acct_no,
            s_rcntrc.age_per1,
            s_rcntrc.age_per2,
            s_rcntrc.age_per3,
            s_rcntrc.age_per4,
            s_rcntrc.age_dsc1,
            s_rcntrc.age_dsc2,
            s_rcntrc.age_dsc3,
            s_rcntrc.age_dsc4,
            s_rcntrc.ar_balanced
    return criteria
end function
# mlh_construct

#######################################################################
function mlh_define_cur(criteria)
#######################################################################
#
    define
        criteria    char(256),  # selection criteria holding bin
        find_specs  char(512),  # select sql specification
        curs_count  integer     # number of elements in the cursor
    # get the count into curs_count
    let find_specs =
        "select count(*) from strcntrc where ",
        criteria clipped
    prepare get_count from find_specs
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into curs_count
    close count_cursor
    # define the cursor
    let find_specs =
        "select rowid",
        " from strcntrc where ",criteria clipped,
        ""
    prepare get_stmt from find_specs
    declare ref_cursor scroll cursor for get_stmt
    open ref_cursor
    let sqlca.sqlerrd[3] = curs_count
    return
end function
#mlh_define_cur()


#######################################################################
function mlh_fetch_cur(curno)
# returning rowid in sqlca.sqlerrd[6]
#######################################################################
#
    define
        curno       integer,    # absolute cursor number
        curs_rowid integer
    fetch absolute curno ref_cursor into
            curs_rowid
    let sqlca.sqlerrd[6] = curs_rowid
    return
end function
# mlh_fetch_cur()

#######################################################################
function mlh_close_cur()
#######################################################################
#
    close ref_cursor
end function
# mlh_close_cur()

#######################################################################
function mlh_lock(ring_rowid)
#######################################################################
#   - this function opens a cursor for update selecting just the
#     record defined by rowid.
#   - because it fetches the record with an update cursor, the record
#     is locked.
#   - it's only meaning in life is to lock the record. not read it.
#
    define
        ring_rowid  integer,    # rowid of record to read
        getid       integer     # something to fetch into
    begin work
    whenever error continue
    declare lock_cursor cursor for
        select rowid into getid from strcntrc where rowid = ring_rowid
        for update
    open lock_cursor
    fetch lock_cursor
    whenever error call error_handler
    return
end function
# mlh_lock()

#######################################################################
function mlh_unlock()
#######################################################################
#
    close lock_cursor
    if not nastiness_occurred
    then
        commit work
    end if
end function
# mlh_unlock()

