########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_contrl.4gs/opnsetup.4gl  1.5  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#######################################################################
function open_setup()
# deletes all a/r transactions from stxtranr, strtranr and stractvd
#######################################################################
# this is dangerous.  if any posting is done to a/r from any journal,
# then the stxtranr record is deleted.  this will leave orphans from
# stgtranr and stgactvd and any other module transaction/activity files
# that were affected.  this is only here so the setup complete flag can
# be reset if it was set to "Y" accidentally.
#
    define
        prompt_response char(1)        # single char Y/N response

    open window opn_setup at 14,16 with 9 rows, 51 columns
        attribute (border, blue, prompt line last)
    display "===================================================" at 2,1
    display " You have indicated that accounts receivable setup " at 3,1
    display " is no longer complete.  If you wish to continue,  " at 4,1
    display " all A/R transactions will be deleted.  The open   " at 5,1
    display " items will remain.  This is generally not a good  " at 6,1
    display " idea if any A/R posting has been done.            " at 7,1
    display "===================================================" at 8,1
    let prompt_response = null
    while prompt_response matches "[^yYnN]" or
          prompt_response is null
        prompt " Continue? " for prompt_response
    end while
    if upshift(prompt_response) = "N"
    then
        close window opn_setup
        let p_rcntrc.ar_balanced = "Y"
        display by name p_rcntrc.ar_balanced
        return
    end if

    display " Deleting A/R transactions ... please wait.        " at 1,1
    whenever error continue
    let nastiness_occurred = false
    lock table stxtranr in share mode   # lock tables for mass delete
    if sqlca.sqlcode != 0
    then
        let nastiness_occurred = true
        call fg_err(29) # Could not lock stxtranr to open setup
    end if
    if not nastiness_occurred
    then
        lock table strtranr in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(30) # Could not lock strtranr to open setup
        end if
    end if
    if not nastiness_occurred
    then
        lock table stractvd in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(31) # Could not lock stractvd to open setup
        end if
    end if
    if nastiness_occurred
    then
        display " a problem occurred ... rolling back.     "
            at 1,1
        sleep 5
        rollback work
        close window opn_setup
        let sqlca.sqlcode = 0
        let p_rcntrc.ar_balanced = "Y"
        display by name p_rcntrc.ar_balanced
        whenever error call error_handler
        return
    end if
    call delt_trans()
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        let sqlca.sqlcode = 0
    end if
    close window opn_setup
end function
# open_setup()

#######################################################################
function delt_trans()
# delete all a/r transactions
#######################################################################
#
    define
        d_journal like strtranr.orig_journal,
        d_doc_no like strtranr.doc_no,
        d_count integer

# set control "setup completed"
    update strcntrc set strcntrc.ar_balanced = p_rcntrc.ar_balanced
    declare d_curs cursor for
        select orig_journal, doc_no from strtranr
    foreach d_curs into d_journal, d_doc_no
        select count(*) into d_count
        from stgtranr where stgtranr.orig_journal = d_journal and
            stgtranr.doc_no = d_doc_no
        if d_count = 0
        then
            delete from stxtranr
            where stxtranr.orig_journal = d_journal and
                  stxtranr.doc_no = d_doc_no
        end if
    end foreach
    close d_curs
    delete from strtranr
    delete from stractvd

end function
# delt_trans()
