#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_invce.4gs/header.4gl  1.11  Delta: 8/31/90
#####################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
# calls lower level input routines for the given form
#
    define
        return_flag smallint

    if curr_form = 1
    then
        call r_input() returning return_flag
    else
        call q_input() returning return_flag
    end if
    return return_flag
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    define
       chk_date date

    if curr_form = 1
    then
        if mustfill(r_rinvce.cust_code,"Customer Code") or
           mustfill(r_rinvce.file_type,"Document Type") or
           mustfill(r_rinvce.due_date,"Due Date") or
           mustfill(r_rinvce.inv_date,"Invoice Date")
        then
            return false
        end if
        call llh_r_q()
    else
        if mustfill(q_rinvce.cust_code,"Customer Code") or
           mustfill(q_rinvce.file_type,"Document Type") or
           mustfill(q_rinvce.due_date,"Due Date") or
           mustfill(q_rinvce.inv_date,"Invoice Date")
        then
            return false
        end if
        call llh_q_r()
    end if
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
#   display p_rinvce.* to s_rinvce.*
    if curr_form = 1
    then
        display r_rinvce.* to s_1invce.*
        if r_rinvce.file_type = "C" then display " Credit" at 7,19 end if
        if r_rinvce.file_type = "D" then display "  Debit" at 7,19 end if
        if r_rinvce.file_type != "C" and r_rinvce.file_type != "D"
        then
            display "Invoice" at 7,19
        end if
    else
        display q_rinvce.* to s_2invce.*
        if q_rinvce.file_type = "C" then display " Credit" at 7,19 end if
        if q_rinvce.file_type = "D" then display "  Debit" at 7,19 end if
        if q_rinvce.file_type != "C" and q_rinvce.file_type != "D"
        then
            display "Invoice" at 7,19
        end if
    end if

end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    define
        disc_days like strtermr.disc_days,
        due_days like strtermr.due_days,
        disc_pct like strtermr.disc_pct,
        incr_with char(2)

    # no use preparing the p_ variables if we're just browsing
    if is_browse then return end if

    let p_rinvce.inv_date = m_rinvce.inv_date
    let p_rinvce.department = m_rinvce.department
    if p_rinvce.department is null then let p_rinvce.department = "000" end if
    let p_rinvce.inv_no = m_rinvce.inv_no
    let p_rinvce.ref_no = m_rinvce.ref_no
    let p_rinvce.tax = m_rinvce.tax
    let p_rinvce.file_type = m_rinvce.file_type
    let p_rinvce.cust_code = m_rinvce.cust_code
    if p_rinvce.cust_code is not null
    then
        call ar_custn(p_rinvce.cust_code)
            returning p_rinvce.cust_name
    end if
    let p_rinvce.ship_to_code = m_rinvce.ship_to_code
    let p_rinvce.inv_desc = m_rinvce.inv_desc
    let p_rinvce.posted = m_rinvce.posted
    let p_rinvce.recurring = m_rinvce.recurring
    let p_rinvce.due_date = m_rinvce.due_date
    let p_rinvce.disc_date = m_rinvce.disc_date
    let p_rinvce.disc_pct = m_rinvce.disc_pct
    let p_rinvce.disc_acct_no = m_rinvce.disc_acct_no
    let p_rinvce.disc_department = m_rinvce.disc_department
    let p_rinvce.disc_amount = m_rinvce.disc_amount
    let p_rinvce.disc_debit_credit = m_rinvce.disc_debit_credit

    let p_rinvce.tax_acct_no = m_rinvce.tax_acct_no
    let p_rinvce.tax_department = m_rinvce.tax_department
    if p_rinvce.tax_acct_no is null
    then
        let p_rinvce.tax_acct_no = m_rcntrc.ar_tax_acct_no
        let p_rinvce.tax_department = p_rinvce.department
    end if
    if m_rinvce.tax_amount is null then
        let m_rinvce.tax_amount = 0
    end if
    let p_rinvce.tax_amount = m_rinvce.tax_amount
    let p_rinvce.tax_debit_credit = m_rinvce.tax_debit_credit
    call al_chrtn(p_rinvce.tax_acct_no)
        returning p_rinvce.tax_desc, incr_with
    call credit_amount(p_rinvce.tax_debit_credit, p_rinvce.tax_amount)
        returning p_rinvce.tax_tmp
    let p_rinvce.frght_acct_no = m_rinvce.frght_acct_no
    let p_rinvce.frght_department = m_rinvce.frght_department
    if p_rinvce.frght_acct_no is null
    then
        let p_rinvce.frght_acct_no = m_rcntrc.ar_frght_acct_no
        let p_rinvce.frght_department = p_rinvce.department
    end if
    if m_rinvce.frght_amount is null then
        let m_rinvce.frght_amount = 0
    end if
    let p_rinvce.frght_amount = m_rinvce.frght_amount
    let p_rinvce.frght_debit_credit = m_rinvce.frght_debit_credit
    call al_chrtn(p_rinvce.frght_acct_no)
        returning p_rinvce.frght_desc, incr_with
    call credit_amount(p_rinvce.frght_debit_credit, p_rinvce.frght_amount)
        returning p_rinvce.frght_tmp
    let p_rinvce.misc_acct_no = m_rinvce.misc_acct_no
    let p_rinvce.misc_department = m_rinvce.misc_department
    if p_rinvce.misc_acct_no is null
    then
        let p_rinvce.misc_acct_no = m_rcntrc.ar_misc_acct_no
        let p_rinvce.misc_department = p_rinvce.department
    end if
    if m_rinvce.misc_amount is null then
        let m_rinvce.misc_amount = 0
    end if
    let p_rinvce.misc_amount = m_rinvce.misc_amount
    let p_rinvce.misc_debit_credit = m_rinvce.misc_debit_credit
    call al_chrtn(p_rinvce.misc_acct_no)
        returning p_rinvce.misc_desc, incr_with
    call credit_amount(p_rinvce.misc_debit_credit, p_rinvce.misc_amount)
        returning p_rinvce.misc_tmp
    let p_rinvce.ar_acct_no = m_rinvce.ar_acct_no
    let p_rinvce.ar_department = m_rinvce.ar_department
    if m_rinvce.ar_amount is null then
        let m_rinvce.ar_amount = 0
    end if
    let p_rinvce.ar_amount = m_rinvce.ar_amount
    let p_rinvce.ar_debit_credit = m_rinvce.ar_debit_credit
    if p_rinvce.ar_acct_no is not null
    then
        call al_chrtn(p_rinvce.ar_acct_no)
            returning p_rinvce.ar_desc, incr_with
        call debit_amount(p_rinvce.ar_debit_credit, p_rinvce.ar_amount)
            returning p_rinvce.ar_tmp
    end if
    let p_rinvce.po_no = m_rinvce.po_no
    let p_rinvce.po_date = m_rinvce.po_date
    let p_rinvce.inv_note = m_rinvce.inv_note
    let p_rinvce.terms_code = m_rinvce.terms_code
    if p_rinvce.terms_code is not null
    then
        call ar_termn(p_rinvce.terms_code)
            returning p_rinvce.terms, due_days, disc_days, disc_pct
    end if
    call llh_p_q()
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    call llh_q_p()
    let m_rinvce.file_type = p_rinvce.file_type
    let m_rinvce.inv_date = p_rinvce.inv_date
    if p_rinvce.department is null
    then
        let p_rinvce.department = "000"
    end if
    let m_rinvce.department = p_rinvce.department
    let m_rinvce.inv_no = p_rinvce.inv_no
    let m_rinvce.ref_no = p_rinvce.ref_no
    let m_rinvce.tax = p_rinvce.tax
    let m_rinvce.cust_code = p_rinvce.cust_code
    let m_rinvce.ship_to_code = p_rinvce.ship_to_code
    let m_rinvce.inv_desc = p_rinvce.inv_desc
    if p_rinvce.posted is null then let p_rinvce.posted = "N" end if
    let m_rinvce.posted = p_rinvce.posted
    let m_rinvce.recurring = p_rinvce.recurring
    let m_rinvce.due_date = p_rinvce.due_date
    if p_rinvce.disc_date is null
    then
        let p_rinvce.disc_date = m_rinvce.due_date
    end if   
    let m_rinvce.disc_date = p_rinvce.disc_date
    if p_rinvce.disc_pct is null then let p_rinvce.disc_pct = 0 end if
    let m_rinvce.disc_pct = p_rinvce.disc_pct
    call set_disc()
    let m_rinvce.disc_acct_no = p_rinvce.disc_acct_no
    let m_rinvce.disc_department = p_rinvce.disc_department
    if p_rinvce.disc_amount is null then let p_rinvce.disc_amount = 0 end if
    let m_rinvce.disc_amount = p_rinvce.disc_amount
    let m_rinvce.disc_debit_credit = p_rinvce.disc_debit_credit
    let m_rinvce.tax_acct_no = p_rinvce.tax_acct_no
    let m_rinvce.tax_department = p_rinvce.tax_department
    if p_rinvce.tax_amount is null then let p_rinvce.tax_amount = 0 end if
    let m_rinvce.tax_amount = p_rinvce.tax_amount
    let m_rinvce.tax_debit_credit = p_rinvce.tax_debit_credit
    let m_rinvce.frght_acct_no = p_rinvce.frght_acct_no
    let m_rinvce.frght_department = p_rinvce.frght_department
    if p_rinvce.frght_amount is null then let p_rinvce.frght_amount = 0 end if
    let m_rinvce.frght_amount = p_rinvce.frght_amount
    let m_rinvce.frght_debit_credit = p_rinvce.frght_debit_credit
    let m_rinvce.misc_acct_no = p_rinvce.misc_acct_no
    let m_rinvce.misc_department = p_rinvce.misc_department
    if p_rinvce.misc_amount is null then let p_rinvce.misc_amount = 0 end if
    let m_rinvce.misc_amount = p_rinvce.misc_amount
    let m_rinvce.misc_debit_credit = p_rinvce.misc_debit_credit
    let m_rinvce.ar_acct_no = p_rinvce.ar_acct_no
    if p_rinvce.ar_department is null and p_rinvce.ar_acct_no is not null
    then
        let p_rinvce.ar_department = p_rinvce.department
    end if
    let m_rinvce.ar_department = p_rinvce.ar_department
    if p_rinvce.ar_amount is null then let p_rinvce.ar_amount = 0 end if
    let m_rinvce.ar_amount = p_rinvce.ar_amount
    let m_rinvce.ar_debit_credit = p_rinvce.ar_debit_credit
    let m_rinvce.po_no = p_rinvce.po_no
    let m_rinvce.po_date = p_rinvce.po_date
    let m_rinvce.inv_note = p_rinvce.inv_note
    let m_rinvce.terms_code = p_rinvce.terms_code
    let m_rinvce.ok_to_post = "N"
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_rinvce.* from strinvce where rowid = ring_rowid
    if sqlca.sqlcode != 0
    then
        return
    end if
    whenever error call error_handler
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer,     # rowid passed
        scratch char(20)

    delete from strinvce where rowid = ring_rowid
    if sqlca.sqlcode = 0
    then
        # delete user defined fields
        let scratch = m_rinvce.doc_no using "<<<<<<<<<<", "-UNPOSTED"
        call al_addld("stxtranrAR",scratch)
    end if

end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    if m_rinvce.doc_no is null
    then
        let m_rinvce.doc_no = 0
    end if
    whenever error continue
    insert into strinvce values(m_rinvce.*)
    whenever error call error_handler
    let m_rinvce.doc_no = sqlca.sqlerrd[2]
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update strinvce set strinvce.* = m_rinvce.*
        where rowid = ring_rowid
end function
# llh_update()

#######################################################################
function llh_p_q()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    let q_rinvce.inv_date = p_rinvce.inv_date
    let q_rinvce.cust_code = p_rinvce.cust_code
    let q_rinvce.cust_name = p_rinvce.cust_name
    let q_rinvce.inv_no = p_rinvce.inv_no
    let q_rinvce.ref_no = p_rinvce.ref_no
    let q_rinvce.tax = p_rinvce.tax
    let q_rinvce.file_type = p_rinvce.file_type
    let q_rinvce.inv_desc = p_rinvce.inv_desc
    let q_rinvce.posted = p_rinvce.posted
    let q_rinvce.recurring = p_rinvce.recurring
    let q_rinvce.due_date = p_rinvce.due_date
    let q_rinvce.disc_date = p_rinvce.disc_date
    let q_rinvce.disc_pct = p_rinvce.disc_pct
    let q_rinvce.tax_acct_no = p_rinvce.tax_acct_no
    let q_rinvce.tax_desc = p_rinvce.tax_desc
    let q_rinvce.tax_department = p_rinvce.tax_department
    let q_rinvce.tax_amount = p_rinvce.tax_amount
    let q_rinvce.tax_tmp = p_rinvce.tax_tmp
    let q_rinvce.tax_debit_credit = p_rinvce.tax_debit_credit
    let q_rinvce.frght_acct_no = p_rinvce.frght_acct_no
    let q_rinvce.frght_desc = p_rinvce.frght_desc
    let q_rinvce.frght_department = p_rinvce.frght_department
    let q_rinvce.frght_amount = p_rinvce.frght_amount
    let q_rinvce.frght_tmp = p_rinvce.frght_tmp
    let q_rinvce.frght_debit_credit = p_rinvce.frght_debit_credit
    let q_rinvce.misc_acct_no = p_rinvce.misc_acct_no
    let q_rinvce.misc_desc = p_rinvce.misc_desc
    let q_rinvce.misc_department = p_rinvce.misc_department
    let q_rinvce.misc_amount = p_rinvce.misc_amount
    let q_rinvce.misc_tmp = p_rinvce.misc_tmp
    let q_rinvce.misc_debit_credit = p_rinvce.misc_debit_credit
    let q_rinvce.ar_acct_no = p_rinvce.ar_acct_no
    let q_rinvce.ar_desc = p_rinvce.ar_desc
    let q_rinvce.ar_department = p_rinvce.ar_department
    let q_rinvce.ar_amount = p_rinvce.ar_amount
    let q_rinvce.ar_tmp = p_rinvce.ar_tmp
    let q_rinvce.ar_debit_credit = p_rinvce.ar_debit_credit

    let r_rinvce.inv_date = p_rinvce.inv_date
    let r_rinvce.department = p_rinvce.department
    let r_rinvce.cust_code = p_rinvce.cust_code
    let r_rinvce.cust_name = p_rinvce.cust_name
    let r_rinvce.ship_to_code = p_rinvce.ship_to_code
    let r_rinvce.due_date = p_rinvce.due_date
    let r_rinvce.inv_no = p_rinvce.inv_no
    let r_rinvce.ref_no = p_rinvce.ref_no
    let r_rinvce.tax = p_rinvce.tax
    let r_rinvce.file_type = p_rinvce.file_type
    let r_rinvce.inv_desc = p_rinvce.inv_desc
    let r_rinvce.posted = p_rinvce.posted
    let r_rinvce.recurring = p_rinvce.recurring
    let r_rinvce.terms_code = p_rinvce.terms_code
    let r_rinvce.terms = p_rinvce.terms
    let r_rinvce.po_no = p_rinvce.po_no
    let r_rinvce.po_date = p_rinvce.po_date
    let r_rinvce.inv_note = p_rinvce.inv_note
    let r_rinvce.misc_tmp = p_rinvce.misc_tmp
    let r_rinvce.tax_tmp = p_rinvce.tax_tmp
    let r_rinvce.frght_tmp = p_rinvce.frght_tmp
    let r_rinvce.ar_tmp = p_rinvce.ar_tmp
end function
# llh_p_q()

#######################################################################
function llh_q_p()
#######################################################################
#   - this function creates the p_* record from the q_* record
#
    let p_rinvce.department = r_rinvce.department
    if p_rinvce.department is null
    then
        let p_rinvce.department = "000"
    end if
    let p_rinvce.inv_date = q_rinvce.inv_date
    let p_rinvce.ref_no = q_rinvce.ref_no
    let p_rinvce.tax = q_rinvce.tax
    let p_rinvce.file_type = q_rinvce.file_type
    let p_rinvce.inv_no = q_rinvce.inv_no
    let p_rinvce.cust_code = q_rinvce.cust_code
    let p_rinvce.inv_desc = q_rinvce.inv_desc
    let p_rinvce.posted = q_rinvce.posted
    let p_rinvce.recurring = q_rinvce.recurring
    let p_rinvce.due_date = q_rinvce.due_date
    let p_rinvce.disc_date = q_rinvce.disc_date
    let p_rinvce.disc_pct = q_rinvce.disc_pct
    let p_rinvce.misc_acct_no = q_rinvce.misc_acct_no
    if p_rinvce.misc_acct_no is null
    then
        let p_rinvce.misc_acct_no = m_rcntrc.ar_misc_acct_no
        let p_rinvce.misc_department = p_rinvce.department
    else
        let p_rinvce.misc_department = q_rinvce.misc_department
    end if
    let p_rinvce.misc_amount = q_rinvce.misc_amount
    let p_rinvce.misc_debit_credit = q_rinvce.misc_debit_credit
    let p_rinvce.frght_acct_no = q_rinvce.frght_acct_no
    if p_rinvce.frght_acct_no is null
    then
        let p_rinvce.frght_acct_no = m_rcntrc.ar_frght_acct_no
        let p_rinvce.frght_department = p_rinvce.department
    else
        let p_rinvce.frght_department = q_rinvce.frght_department
    end if
    let p_rinvce.frght_amount = q_rinvce.frght_amount
    let p_rinvce.frght_debit_credit = q_rinvce.frght_debit_credit
    let p_rinvce.tax_acct_no = q_rinvce.tax_acct_no
    if p_rinvce.tax_acct_no is null
    then
        let p_rinvce.tax_acct_no = m_rcntrc.ar_tax_acct_no
        let p_rinvce.tax_department = p_rinvce.department
    else
        let p_rinvce.tax_department = q_rinvce.tax_department
    end if
    let p_rinvce.tax_amount = q_rinvce.tax_amount
    let p_rinvce.tax_debit_credit = q_rinvce.tax_debit_credit
    let p_rinvce.ar_acct_no = q_rinvce.ar_acct_no
    if p_rinvce.ar_acct_no is null
    then
        let p_rinvce.ar_acct_no = m_rcntrc.ar_acct_no
        let p_rinvce.ar_department = p_rinvce.department
    else
        let p_rinvce.ar_department = q_rinvce.ar_department
    end if
    let p_rinvce.ar_amount = q_rinvce.ar_amount
    let p_rinvce.ar_debit_credit = q_rinvce.ar_debit_credit
    let p_rinvce.ship_to_code = r_rinvce.ship_to_code
    let p_rinvce.po_no = r_rinvce.po_no
    let p_rinvce.po_date = r_rinvce.po_date
    let p_rinvce.inv_note = r_rinvce.inv_note
    let p_rinvce.terms_code = r_rinvce.terms_code
    let p_rinvce.due_date = r_rinvce.due_date
end function
# llh_q_p()

########################################################################
function set_disc()
########################################################################
#
# sets the discount line
#

    define
        amount like strinvce.ar_amount

    let p_rinvce.disc_acct_no = m_rcntrc.cr_disc_acct_no
    let p_rinvce.disc_department = p_rinvce.department
    if p_rinvce.sub_total is null then let p_rinvce.sub_total = 0 end if
    if p_rinvce.misc_tmp is null then let p_rinvce.misc_tmp = 0 end if
    if p_rinvce.frght_tmp is null then let p_rinvce.frght_tmp = 0 end if
    if p_rinvce.tax_tmp is null then let p_rinvce.tax_tmp = 0 end if
    let amount = p_rinvce.sub_total
    if m_rcntrc.disc_misc = "Y"
    then
        let amount = amount + p_rinvce.misc_tmp
    end if
    if m_rcntrc.disc_frght = "Y"
    then
        let amount = amount + p_rinvce.frght_tmp
    end if
    if m_rcntrc.disc_tax = "Y"
    then
        let amount = amount + p_rinvce.tax_tmp
    end if
    let p_rinvce.disc_tmp = al_round( "a", (p_rinvce.disc_pct / 100) * amount )
    call switch_credit(p_rinvce.disc_tmp,p_rinvce.file_type) returning
                       p_rinvce.disc_debit_credit
    let p_rinvce.disc_amount = absolute(p_rinvce.disc_tmp)

end function
# set_disc()

