#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_invce.4gs/inputd1.4gl  1.7  Delta: 6/13/90
#####################################################################

globals "globals.4gl"

#######################################################################
function r_inputd()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#   - scrolling input array
#   - must call set_count before input array
#

    define
        return_flag smallint,
        counter smallint,
        pcurr smallint,
        scurr smallint,
        oldqty  like strinvcd.quantity,
        oldprice  like strinvcd.price

    let return_flag = 0
    call set_count(rec1_cnt)    # this must be called before input array
        input array r_rinvcd without defaults from s_1invcd.*
            on key (control-i)
                let return_flag = -1
                 exit input
            on key (control-e)
                call fg_err(0)
            on key (control-w)
                call fg_help(2)
            on key (control-f)
                # add/update user defined fields...
                call al_addlz("stxtranrAR",m_rinvce.doc_no,"-UNPOSTED","")
            before row
                let pcurr = arr_curr()
                let scurr = scr_line()
            before field quantity
                if r_rinvcd[pcurr].quantity is null
                then
                    let oldqty = 0
                else
                    let oldqty = r_rinvcd[pcurr].quantity
                end if
            after field quantity
                call calc_total(pcurr,scurr)
                call lld_recalc()
            before field price
                if r_rinvcd[pcurr].price is null
                then
                    let oldprice = 0
                else
                    let oldprice = r_rinvcd[pcurr].price
                end if
            after field price
                let r_rinvcd[pcurr].price = al_round( "a",
                    r_rinvcd[pcurr].price )
                call calc_total(pcurr,scurr)
                call lld_recalc()
            before delete
                call mld_arr_count()
            after delete
                initialize r_rinvcd[rec1_cnt].* to null
                for counter = pcurr to rec1_max - 1
                    let q_rinvcd[counter].* = q_rinvcd[counter+1].*
                end for
                initialize q_rinvcd[rec1_max].* to null 
                initialize r_rinvcd[rec1_max].* to null
                call lld_recalc()
            before insert
                for counter = rec1_max -1 to pcurr step - 1
                    let q_rinvcd[counter+1].* = q_rinvcd[counter].*
                end for
                initialize q_rinvcd[pcurr].* to null 
        end input
    return return_flag
end function
# lld_input()

