#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_invce.4gs/inputd2.4gl  1.10  Delta: 6/13/90
#####################################################################

globals "globals.4gl"

#######################################################################
function q_inputd()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#   - scrolling input array
#   - must call set_count before input array
#

    define
        return_flag         smallint,
        counter             smallint,
        pcurr               smallint,       #row of program array
        scurr               smallint,       #row of screen array
        acct_no like strinvcd.acct_no,
        department like strinvcd.department,
        description like strinvcd.description,
        oldacct_no          like stxchrtr.acct_no,
        acct_zoom           char(1),
        oldamount           like strinvcd.amount

    call set_count(rec1_cnt)    # this must be called before input array

    let return_flag = 0
    let acct_zoom = "N"
    input array q_rinvcd without defaults from s_2invcd.*
        on key (control-i)
            let return_flag = -1
            exit input 
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(4)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxtranrAR",m_rinvce.doc_no,"-UNPOSTED","")
        on key (control-z)
            case
                when infield(acct_no)
                    let oldacct_no = q_rinvcd[pcurr].acct_no
                    let acct_zoom = "Y"
                    call al_chrtz() returning acct_no
                    if acct_no is not null
                    then
                        let q_rinvcd[pcurr].acct_no = acct_no
                    end if
                    display q_rinvcd[pcurr].acct_no to s_2invcd[scurr].acct_no
                    next field acct_no
                when infield(department)
                    call al_deptz() returning department
                    if department is not null
                    then
                        let q_rinvcd[pcurr].department = department
                    end if
                    display q_rinvcd[pcurr].department to 
                            s_2invcd[scurr].department
                    next field department
            end case
        before row
            let pcurr = arr_curr()
            let scurr = scr_line()
        before field acct_no
            if acct_zoom = "Y"
            then
                let acct_zoom = "N"
            else
                let oldacct_no = q_rinvcd[pcurr].acct_no
            end if
        before field department
            if q_rinvcd[pcurr].acct_no is not null and al_deptc()
            then
                let q_rinvcd[pcurr].department = "000"
                display q_rinvcd[pcurr].department to s_2invcd[scurr].department
            end if
        before field tmp_amount
            let oldamount = q_rinvcd[pcurr].tmp_amount
        after field acct_no
            if q_rinvcd[pcurr].acct_no is null
            then
                call lld_clearline(pcurr,scurr)
                call lld_showline(pcurr,scurr)
                call lld_recalc()
            end if
            if q_rinvcd[pcurr].acct_no != oldacct_no or
               oldacct_no is null and
               q_rinvcd[pcurr].acct_no is not null
            then
                call wlf_change(oldacct_no,pcurr,scurr)
                if q_rinvcd[pcurr].description = "NOT FOUND"
                then
                    let q_rinvcd[pcurr].description = null
                    call lld_showline(pcurr,scurr)
                    next field acct_no
                end if
                let oldamount = 0
                call flip(pcurr,scurr)
            end if
        after field department
            if q_rinvcd[pcurr].acct_no is null
            then
                let q_rinvcd[pcurr].department = null
            else
                if q_rinvcd[pcurr].department is null
                then
                    let q_rinvcd[pcurr].department = "000"
                end if
            end if
            display q_rinvcd[pcurr].department to s_2invcd[scurr].department
            if q_rinvcd[pcurr].department is not null and
               q_rinvcd[pcurr].department != "000"
            then
                call al_deptn(q_rinvcd[pcurr].department)
                   returning description
                if description = "NOT FOUND"
                then
                    let q_rinvcd[pcurr].department = null
                    display q_rinvcd[pcurr].department to
                            s_2invcd[scurr].department
                    call fg_err(3) #  Department code has not been defined
                    next field department
                end if
            end if
        after field tmp_amount
            if q_rinvcd[pcurr].acct_no is not null and 
               q_rinvcd[pcurr].department is not null
            then
                call flip(pcurr,scurr)
                call lld_recalc()
            else
                call lld_clearline(pcurr,scurr)
                call lld_showline(pcurr,scurr)
            end if
        before delete
            call mld_arr_count()
        after delete
            initialize q_rinvcd[rec1_cnt].* to null
            let pcurr = arr_curr()
            for counter = pcurr to rec1_max -1
                let r_rinvcd[counter].* = r_rinvcd[counter+1].*
            end for
            initialize r_rinvcd[rec1_max].* to null
            initialize q_rinvcd[rec1_max].* to null
            call lld_recalc()
        before insert
            let pcurr = arr_curr()
            for counter = rec1_max -1 to pcurr step - 1
                let r_rinvcd[counter+1].* = r_rinvcd[counter].*
            end for
            initialize r_rinvcd[pcurr].* to null
    end input
    return return_flag
end function
# lld_input()

############################################################
function wlf_change(oldacct_no,pcurr,scurr)
############################################################
# when leaving field account number
# the field is change this function
# gets description from the chart of accounts table
#
    define
        pcurr               smallint,
        scurr               smallint,
        oldacct_no          like stxchrtr.acct_no,
        db_cr char(2)

    let q_rinvcd[pcurr].department = null
    let q_rinvcd[pcurr].debit_credit = null

    call al_chrtn(q_rinvcd[pcurr].acct_no)
        returning q_rinvcd[pcurr].description, db_cr
                
    if q_rinvcd[pcurr].description = "NOT FOUND"
    then
        call fg_err(11) # Account number has not been defined
        let q_rinvcd[pcurr].acct_no = null
        return
    end if
    call lld_recalc()
    call lld_showline(pcurr,scurr)

end function
# wlf_change()

