##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_invce.4gs/inputd3.4gl  1.5  Last Delta: 6/13/90
##############################################################################

globals "globals.4gl"

##############################################################
function set_acct_line(n)
##############################################################
#
# coverts each detail amount line to the accounting format
#

    define
        n smallint,
        db_cr char(2)

    if r_rinvcd[n].tmp_amount is not null
    then
        if q_rinvcd[n].acct_no is null
        then
            let q_rinvcd[n].acct_no = m_rcntrc.ar_sales_acct_no
            let q_rinvcd[n].department = r_rinvce.department
            call al_chrtn(q_rinvcd[n].acct_no)
                returning q_rinvcd[n].description, db_cr
            if r_rinvcd[n].description is not null
            then
                let q_rinvcd[n].description = r_rinvcd[n].description
            end if
        end if
        let q_rinvcd[n].tmp_amount = r_rinvcd[n].tmp_amount
        call switch_credit(q_rinvcd[n].tmp_amount,q_rinvce.file_type)
            returning q_rinvcd[n].debit_credit
        let q_rinvcd[n].amount = absolute(q_rinvcd[n].tmp_amount)
     end if

end function
# set_acct_line(n)

######################################################################
function calc_total(pcurr,scurr)
######################################################################
#
# calculate each detail line's extension. (qty * price)
#

    define
        pcurr smallint,
        scurr smallint,
        scratch char(15)

    if r_rinvcd[pcurr].quantity is null
    then
        let r_rinvcd[pcurr].tmp_amount = null
        display r_rinvcd[pcurr].tmp_amount to s_1invcd[scurr].tmp_amount
        return
    end if
    if r_rinvcd[pcurr].price is null
    then
        let r_rinvcd[pcurr].tmp_amount = null
        display r_rinvcd[pcurr].tmp_amount to s_1invcd[scurr].tmp_amount
        return
    end if

    let r_rinvcd[pcurr].tmp_amount = al_round( "a", 
        r_rinvcd[pcurr].quantity * r_rinvcd[pcurr].price )

    display r_rinvcd[pcurr].tmp_amount to s_1invcd[scurr].tmp_amount

end function
# calc_total

############################################################
function flip(pcurr,scurr)
############################################################
#
    define
        scurr               smallint,
        pcurr               smallint

    call switch_credit(q_rinvcd[pcurr].tmp_amount,q_rinvce.file_type)
        returning q_rinvcd[pcurr].debit_credit
    let q_rinvcd[pcurr].amount = absolute(q_rinvcd[pcurr].tmp_amount)
    call lld_showline(pcurr,scurr)

end function
#flip2

############################################################
function lld_showline(pcurr,scurr)
############################################################
# Show a line
#
    define pcurr smallint,
           scurr smallint

    display q_rinvcd[pcurr].* to s_2invcd[scurr].*

end function
# lld_showline

############################################################
function lld_clearline(pcurr,scurr)
############################################################
# clear a line
#
    define
        pcurr smallint,
        scurr smallint

    let q_rinvcd[pcurr].department = null
    let q_rinvcd[pcurr].description = null
    let q_rinvcd[pcurr].tmp_amount = null
    let q_rinvcd[pcurr].amount = null
    let q_rinvcd[pcurr].debit_credit = null

end function
# lld_clearline

############################################################
function lld_recalc()
#
############################################################
# Recalculate the subtotals
#

    define
        counter             smallint,
        scratch char(13)

    let p_rinvce.sub_total = 0
    call mld_arr_count()
    for counter = 1 to rec1_cnt
        if curr_form = 1
        then
            if r_rinvcd[counter].tmp_amount is not null then
                let p_rinvce.sub_total=r_rinvcd[counter].tmp_amount +
                                       p_rinvce.sub_total
            end if
        else
            if q_rinvcd[counter].tmp_amount is not null then
                let p_rinvce.sub_total=q_rinvcd[counter].tmp_amount +
                                       p_rinvce.sub_total
            end if
        end if
    end for
    let r_rinvce.sub_total = p_rinvce.sub_total
    let q_rinvce.sub_total = p_rinvce.sub_total
    call total_calc()

end function
# lld_recalc()

############################################################
function total_calc()
############################################################
#
# calculate the a/r and discount totals
#
    define
        db_cr char(2)

    if curr_form = 1
    then
        call ar_total()
    else
        if q_rinvce.ar_acct_no is null
        then
            let q_rinvce.ar_acct_no = m_rcntrc.ar_acct_no
            if r_rinvce.department is not null
            then
                let q_rinvce.ar_department = r_rinvce.department
            else
                let q_rinvce.ar_department = "000"
            end if
            call al_chrtn(q_rinvce.ar_acct_no)
                returning q_rinvce.ar_desc, db_cr
        end if
        call ar_total()
    end if
    call llh_display()

end function
# total_calc
