#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_invce.4gs/inputh1.4gl  1.12  Delta: 5/30/90
#####################################################################

globals "globals.4gl"


#######################################################################
function r_input()
#######################################################################
#
# Input process for Entering Invoice using form screen1
#
     define
        tmp_filetype char(1),
        old_inv_date like strinvce.inv_date,
        oldtax like strinvce.tax,
        oldship_to_code char(6),
        in_zoom smallint,
        after_field char(1),
        tmp_al_deptn char(30),
        return_flag smallint,
        oldcust_code like strcustr.cust_code,
        oldterms_code like strtermr.terms_code,
        oldref_no like strinvce.ref_no,
        olddepartment like strinvce.ar_department,
        due_days  like strtermr.due_days,
        disc_days  like strtermr.disc_days,
        disc_pct  like strtermr.disc_pct

    let return_flag = 0
    let in_zoom = false
    let old_inv_date = r_rinvce.inv_date

    if m_rinvce.doc_no is null
    then
        let m_rinvce.doc_no = al_uniq()
        display "Invoice" at 7,19
    end if

    input r_rinvce.* without defaults from s_1invce.*
        on key (control-i)
            let return_flag = -1
            exit input
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxtranrAR",m_rinvce.doc_no,"-UNPOSTED","")
        on key (control-z)
            case
                when infield(department)
                    let olddepartment = r_rinvce.department
                    call al_deptz()
                    returning r_rinvce.department
                    if r_rinvce.department is null
                    then
                        let r_rinvce.department = olddepartment
                    end if
                    display by name r_rinvce.department
                    next field department
                when infield(cust_code)
                    let oldcust_code = r_rinvce.cust_code
                    let in_zoom = true
                    call ar_custz()
                        returning r_rinvce.cust_code
                    if r_rinvce.cust_code is null
                    then
                        let r_rinvce.cust_code = oldcust_code
                    end if
                    display by name r_rinvce.cust_code
                    next field cust_code
                when infield(ship_to_code)
                    let oldship_to_code = r_rinvce.ship_to_code
                    let in_zoom = true
                    call ar_shipz(r_rinvce.cust_code)
                        returning r_rinvce.ship_to_code
                    if r_rinvce.ship_to_code is null
                    then
                        let r_rinvce.ship_to_code = oldship_to_code
                    end if
                    display by name r_rinvce.ship_to_code
                    next field ship_to_code
                when infield(ref_no)
                    let oldref_no = r_rinvce.ref_no
                    call ar_openz(r_rinvce.cust_code)
                        returning r_rinvce.ref_no
                        if r_rinvce.ref_no is null
                        then
                            let r_rinvce.ref_no = oldref_no
                            display by name r_rinvce.ref_no
                        end if
                        next field ref_no
                when infield(terms_code)
                    let oldterms_code = r_rinvce.terms_code
                    let in_zoom = true
                    call ar_termz()
                        returning r_rinvce.terms_code
                    if r_rinvce.terms_code is null
                    then
                        let r_rinvce.terms_code = oldterms_code
                    end if
                    display by name r_rinvce.terms_code
                    next field terms_code
            end case
        after field inv_date
            let after_field = "I"
            if r_rinvce.inv_date is null
            then
                let r_rinvce.inv_date = today
                display by name r_rinvce.inv_date
                let old_inv_date = null
            end if
            if r_rinvce.posted is null
            then
                let r_rinvce.posted = "N"
                display by name r_rinvce.posted
            end if
            if r_rinvce.terms_code is null or
               r_rinvce.inv_date != old_inv_date or
               old_inv_date is null
            then
                if r_rinvce.terms_code is null
                then
                    let r_rinvce.terms_code = m_rcntrc.terms_code
                end if
                call ar_termn(r_rinvce.terms_code)
                    returning r_rinvce.terms, due_days,
                              disc_days, disc_pct
                let r_rinvce.due_date = r_rinvce.inv_date + due_days
                let q_rinvce.due_date = r_rinvce.due_date
                let q_rinvce.disc_date = r_rinvce.inv_date + disc_days
                let q_rinvce.disc_pct = disc_pct
                display by name r_rinvce.terms_code, r_rinvce.terms,
                        r_rinvce.due_date
            end if
            let old_inv_date = r_rinvce.inv_date
        after field department
            if r_rinvce.department is null
            then
                let r_rinvce.department = "000"
                display by name r_rinvce.department
            else
                call al_deptn(r_rinvce.department) returning tmp_al_deptn
                if tmp_al_deptn = "NOT FOUND"
                then
                    call fg_err(3) # Invalid Department
                    next field department
                end if
            end if
        before field cust_code
            if in_zoom
            then
                let in_zoom = false
            else
                let oldcust_code = r_rinvce.cust_code
            end if
        after field cust_code
            if r_rinvce.cust_code is null
            then
                call fg_err(1) # Customer code is required.
                next field cust_code
            end if
            if  oldcust_code = r_rinvce.cust_code
            then else
                call ar_custn(r_rinvce.cust_code)
                    returning r_rinvce.cust_name
                display by name r_rinvce.cust_name
                if r_rinvce.cust_name = "NOT FOUND"
                then
                    call fg_err(4) # Invalid Customer
                    let oldcust_code = null
                    let in_zoom = true
                    next field cust_code
                end if
                call chg_cust(r_rinvce.cust_code)
            end if
        before field ship_to_code
            if in_zoom
            then
                let in_zoom = false
            else
                let oldship_to_code = r_rinvce.ship_to_code
            end if
        after field ship_to_code
            if r_rinvce.ship_to_code is null
            then
                let r_rinvce.ship_to_code = "SHIPTO"
                display by name r_rinvce.ship_to_code
            end if
            if ar_shipc(r_rinvce.cust_code,r_rinvce.ship_to_code)
            then
                call fg_err(5) # Invalid Ship to Code
                let oldship_to_code = null
                let in_zoom = true
                next field ship_to_code
            else
                if  oldship_to_code = r_rinvce.ship_to_code
                then else
                    call tax_able(r_rinvce.cust_code,
                                  r_rinvce.ship_to_code)
                end if
            end if
        before field file_type
            if r_rinvce.file_type is not null
            then
                let tmp_filetype = r_rinvce.file_type
            else
                let tmp_filetype = "x"
            end if
        after field file_type
            if r_rinvce.file_type is null
            then
                let r_rinvce.file_type = "I"
                let r_rinvce.ref_no = null
                display by name r_rinvce.file_type, r_rinvce.ref_no
            else
                if r_rinvce.file_type != "I" and
                   r_rinvce.file_type != "C" and
                   r_rinvce.file_type != "D" and
                   r_rinvce.file_type != "F"
                then
                    call fg_err(6) # Ref no must be a I, C, D, or F
                    let r_rinvce.file_type = ""
                    display by name r_rinvce.file_type
                    next field file_type
                end if
                if r_rinvce.file_type != tmp_filetype
                then
                    if r_rinvce.file_type = "C" or tmp_filetype = "C"
                    then
                        call chg_dbcr()
                    end if
                end if
            end if
            case
                when r_rinvce.file_type = "C"
                    display " Credit" at 7,19
                when r_rinvce.file_type = "D"
                    display "  Debit" at 7,19
                otherwise
                    let r_rinvce.ref_no = null
                    display by name r_rinvce.ref_no
                    display "Invoice" at 7,19
            end case
        after field recurring
            let after_field = "I"
        before field ref_no
            if r_rinvce.file_type = "I"
            then
                if after_field = "I"
                then
                    next field tax
                end if
                if after_field = "D"
                then
                    next field recurring
                end if
            end if
        after field ref_no
            if r_rinvce.ref_no is not null
            then
                if ar_openc(r_rinvce.cust_code, r_rinvce.ref_no)
                then
                    call fg_err(7) # Invalid reference number
                    next field ref_no
                end if
            end if
        before field tax
            let oldtax = r_rinvce.tax
        after field tax
            if r_rinvce.tax is null
            then
                let r_rinvce.tax = "N"
                display by name r_rinvce.tax
                let p_rinvce.tax = r_rinvce.tax
            end if
            if r_rinvce.tax != oldtax or
                oldtax is null
            then
                if r_rinvce.tax = "N"
                then
                    let r_rinvce.tax_tmp = null
                end if
                if r_rinvce.tax != "N" and r_rinvce.tax != "Y"
                then 
                    call fg_err(12) # taxable must be a "N" or "Y"
                    next field tax
                end if
                let p_rinvce.tax = r_rinvce.tax
                call ar_total()
            end if
            let after_field = "D"
        before field terms_code
            if in_zoom
            then
                let in_zoom = false
            else
                let oldterms_code = r_rinvce.terms_code
            end if
        after field terms_code
            if r_rinvce.terms_code is null
            then
                let r_rinvce.terms_code = m_rcntrc.terms_code
                display by name r_rinvce.terms_code
            end if
            if oldterms_code = r_rinvce.terms_code and
               r_rinvce.terms_code is not null
            then else
                call ar_termn(r_rinvce.terms_code)
                    returning r_rinvce.terms, due_days,
                              disc_days, disc_pct
                let r_rinvce.due_date = r_rinvce.inv_date + due_days
                let q_rinvce.due_date = r_rinvce.due_date
                let q_rinvce.disc_date = r_rinvce.inv_date +
                                         disc_days
                let q_rinvce.disc_pct = disc_pct
                display by name r_rinvce.terms, r_rinvce.due_date
                if r_rinvce.terms = "NOT FOUND"
                then
                    display by name r_rinvce.terms
                    call fg_err(8) # Warning:  Terms code not found.
                    next field terms_code
                end if
            end if
        after field due_date
            if r_rinvce.due_date is not null and
               r_rinvce.due_date < r_rinvce.inv_date
            then
               call fg_err(9) # Due date must be later than invoice date
            end if
        after field misc_tmp
            let r_rinvce.misc_tmp = al_round( "a", r_rinvce.misc_tmp ) 
            call ar_total()
        after field frght_tmp
            let r_rinvce.frght_tmp = al_round( "a", r_rinvce.frght_tmp ) 
            let after_field = "F"
            call ar_total()
        before field tax_tmp
            if r_rinvce.tax = "Y"
            then
                if after_field = "F"
                then
                    next field inv_date
                end if
                if after_field = "I"
                then
                    next field frght_tmp
                end if
            end if
        after field tax_tmp
            let r_rinvce.tax_tmp = al_round( "a", r_rinvce.tax_tmp ) 
            call ar_total()
    end input
    return return_flag

end function
# r_input()

#######################################################################
function llh_r_q()
#######################################################################
#
# converts r record fields to q record fields
#
    let q_rinvce.inv_date = r_rinvce.inv_date
    let q_rinvce.ref_no = r_rinvce.ref_no
    let q_rinvce.tax = r_rinvce.tax
    let q_rinvce.file_type = r_rinvce.file_type
    let q_rinvce.cust_code = r_rinvce.cust_code
    let q_rinvce.cust_name = r_rinvce.cust_name
    let q_rinvce.inv_no = r_rinvce.inv_no
    let q_rinvce.inv_desc = r_rinvce.inv_desc
    let q_rinvce.recurring = r_rinvce.recurring
    let q_rinvce.posted = r_rinvce.posted
    let q_rinvce.due_date = r_rinvce.due_date
    call set_misc_line()
    call set_tax_line()
    call set_frght_line()
    call set_ar_line()
end function
# llh_r_q()
