#####################################################################
# Copyright (C) 1988,1989
# Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_invce.4gs/inputh2.4gl  1.16  Delta: 5/14/90
#####################################################################

globals "globals.4gl"

#######################################################################
function q_input()
#######################################################################
#
# Input process for Entering Invoice using form screen2
#
    define
        db_cr               char(2),
        tmp_filetype        char(1),
        after_field         char(1),
        return_flag         smallint,
        description         char(30),
        old_inv_date        like strinvce.inv_date,
        oldcust_code        like strcustr.cust_code,
        in_zoom             smallint,
        oldtax              like strinvce.tax,
        oldactgrp           char(6),
        oldref_no           like strinvce.ref_no,
        oldacct_no          like stxchrtr.acct_no,
        olddepartment       like strinvce.department,
        oldamount           like strinvce.ar_amount,
        due_days            like strtermr.due_days,
        disc_days           like strtermr.disc_days,
        disc_pct            like strtermr.disc_pct


    let return_flag = 0
    let in_zoom = false
    let old_inv_date = q_rinvce.inv_date

    if m_rinvce.doc_no is null then let m_rinvce.doc_no = al_uniq() end if

    input q_rinvce.* without defaults from s_2invce.*
        on key (control-i)
            let return_flag = -1
             exit input
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(3)
        on key (control-f)
            # add/update user defined fields...
            call al_addlz("stxtranrAR",m_rinvce.doc_no,"-UNPOSTED","")
        on key (control-z)
            case
                when infield(cust_code)
                    let oldcust_code = q_rinvce.cust_code
                    let in_zoom = true
                    call ar_custz() returning q_rinvce.cust_code
                    if q_rinvce.cust_code is null
                    then
                        let q_rinvce.cust_code = oldcust_code
                    end if
                    display by name q_rinvce.cust_code
                    next field cust_code
                when infield(actgrp)
                    let oldactgrp = q_rinvce.actgrp
                    let in_zoom = true
                    call al_grp_z() returning q_rinvce.actgrp
                    if q_rinvce.actgrp is null
                    then
                        let q_rinvce.actgrp = oldactgrp
                    end if
                    display by name q_rinvce.actgrp
                    next field actgrp
                when infield(ref_no)
                    let oldref_no = q_rinvce.ref_no
                    call ar_openz(q_rinvce.cust_code)
                        returning q_rinvce.ref_no
                    if q_rinvce.ref_no is null
                    then
                        let q_rinvce.ref_no = oldref_no
                        display by name q_rinvce.ref_no
                    end if
                    next field ref_no
                when infield(misc_acct_no)
                    let oldacct_no = q_rinvce.misc_acct_no
                    let in_zoom = true
                    call al_chrtz() returning q_rinvce.misc_acct_no
                    if q_rinvce.misc_acct_no is null
                    then
                        let q_rinvce.misc_acct_no = oldacct_no
                    end if
                    display by name q_rinvce.misc_acct_no
                    next field misc_acct_no
                when infield(misc_department)
                    let olddepartment = q_rinvce.misc_department
                    call al_deptz() returning q_rinvce.misc_department
                    if q_rinvce.misc_department is null
                    then
                        let q_rinvce.misc_department = olddepartment
                    end if
                    display by name q_rinvce.misc_department
                    next field misc_department
                when infield(tax_acct_no)
                    let oldacct_no = q_rinvce.tax_acct_no
                    let in_zoom = true
                    call al_chrtz() returning q_rinvce.tax_acct_no
                    if q_rinvce.tax_acct_no is null
                    then
                        let q_rinvce.tax_acct_no = oldacct_no
                    end if
                    display by name q_rinvce.tax_acct_no
                    next field tax_acct_no
                when infield(tax_department)
                    let olddepartment = q_rinvce.tax_department
                    call al_deptz() returning q_rinvce.tax_department
                    if q_rinvce.tax_department is null
                    then
                        let q_rinvce.tax_department = olddepartment
                    end if
                    display by name q_rinvce.tax_department
                    next field tax_department
                when infield(frght_acct_no)
                    let oldacct_no = q_rinvce.frght_acct_no
                    let in_zoom = true
                    call al_chrtz() returning q_rinvce.frght_acct_no
                    if q_rinvce.frght_acct_no is null
                    then
                        let q_rinvce.frght_acct_no = oldacct_no
                    end if
                    display by name q_rinvce.frght_acct_no
                    next field frght_acct_no
                when infield(frght_department)
                    let olddepartment = q_rinvce.frght_department
                    call al_deptz() returning q_rinvce.frght_department
                    if q_rinvce.frght_department is null
                    then
                        let q_rinvce.frght_department = olddepartment
                    end if
                    display by name q_rinvce.frght_department
                    next field frght_department
                when infield(ar_acct_no)
                    let oldacct_no = q_rinvce.ar_acct_no
                    let in_zoom = true
                    call al_chrtz() returning q_rinvce.ar_acct_no
                    if q_rinvce.ar_acct_no is null
                    then
                        let q_rinvce.ar_acct_no = oldacct_no
                    end if
                    display by name q_rinvce.ar_acct_no
                    next field ar_acct_no
                when infield(ar_department)
                    let olddepartment = q_rinvce.ar_department
                    call al_deptz() returning q_rinvce.ar_department
                    if q_rinvce.ar_department is null
                    then
                        let q_rinvce.ar_department = olddepartment
                    end if
                    display by name q_rinvce.ar_department
                    next field ar_department
            end case
        before field cust_code
            if in_zoom
            then
                let in_zoom = false
            else
                let oldcust_code = q_rinvce.cust_code
            end if
        after field cust_code
            if q_rinvce.cust_code is null
            then
                call fg_err(1) # Customer code is required.
                next field cust_code
            end if
            if  oldcust_code = q_rinvce.cust_code
            then else
                call ar_custn(q_rinvce.cust_code)
                    returning q_rinvce.cust_name
                display by name q_rinvce.cust_name
                if q_rinvce.cust_name = "NOT FOUND"
                then
                    call fg_err(4) # Invalid Customer
                    let oldcust_code = null
                    let in_zoom = true
                    next field cust_code
                end if
                call chg_cust(q_rinvce.cust_code)
            end if
        before field file_type
            if q_rinvce.file_type is not null
            then
                let tmp_filetype = q_rinvce.file_type
            else
                let tmp_filetype = "x"
            end if
        after field file_type
            if q_rinvce.file_type is null
            then
                let q_rinvce.file_type = "I"
                display by name q_rinvce.file_type
            else
                if q_rinvce.file_type != "I" and
                   q_rinvce.file_type != "C" and
                   q_rinvce.file_type != "D" and
                   q_rinvce.file_type != "F"
                then
                    call fg_err(6) # Ref no must be a I, C, D or F
                    let q_rinvce.file_type = ""
                    display by name q_rinvce.file_type
                    next field file_type
                end if
                if q_rinvce.file_type !=  tmp_filetype
                then
                    if q_rinvce.file_type = "C" or tmp_filetype = "C"
                    then
                        call chg_dbcr()
                    end if
                end if
            end if
            case
                when q_rinvce.file_type = "C"
                    display " Credit" at 7,19
                when q_rinvce.file_type = "D"
                    display "  Debit" at 7,19
                otherwise
                    let q_rinvce.ref_no = null
                    display by name q_rinvce.ref_no
                    display "Invoice" at 7,19
            end case

        after field recurring
            let after_field = "I"

        before field ref_no
            if q_rinvce.file_type = "I"
            then
                if after_field = "I"
                then
                    next field tax
                end if
                if after_field = "D"
                then
                    next field recurring
                end if
            end if
        after field ref_no
            if q_rinvce.ref_no is not null
            then
                if ar_openc(q_rinvce.cust_code, q_rinvce.ref_no)
                then
                    call fg_err(7) # Invalid reference number
                    next field ref_no
                end if
            end if
        before field tax
            let oldtax = q_rinvce.tax
        after field tax
            let after_field = "D"
            if q_rinvce.tax is null
            then
                let q_rinvce.tax = "N"
                display by name q_rinvce.tax
                let p_rinvce.tax = q_rinvce.tax
            end if
            if q_rinvce.tax != oldtax or
                oldtax is null
            then
                if q_rinvce.tax = "N"
                then
                    let q_rinvce.tax_tmp = null
                end if
                if q_rinvce.tax != "N" and q_rinvce.tax != "Y"
                then 
                    call fg_err(12) # taxable must be a "N" or "Y"
                    next field tax
                end if
                let p_rinvce.tax = q_rinvce.tax
                call ar_total()
            end if
        before field actgrp
            if in_zoom
            then
                let in_zoom = false
            else
                let oldactgrp = q_rinvce.actgrp
            end if
        after field actgrp
            if q_rinvce.actgrp is null
            then
                let q_rinvce.actdesc = null
                display by name q_rinvce.actdesc
            end if
            if q_rinvce.actgrp = oldactgrp or q_rinvce.actgrp is null
            then else
                call fill_actgrp()
                if q_rinvce.actdesc = "NOT FOUND"
                then
                    call fg_err(10) # Warning:  Account group not found.
                    next field actgrp
                end if
            end if

        after field inv_date
            if q_rinvce.inv_date is null
            then
                let q_rinvce.inv_date = today
                display q_rinvce.inv_date to s_2invce.inv_date
                let old_inv_date = null
            end if
            if q_rinvce.posted is null
            then
                let q_rinvce.posted = "N"
                display q_rinvce.posted to s_2invce.posted
            end if
            if q_rinvce.due_date is null or
               q_rinvce.inv_date != old_inv_date or
               old_inv_date is null
            then
                let r_rinvce.terms_code = m_rcntrc.terms_code
                call ar_termn(r_rinvce.terms_code)
                    returning r_rinvce.terms, due_days,
                              disc_days, disc_pct
                let r_rinvce.due_date = q_rinvce.inv_date + due_days
                let q_rinvce.due_date = r_rinvce.due_date
                let q_rinvce.disc_date = q_rinvce.inv_date + disc_days
                let q_rinvce.disc_pct = disc_pct
                display by name q_rinvce.due_date,q_rinvce.disc_date,
                                q_rinvce.disc_pct
            end if
            let old_inv_date = q_rinvce.inv_date

        after field due_date
            if q_rinvce.due_date is null
            then
                let r_rinvce.terms_code = m_rcntrc.terms_code
                call ar_termn(r_rinvce.terms_code)
                    returning r_rinvce.terms, due_days,
                              disc_days, disc_pct
                let r_rinvce.due_date = q_rinvce.inv_date + due_days
                let q_rinvce.due_date = r_rinvce.due_date
                let q_rinvce.disc_date = q_rinvce.inv_date + disc_days
                let q_rinvce.disc_pct = disc_pct
                display by name q_rinvce.due_date,q_rinvce.disc_date,
                                q_rinvce.disc_pct
            end if

        before field misc_acct_no
            if in_zoom
            then
                let in_zoom = false
            else
                let oldacct_no = q_rinvce.misc_acct_no
            end if
        after field misc_acct_no
            if q_rinvce.misc_acct_no is null
            then
                let q_rinvce.misc_acct_no = m_rcntrc.ar_misc_acct_no
                let q_rinvce.misc_department = p_rinvce.department
                if q_rinvce.misc_department is null
                then
                    let q_rinvce.misc_department = "000"
                end if
                display by name q_rinvce.misc_acct_no,
                                q_rinvce.misc_department
            end if
            if q_rinvce.misc_acct_no = oldacct_no
            then else
                if q_rinvce.misc_acct_no is null
                then
                    let q_rinvce.misc_desc = null
                    let q_rinvce.misc_department = null
                    let q_rinvce.misc_tmp = null
                    call ar_total()
                    display by name q_rinvce.misc_desc,
                        q_rinvce.misc_department
                else
                    call al_chrtn(q_rinvce.misc_acct_no)
                        returning description, db_cr
                    if description = "NOT FOUND"
                    then
                        call fg_err(11) # Account number has not been defined
                        call ar_total()
                        let oldacct_no = null
                        let in_zoom = true
                        next field misc_acct_no
                    else
                        let q_rinvce.misc_desc = description
                    end if
                    display by name q_rinvce.misc_desc
                end if
            end if
        before field misc_department
            if q_rinvce.misc_acct_no is not null and al_deptc()
            then
                let q_rinvce.misc_department = "000"
                display by name q_rinvce.misc_department
            end if
        after field misc_department
            if q_rinvce.misc_acct_no is null
            then
                let q_rinvce.misc_department = null
            else
                if q_rinvce.misc_department is null
                then
                    let q_rinvce.misc_department = "000"
                end if
            end if
            display by name q_rinvce.misc_department
            if q_rinvce.misc_department is not null and
               q_rinvce.misc_department != "000"
            then
                call al_deptn(q_rinvce.misc_department)
                   returning description
                if description = "NOT FOUND"
                then
                    call fg_err(3) #  Department code has not been defined
                    next field misc_department
                end if
            end if
        before field misc_tmp
            let oldamount = q_rinvce.misc_tmp
        after field misc_tmp
            let q_rinvce.misc_tmp = al_round( "a", q_rinvce.misc_tmp ) 
            call ar_total()
        after field disc_pct
            let q_rinvce.disc_pct = absolute(q_rinvce.disc_pct)
            let q_rinvce.disc_pct = al_round("e", q_rinvce.disc_pct)
        before field tax_acct_no
            if in_zoom
            then
                let in_zoom = false
            else
                let oldacct_no = q_rinvce.tax_acct_no
            end if
        after field tax_acct_no
            if q_rinvce.tax_acct_no is null
            then
                let q_rinvce.tax_acct_no = m_rcntrc.ar_tax_acct_no
                let q_rinvce.tax_department = p_rinvce.department
                if q_rinvce.tax_department is null
                then
                    let q_rinvce.tax_department = "000"
                end if
                display by name q_rinvce.tax_acct_no,
                                q_rinvce.tax_department
            end if
            if q_rinvce.tax_acct_no = oldacct_no
            then else
                if q_rinvce.tax_acct_no is null
                then
                    let q_rinvce.tax_desc = null
                    let q_rinvce.tax_department = null
                    let q_rinvce.tax_tmp = null
                    call ar_total()
                    display by name q_rinvce.tax_desc,
                        q_rinvce.tax_department
                else
                    call al_chrtn(q_rinvce.tax_acct_no)
                        returning description, db_cr
                    if description = "NOT FOUND"
                    then
                        call fg_err(11) # Account number has not been defined
                        call ar_total()
                        let oldacct_no = null
                        let in_zoom = true
                        next field tax_acct_no
                    else
                        let q_rinvce.tax_desc = description
                    end if
                    display by name q_rinvce.tax_desc
                end if
            end if
        before field tax_department
            if q_rinvce.tax_acct_no is not null and al_deptc()
            then
                let q_rinvce.tax_department = "000"
                display by name q_rinvce.tax_department
            end if
        after field tax_department
            let after_field = "T"
            if q_rinvce.tax_acct_no is null
            then
                let q_rinvce.tax_department = null
            else
                if q_rinvce.tax_department is null
                then
                    let q_rinvce.tax_department = "000"
                end if
            end if
            display by name q_rinvce.tax_department
            if q_rinvce.tax_department is not null and
               q_rinvce.tax_department != "000"
            then
                call al_deptn(q_rinvce.tax_department)
                   returning description
                if description = "NOT FOUND"
                then
                    call fg_err(3) #  Department code has not been defined
                    next field tax_department
                end if
            end if
        before field tax_tmp
            if q_rinvce.tax = "Y"
            then
                if after_field = "T"
                then
                    next field ar_acct_no
                end if
                if after_field = "A"
                then
                    next field tax_department
                end if
            end if
        after field tax_tmp
            let q_rinvce.tax_tmp = al_round( "a", q_rinvce.tax_tmp ) 
            call ar_total()
        before field frght_acct_no
            if in_zoom
            then
                let in_zoom = false
            else
                let oldacct_no = q_rinvce.frght_acct_no
            end if
        after field frght_acct_no
            if q_rinvce.frght_acct_no is null
            then
                let q_rinvce.frght_acct_no = m_rcntrc.ar_frght_acct_no
                let q_rinvce.frght_department = p_rinvce.department
                if q_rinvce.frght_department is null
                then
                    let q_rinvce.frght_department = "000"
                end if
                display by name q_rinvce.frght_acct_no,
                                q_rinvce.frght_department
            end if
            if q_rinvce.frght_acct_no = oldacct_no
            then else
                if q_rinvce.frght_acct_no is null
                then
                    let q_rinvce.frght_desc = null
                    let q_rinvce.frght_department = null
                    let q_rinvce.frght_tmp = null
                    call ar_total()
                    display by name q_rinvce.frght_desc,
                        q_rinvce.frght_department
                else
                    call al_chrtn(q_rinvce.frght_acct_no)
                        returning description, db_cr
                    if description = "NOT FOUND"
                    then
                        call fg_err(11) # Account number has not been defined
                        call ar_total()
                        let oldacct_no = null
                        let in_zoom = true
                        next field frght_acct_no
                    else
                        let q_rinvce.frght_desc = description
                    end if
                    display by name q_rinvce.frght_desc
                end if
            end if
        before field frght_department
            if q_rinvce.frght_acct_no is not null and al_deptc()
            then
                let q_rinvce.frght_department = "000"
                display by name q_rinvce.frght_department
            end if
        after field frght_department
            if q_rinvce.frght_acct_no is null
            then
                let q_rinvce.frght_department = null
            else
                if q_rinvce.frght_department is null
                then
                    let q_rinvce.frght_department = "000"
                end if
            end if
            display by name q_rinvce.frght_department
            if q_rinvce.frght_department is not null and
               q_rinvce.frght_department != "000"
            then
                call al_deptn(q_rinvce.frght_department)
                   returning description
                if description = "NOT FOUND"
                then
                    call fg_err(3) #  Department code has not been defined
                    next field frght_department
                end if
            end if
        after field frght_tmp
            let q_rinvce.frght_tmp = al_round( "a", q_rinvce.frght_tmp ) 
            call ar_total()
        before field ar_acct_no
            if in_zoom
            then
                let in_zoom = false
            else
                let oldacct_no = q_rinvce.ar_acct_no
            end if
        after field ar_acct_no
            let after_field = "A"
            if q_rinvce.ar_acct_no is null
            then
                let q_rinvce.ar_acct_no = m_rcntrc.ar_acct_no
                let q_rinvce.ar_department = p_rinvce.department
                if q_rinvce.ar_department is null
                then
                    let q_rinvce.ar_department = "000"
                end if
                display by name q_rinvce.ar_acct_no,
                                q_rinvce.ar_department
            end if
            if q_rinvce.ar_acct_no = oldacct_no
            then else
                if q_rinvce.ar_acct_no is null
                then
                    let q_rinvce.ar_desc = null
                    let q_rinvce.ar_department = null
                    let q_rinvce.ar_tmp = null
                    call ar_total()
                    display by name q_rinvce.ar_desc,
                        q_rinvce.ar_department
                else
                    call al_chrtn(q_rinvce.ar_acct_no)
                        returning description, db_cr
                    if description = "NOT FOUND"
                    then
                        call fg_err(11) # Account number has not been defined
                        call ar_total()
                        let oldacct_no = null
                        let in_zoom = true
                        next field ar_acct_no
                    else
                        let q_rinvce.ar_desc = description
                    end if
                    display by name q_rinvce.ar_desc
                end if
            end if
        before field ar_department
            if q_rinvce.ar_acct_no is not null and al_deptc()
            then
                let q_rinvce.ar_department = "000"
                display by name q_rinvce.ar_department
            end if
        after field ar_department
            if q_rinvce.ar_acct_no is null
            then
                let q_rinvce.ar_department = null
            else
                if q_rinvce.ar_department is null
                then
                    let q_rinvce.ar_department = "000"
                end if
            end if
            display by name q_rinvce.ar_department
            if q_rinvce.ar_department is not null and
               q_rinvce.ar_department != "000"
            then
                call al_deptn(q_rinvce.ar_department)
                   returning description
                if description = "NOT FOUND"
                then
                    call fg_err(3) #  Department code has not been defined
                    next field ar_department
                end if
            end if

    end input
    return return_flag

end function
# q_input()

#######################################################################
function llh_q_r()
#######################################################################
#
# converts q record fields to r record fields
#
    let r_rinvce.inv_date = q_rinvce.inv_date
    let r_rinvce.ref_no = q_rinvce.ref_no
    let r_rinvce.tax = q_rinvce.tax
    let r_rinvce.file_type = q_rinvce.file_type
    let r_rinvce.cust_code = q_rinvce.cust_code
    let r_rinvce.cust_name = q_rinvce.cust_name
    let r_rinvce.inv_no = q_rinvce.inv_no
    let r_rinvce.inv_desc = q_rinvce.inv_desc
    let r_rinvce.posted = q_rinvce.posted
    let r_rinvce.recurring = q_rinvce.recurring
    let r_rinvce.misc_tmp = q_rinvce.misc_tmp
    let r_rinvce.tax_tmp = q_rinvce.tax_tmp
    let r_rinvce.frght_tmp = q_rinvce.frght_tmp
    let r_rinvce.ar_tmp = q_rinvce.ar_tmp
    let r_rinvce.due_date = q_rinvce.due_date
end function
# llh_q_r()

