########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_invce.4gs/inputh3.4gl  1.13  Delta: 8/31/90
########################################################################

globals "globals.4gl"

########################################################################
function credit_amount(debit_credit, amount)
########################################################################
#
# this function is used to change the amount to a negative if the
#     the line is not a credit type
#
    define
        debit_credit char(2),
        amount       like strinvcd.amount

    if debit_credit != "CR" and p_rinvce.file_type != "C"
    then
        let amount = amount * -1
    end if
    if debit_credit = "CR" and  p_rinvce.file_type = "C"
    then
        let amount = amount * -1
    end if
    return amount
end function
# credit_amount()

########################################################################
function debit_amount(debit_credit, amount)
########################################################################
#
# this function is used to change the amount to a negative if the
#    increase with a credit field is not the same as the debit_credit
#    field.
#
    define
        debit_credit char(2),
        amount       like strinvcd.amount

    if debit_credit != "DB" and p_rinvce.file_type != "C"
    then
        let amount = amount * -1
    end if
    if debit_credit = "DB" and  p_rinvce.file_type = "C"
    then
        let amount = amount * -1
    end if
    return amount
end function
# debit_amount()

########################################################################
function switch_credit(amount, file_type)
# returns the credit type
########################################################################
#
# this function switches

    define
        amount       like strinvcd.amount,
        file_type    char(1),
        db_cr char(2)

    let db_cr = "CR"
    if amount < 0 and file_type != "C"
    then
       let db_cr = "DB"
    end if
    if amount > 0 and file_type = "C"
    then
       let db_cr = "DB"
    end if

    return db_cr
end function
# switch_credit()

########################################################################
function switch_debit(amount, file_type)
# returns the credit type
########################################################################
#
# this function switches

    define
        amount       like strinvcd.amount,
        file_type    char(1),
        db_cr char(2)

    let db_cr = "DB"
    if amount < 0 and file_type != "C"
    then
       let db_cr = "CR"
    end if
    if amount > 0 and file_type = "C"
    then
       let db_cr = "CR"
    end if

    return db_cr
end function
# switch_debit()

########################################################################
function set_misc_line()
########################################################################
#
# converts the misc amount to the accounting format
#
    define
        db_cr char(2)

    if q_rinvce.misc_acct_no is null
    then
        let q_rinvce.misc_acct_no = m_rcntrc.ar_misc_acct_no
        let q_rinvce.misc_department = r_rinvce.department
        call al_chrtn(q_rinvce.misc_acct_no)
            returning q_rinvce.misc_desc, db_cr
    end if
    if curr_form = 1
    then
        let q_rinvce.misc_tmp = r_rinvce.misc_tmp
    else
        let r_rinvce.misc_tmp = q_rinvce.misc_tmp
    end if
    call switch_credit(q_rinvce.misc_tmp,q_rinvce.file_type)
        returning q_rinvce.misc_debit_credit
    let q_rinvce.misc_amount = absolute(q_rinvce.misc_tmp)
end function
# set_misc_line()

########################################################################
function set_tax_line()
########################################################################
#
# converts the tax amount to the accounting format
#
    define db_cr char(2)

    if q_rinvce.tax_acct_no is null
    then
        let q_rinvce.tax_acct_no = m_rcntrc.ar_tax_acct_no
        let q_rinvce.tax_department = r_rinvce.department
        call al_chrtn(q_rinvce.tax_acct_no)
            returning q_rinvce.tax_desc, db_cr
    end if
    if curr_form = 1
    then
        let q_rinvce.tax_tmp = r_rinvce.tax_tmp
    else
        let r_rinvce.tax_tmp = q_rinvce.tax_tmp
    end if
    call switch_credit(q_rinvce.tax_tmp,q_rinvce.file_type)
        returning q_rinvce.tax_debit_credit
    let q_rinvce.tax_amount = absolute(q_rinvce.tax_tmp)

end function
# set_tax_line()

########################################################################
function set_frght_line()
########################################################################
#
# converts the freight amount to the accounting format
#
    define db_cr char(2)

    if q_rinvce.frght_acct_no is null
    then
        let q_rinvce.frght_acct_no = m_rcntrc.ar_frght_acct_no
        let q_rinvce.frght_department = r_rinvce.department
        call al_chrtn(q_rinvce.frght_acct_no)
            returning q_rinvce.frght_desc, db_cr
    end if
    if curr_form = 1
    then
        let q_rinvce.frght_tmp = r_rinvce.frght_tmp
    else
        let r_rinvce.frght_tmp = q_rinvce.frght_tmp
    end if
    call switch_credit(q_rinvce.frght_tmp,q_rinvce.file_type)
        returning q_rinvce.frght_debit_credit
    let q_rinvce.frght_amount = absolute(q_rinvce.frght_tmp)

end function
# set_frght_line()

########################################################################
function set_ar_line()
########################################################################
#
# converts the ar amount to the accounting format
#
    define db_cr char(2)

    if q_rinvce.ar_acct_no is null
    then
        let q_rinvce.ar_acct_no = m_rcntrc.ar_acct_no
        let q_rinvce.ar_department = r_rinvce.department
        call al_chrtn(q_rinvce.ar_acct_no)
            returning q_rinvce.ar_desc, db_cr
    end if
    if curr_form = 1
    then
        let q_rinvce.ar_tmp = r_rinvce.ar_tmp
    else
        let r_rinvce.ar_tmp = q_rinvce.ar_tmp
    end if
    call switch_debit(q_rinvce.ar_tmp,q_rinvce.file_type)
        returning q_rinvce.ar_debit_credit
    let q_rinvce.ar_amount = absolute(q_rinvce.ar_tmp)

end function
# set_ar_line()

########################################################################
function ar_total()
########################################################################
#
#  Accumulates the various totals to produce the a/r total
#
    if p_rinvce.sub_total is null
    then
        let p_rinvce.sub_total = 0
    end if

    call tax_total()
    if curr_form = 1
    then
        if r_rinvce.misc_tmp is null
        then
            let r_rinvce.misc_tmp = 0
            display by name r_rinvce.misc_tmp
        end if
        if r_rinvce.tax_tmp is null
        then
            let r_rinvce.tax_tmp = 0
            display by name r_rinvce.tax_tmp
        end if
        if r_rinvce.frght_tmp is null
        then
            let r_rinvce.frght_tmp = 0
            display by name r_rinvce.frght_tmp
        end if
        let r_rinvce.ar_tmp = p_rinvce.sub_total + r_rinvce.misc_tmp +
                       r_rinvce.tax_tmp + r_rinvce.frght_tmp
        display by name r_rinvce.ar_tmp
     else
        if q_rinvce.misc_tmp is null
        then
            let q_rinvce.misc_tmp = 0
            display by name q_rinvce.misc_tmp
        end if
        if q_rinvce.tax_tmp is null
        then
            let q_rinvce.tax_tmp = 0
            display by name q_rinvce.tax_tmp
        end if
        if q_rinvce.frght_tmp is null
        then
            let q_rinvce.frght_tmp = 0
            display by name q_rinvce.frght_tmp
        end if
        call switch_credit(q_rinvce.misc_tmp,q_rinvce.file_type)
            returning q_rinvce.misc_debit_credit
        let q_rinvce.misc_amount = absolute(q_rinvce.misc_tmp)
        call switch_credit(q_rinvce.tax_tmp,q_rinvce.file_type)
            returning q_rinvce.tax_debit_credit
        let q_rinvce.tax_amount = absolute(q_rinvce.tax_tmp)
        call switch_credit(q_rinvce.frght_tmp,q_rinvce.file_type)
            returning q_rinvce.frght_debit_credit
        let q_rinvce.frght_amount = absolute(q_rinvce.frght_tmp)
        let q_rinvce.ar_tmp = p_rinvce.sub_total + q_rinvce.misc_tmp +
                       q_rinvce.tax_tmp + q_rinvce.frght_tmp
        call switch_debit(q_rinvce.ar_tmp,q_rinvce.file_type)
            returning q_rinvce.ar_debit_credit
        let q_rinvce.ar_amount =  absolute(q_rinvce.ar_tmp)
        display by name q_rinvce.ar_tmp, q_rinvce.ar_amount,
                        q_rinvce.ar_debit_credit,
                        q_rinvce.misc_tmp, q_rinvce.misc_amount,
                        q_rinvce.misc_debit_credit,
                        q_rinvce.tax_tmp, q_rinvce.tax_amount,
                        q_rinvce.tax_debit_credit,
                        q_rinvce.frght_tmp, q_rinvce.frght_amount,
                        q_rinvce.frght_debit_credit
    end if

end function
# ar_total()

############################################################
function fill_actgrp()
############################################################
# select distributions from the general distribution file
#
    define
        tmp_line_no   smallint,
        counter   smallint

    call al_grp_n(q_rinvce.actgrp) returning q_rinvce.actdesc
    if q_rinvce.actdesc = "NOT FOUND"
    then
        display by name q_rinvce.actdesc
        return
    end if

    display by name q_rinvce.actdesc
    for counter = 1 to scr2_max
        clear s_2invcd[counter].*
    end for

    for counter = 1 to rec1_max
        initialize q_rinvcd[counter].* to null
    end for

    let counter = 1

    declare j_curs cursor for
        select line_no, acct_no, department
            from stxactgd
                where stxactgd.grp_key = q_rinvce.actgrp
                     order by line_no

    foreach j_curs into tmp_line_no,
                        q_rinvcd[counter].acct_no,
                        q_rinvcd[counter].department

        call al_chrtn(q_rinvcd[counter].acct_no)
                         returning q_rinvcd[counter].description,
                                   q_rinvcd[counter].debit_credit
        let q_rinvcd[counter].tmp_amount = 0
        let q_rinvcd[counter].amount = 0
        call switch_credit(q_rinvcd[counter].tmp_amount,q_rinvce.file_type)
                  returning q_rinvcd[counter].debit_credit

        let counter = counter + 1

    end foreach

    let rec1_cnt = counter - 1
    call set_count(rec1_cnt)

    call lld_recalc()
    call lld_display()

end function
# fill_actgrp()

########################################################################
function tax_able(cust_code,ship_code)
########################################################################
#
# determine if items are taxable.
#

    define
        cust_code like strcustr.cust_code,
        ship_code like strshipr.ship_to_code

    whenever error continue
    select strshipr.taxable into p_rinvce.tax
        from strshipr
            where strshipr.cust_code = cust_code and
                  strshipr.ship_to_code = ship_code

    if sqlca.sqlcode != 0
    then
        select strcustr.taxable into p_rinvce.tax
            from strcustr
                where strcustr.cust_code = cust_code
    end if
    if sqlca.sqlcode != 0
    then
        let sqlca.sqlcode = 0
    end if
    whenever error call error_handler

    if p_rinvce.tax is null
     then
         let p_rinvce.tax = "N" end if
    let q_rinvce.tax = p_rinvce.tax
    let r_rinvce.tax = p_rinvce.tax
    call ar_total()

end function
# tax_able()

########################################################################
function chg_cust(cust_code)
########################################################################
#
# change customer process which set the terms, ar account to use
# the department the customer is in, and account grouping use
# by the customer
#

    define
        db_cr char(1),
        description char(20),
        cust_code like strcustr.cust_code,
        counter smallint,
        due_days like strtermr.due_days,
        disc_days like strtermr.disc_days,
        disc_pct like strtermr.disc_pct,
        tmpterms_code like strtermr.terms_code

    let q_rinvce.ref_no = null
    let r_rinvce.ref_no = null
    select strcustr.terms_code, strcustr.act_grp,
           strcustr.ar_acct_dflt, strcustr.ar_department_dflt
        into tmpterms_code, q_rinvce.actgrp,
             q_rinvce.ar_acct_no, q_rinvce.ar_department
        from strcustr
            where strcustr.cust_code = cust_code
    if q_rinvce.ar_department is null
    then
        let q_rinvce.ar_department = "000"
    end if
    let r_rinvce.department = q_rinvce.ar_department
    let p_rinvce.department = q_rinvce.ar_department
    if q_rinvce.ar_acct_no is null
    then
        let q_rinvce.ar_acct_no = m_rcntrc.ar_acct_no
    end if
    call al_chrtn(q_rinvce.ar_acct_no)
        returning q_rinvce.ar_desc, q_rinvce.ar_debit_credit
    if tmpterms_code is not null
    then
        let r_rinvce.terms_code = tmpterms_code
        call ar_termn(r_rinvce.terms_code)
        returning r_rinvce.terms, due_days, disc_days, disc_pct
        if curr_form = 1
        then
            let r_rinvce.due_date = r_rinvce.inv_date + due_days
            let q_rinvce.due_date = r_rinvce.due_date
            let q_rinvce.disc_date = r_rinvce.inv_date + disc_days
        else
            let r_rinvce.due_date = q_rinvce.inv_date + due_days
            let q_rinvce.due_date = r_rinvce.due_date
            let q_rinvce.disc_date = q_rinvce.inv_date + disc_days
        end if
        let q_rinvce.disc_pct = disc_pct
    end if
    if q_rinvce.actgrp is not null and curr_form = 2
    then
        call fill_actgrp()
        for counter = 1 to rec1_max
            let r_rinvcd[counter].description =
                q_rinvcd[counter].description
            let r_rinvcd[counter].tmp_amount =
                q_rinvcd[counter].tmp_amount
        end for
    end if

    if q_rinvce.misc_acct_no is null
    then
        let q_rinvce.misc_acct_no = m_rcntrc.ar_misc_acct_no
        let q_rinvce.misc_department = p_rinvce.department
    end if
    call al_chrtn(q_rinvce.misc_acct_no)
        returning description, db_cr
    if description = "NOT FOUND"
    then
        let q_rinvce.misc_desc = null
    else
        let q_rinvce.misc_desc = description
    end if

    if q_rinvce.frght_acct_no is null
    then
        let q_rinvce.frght_acct_no = m_rcntrc.ar_frght_acct_no
        let q_rinvce.frght_department = p_rinvce.department
    end if
    call al_chrtn(q_rinvce.frght_acct_no)
        returning description, db_cr
    if description = "NOT FOUND"
    then
        let q_rinvce.frght_desc = null
    else
        let q_rinvce.frght_desc = description
    end if

    if q_rinvce.tax_acct_no is null
    then
        let q_rinvce.tax_acct_no = m_rcntrc.ar_tax_acct_no
        let q_rinvce.tax_department = p_rinvce.department
    end if
    call al_chrtn(q_rinvce.tax_acct_no)
        returning description, db_cr
    if description = "NOT FOUND"
    then
        let q_rinvce.tax_desc = null
    else
        let q_rinvce.tax_desc = description
    end if

    if curr_form = 1
    then
        let r_rinvce.ship_to_code = null
    else
        let r_rinvce.ship_to_code = "SHIPTO"
        call tax_able(q_rinvce.cust_code,r_rinvce.ship_to_code)
    end if
    call llh_display()
    call lld_display()

end function
# chg_cust()

########################################################################
function tax_total()
########################################################################
#
# calculate the tax total
#
    define
        scratch char(15)

    if m_rcntrc.tax_pct is null
    then
        let m_rcntrc.tax_pct = 0
    end if
    if p_rinvce.sub_total is null
    then
        let p_rinvce.sub_total = 0
    end if

    if p_rinvce.tax = "Y"
    then
        if curr_form = 1
        then
            let r_rinvce.tax_tmp = al_round( "a",
                p_rinvce.sub_total * m_rcntrc.tax_pct / 100 )
        else
            let q_rinvce.tax_tmp = al_round( "a",
                p_rinvce.sub_total * m_rcntrc.tax_pct / 100 )
        end if
    end if
    call set_tax_line()
    if q_rinvce.tax_department is null
    then
        let q_rinvce.tax_department = "000"
    end if

    if curr_form = 1
    then
        display by name r_rinvce.tax_tmp, r_rinvce.tax
    else
        display by name q_rinvce.tax_acct_no,q_rinvce.tax_department,
                        q_rinvce.tax_desc,q_rinvce.tax_tmp,
                        q_rinvce.tax_amount,q_rinvce.tax_debit_credit,
                        q_rinvce.tax
    end if

end function
# tax_total()

########################################################################
function chg_dbcr()
########################################################################
#
# change all debits to credits and vice versa
#
    define counter smallint

    for counter = 1 to rec1_max
        if q_rinvcd[counter].debit_credit is not null
        then
            let q_rinvcd[counter].debit_credit =
                switch_db_cr(q_rinvcd[counter].debit_credit)
        end if
    end for
    if q_rinvce.misc_debit_credit is not null
    then
        let q_rinvce.misc_debit_credit =
            switch_db_cr(q_rinvce.misc_debit_credit)
    end if
    if q_rinvce.tax_debit_credit is not null
    then
        let q_rinvce.tax_debit_credit =
            switch_db_cr(q_rinvce.tax_debit_credit)
    end if
    if q_rinvce.frght_debit_credit is not null
    then
        let q_rinvce.frght_debit_credit =
            switch_db_cr(q_rinvce.frght_debit_credit)
    end if
    if q_rinvce.ar_debit_credit is not null
    then
        let q_rinvce.ar_debit_credit =
            switch_db_cr(q_rinvce.ar_debit_credit)
    end if
    call llh_display()
    call lld_display()
end function
# chg_dbcr()

########################################################################
function switch_db_cr(dbcr)
########################################################################
#
# if dbcr is a CR the function returns a DB
# if dbcr is a DB the function returns a CR
#

    define dbcr char(2)

    if dbcr = "DB"
    then
         let dbcr = "CR"
    else
         let dbcr = "DB"
    end if
    return dbcr
end function
# switch_db_cr()

