########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_opend.4gs/header.4gl  1.15  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    define
        scratch                 char(10),
        old_cust_code           like strcustr.cust_code,
        generic_desc            char(10),
        old_on_acct             like strcustr.on_acct_amt,
        old_balance             like stropend.balance,
        old_acct_no             like stropend.ar_acct_no,
        old_department          like stropend.ar_department,
        in_zoom                 smallint

    if p_ropend.doc_no is null
    then
        let p_ropend.doc_no = auto_next("strcntrc","ar_doc_no")
    end if

    let in_zoom = false
    input p_ropend.* without defaults from s_ropend.*
      on key (control-e)
        call fg_err(0)
      on key (control-w)
        call fg_help(1)
      on key (control-f)
        # add/update user defined fields...
        call al_addlz("stxtranrAR",p_ropend.doc_no,"","")
      on key (control-z)
        case
          when infield(cust_code)
            let in_zoom = true
            let old_cust_code = p_ropend.cust_code
            call ar_custz() returning p_ropend.cust_code
            if p_ropend.cust_code is null
              then let p_ropend.cust_code = old_cust_code end if
            display by name p_ropend.cust_code
            next field cust_code
          when infield(ar_acct_no)
            let old_acct_no = p_ropend.ar_acct_no
            call al_chrtz() returning p_ropend.ar_acct_no
            if p_ropend.ar_acct_no is null
              then let p_ropend.ar_acct_no = old_acct_no end if
            display by name p_ropend.ar_acct_no
            next field ar_acct_no
          when infield(ar_department)
            let old_department = p_ropend.ar_department
            call al_deptz() returning p_ropend.ar_department
            if p_ropend.ar_department is null
              then let p_ropend.ar_department = old_department end if
            display by name p_ropend.ar_department
            next field ar_department
        end case
      before field cust_code
        if in_zoom
          then let in_zoom = false
          else let old_cust_code = p_ropend.cust_code
        end if
      after field cust_code
        if p_ropend.cust_code is null
        then
            call fg_err(1) # Customer code must be entered
            let p_ropend.cust_code = old_cust_code
            next field cust_code
        end if
        if new_item or old_cust_code = p_ropend.cust_code
        then else
            call fg_err(2) # Customer code may not be changed
            let p_ropend.cust_code = old_cust_code
            display by name p_ropend.cust_code
        end if
        if new_item and (old_cust_code != p_ropend.cust_code or
            old_cust_code is null)
        then
            call get_cust()
            if sqlca.sqlcode = notfound
            then
                let sqlca.sqlcode = 0
                call fg_err(3) # Invalid customer code
                let p_ropend.cust_code = old_cust_code
                display by name p_ropend.cust_code
                next field cust_code
            end if
            call mlh_cust_lock()
            if sqlca.sqlcode != 0
            then
                let sqlca.sqlcode = 0
                call fg_err(10) # Customer is currently being updated.
                let p_ropend.cust_code = old_cust_code
                display by name p_ropend.cust_code
                next field cust_code
            end if
            if p_ropend.balance is not null
            then
                let p_ropend.acct_bal = p_ropend.acct_bal +
                    p_ropend.balance
            end if
            display by name p_ropend.*
        end if
      after field ar_acct_no
        if p_ropend.ar_acct_no is not null
        then
            call al_chrtn(p_ropend.ar_acct_no) returning
                generic_desc, scratch
            if generic_desc = "NOT FOUND"
            then
                call fg_err(4) # Invalid account number
                next field ar_acct_no
            end if
        end if
      after field ar_department
        if p_ropend.ar_department is not null
        then
            call al_deptn(p_ropend.ar_department) returning
                generic_desc
            if generic_desc = "NOT FOUND"
            then
                call fg_err(5) # Invalid department code
                next field ar_department
            end if
        end if
      before field on_acct_amt
        if p_ropend.on_acct_amt is null
        then
            let p_ropend.on_acct_amt = 0
            display by name p_ropend.on_acct_amt
        end if
        let old_on_acct = p_ropend.on_acct_amt
      after field on_acct_amt
        let p_ropend.on_acct_amt = al_round( "a",
            p_ropend.on_acct_amt )
        if p_ropend.acct_bal is null
          then let p_ropend.acct_bal = 0 end if
        if p_ropend.on_acct_amt is null
        then
            let p_ropend.on_acct_amt = 0
            display by name p_ropend.on_acct_amt
        end if
        let p_ropend.acct_bal = p_ropend.acct_bal - old_on_acct +
            p_ropend.on_acct_amt
        display by name p_ropend.acct_bal
      after field orig_amount
        let p_ropend.orig_amount = al_round("a", p_ropend.orig_amount)
        call amount_validate(1)
      after field disc_amt
        let p_ropend.disc_amt = al_round("a", p_ropend.disc_amt)
        call amount_validate(2)
      before field balance
        if p_ropend.balance is null
          then let old_balance = 0
          else let old_balance = p_ropend.balance
        end if
      after field balance
        let p_ropend.balance = al_round("a", p_ropend.balance)
        if p_ropend.balance is null then let p_ropend.balance = 0 end if
        let p_ropend.acct_bal = p_ropend.acct_bal - old_balance +
            p_ropend.balance
        call amount_validate(3)
      after field disc_bal
        let p_ropend.disc_bal = al_round("a", p_ropend.disc_bal)
        call amount_validate(4)
      after input
        if new_item and int_flag then call mlh_cust_unlock() end if
        if not int_flag
        then
            call amount_validate(5)
            if mustfill(p_ropend.inv_no,"Invoice number")
              then next field inv_no end if
            if mustfill(p_ropend.inv_date,"Invoice date")
              then next field inv_date end if
            if mustfill(p_ropend.due_date,"Invoice due date")
              then next field due_date end if
        end if
    end input
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    display p_ropend.* to s_ropend.*
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    let p_ropend.cust_code = m_ropend.cust_code
    if p_ropend.cust_code is not null
    then
        call get_cust()
    end if
    let p_ropend.inv_no = m_ropend.inv_no
    let p_ropend.doc_no = m_ropend.doc_no
    let p_ropend.inv_desc = m_ropend.inv_desc
    let p_ropend.inv_date = m_ropend.inv_date
    let p_ropend.orig_amount = m_ropend.orig_amount
    let p_ropend.disc_amt = m_ropend.disc_amt
    let p_ropend.balance = m_ropend.balance
    let p_ropend.disc_bal = m_ropend.disc_bal
    let p_ropend.due_date = m_ropend.due_date
    let p_ropend.disc_date = m_ropend.disc_date
    let p_ropend.ar_acct_no = m_ropend.ar_acct_no
    let p_ropend.ar_department = m_ropend.ar_department
    let p_ropend.po_no = m_ropend.po_no
    let p_ropend.po_date = m_ropend.po_date
end function
# llh_p_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    let m_ropend.cust_code = p_ropend.cust_code
    let m_ropend.inv_no = p_ropend.inv_no
    let m_ropend.doc_no = p_ropend.doc_no
    let m_ropend.inv_desc = p_ropend.inv_desc
    let m_ropend.inv_date = p_ropend.inv_date
    let m_ropend.orig_amount = p_ropend.orig_amount
    if p_ropend.disc_amt is null
      then let p_ropend.disc_amt = 0 end if
    let m_ropend.disc_amt = p_ropend.disc_amt
    let m_ropend.balance = p_ropend.balance
    if p_ropend.disc_bal is null
      then let p_ropend.disc_bal = 0 end if
    let m_ropend.disc_bal = p_ropend.disc_bal
    let m_ropend.due_date = p_ropend.due_date
    if p_ropend.disc_date is null
      then let p_ropend.disc_date = p_ropend.due_date end if
    let m_ropend.disc_date = p_ropend.disc_date
    if p_ropend.ar_acct_no is null
      then let p_ropend.ar_acct_no = ar_acct_no end if
    if p_ropend.ar_acct_no is null
    then
        select * into m_rcntrc.* from strcntrc
        let p_ropend.ar_acct_no = m_rcntrc.ar_acct_no
    end if
    let m_ropend.ar_acct_no = p_ropend.ar_acct_no
    if p_ropend.ar_department is null
      then let p_ropend.ar_department = ar_department end if
    if p_ropend.ar_department is null
      then let p_ropend.ar_department = "000" end if
    let m_ropend.ar_department = p_ropend.ar_department
    let m_ropend.po_no = p_ropend.po_no
    let m_ropend.po_date = p_ropend.po_date
    if m_ropend.item_type is null then let m_ropend.item_type = "IN" end if
    call llh_display()
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_ropend.* from stropend where rowid = ring_rowid
    whenever error call error_handler
    if sqlca.sqlcode != 0 then return end if
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed

    update strcustr set acct_bal = p_ropend.acct_bal - p_ropend.balance
        where rowid = cust_rowid

    delete from stropend
        where rowid = ring_rowid

    # delete user defined fields
    if sqlca.sqlcode = 0
      then call al_addld("stxtranrAR",p_ropend.doc_no) end if
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    update strcustr
      set
        on_acct_amt = p_ropend.on_acct_amt,
        acct_bal    = p_ropend.acct_bal,
        stmt_date   = 1,
        stmt_amount = p_rcustr.on_acct_amt
      where rowid = cust_rowid
    if sqlca.sqlcode = 0
    then
        call mlh_cust_unlock()
        if  m_ropend.inv_no is not null or
            m_ropend.doc_no is not null or
            m_ropend.inv_desc is not null or
            m_ropend.inv_date is not null or
            m_ropend.orig_amount is not null or
            m_ropend.disc_amt is not null or
            m_ropend.balance is not null or
            m_ropend.disc_bal is not null or
            m_ropend.due_date is not null or
            m_ropend.disc_date is not null or
            m_ropend.ar_acct_no is not null or
            m_ropend.ar_department is not null or
            m_ropend.po_no is not null or
            m_ropend.po_date is not null
        then
            insert into stropend values(m_ropend.*)
        end if
    end if
    whenever error call error_handler
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    whenever error continue
    update strcustr
      set
        on_acct_amt = p_ropend.on_acct_amt,
        acct_bal    = p_ropend.acct_bal,
        stmt_date   = 1,
        stmt_amount = p_rcustr.on_acct_amt
      where rowid = cust_rowid

    if sqlca.sqlcode = 0
    then
        update stropend set stropend.* = m_ropend.*
            where rowid = ring_rowid
    end if
    whenever error call error_handler
end function
# llh_update()

#######################################################################
function get_cust()
#######################################################################
# retrieves the customer record

    whenever error continue
    select
        rowid,
        strcustr.bus_name,
        strcustr.on_acct_amt,
        strcustr.acct_bal,
        strcustr.ar_acct_dflt,
        strcustr.ar_department_dflt
      into
        cust_rowid,
        p_ropend.bus_name,
        p_ropend.on_acct_amt,
        p_ropend.acct_bal,
        ar_acct_no,
        ar_department
      from strcustr
      where cust_code = p_ropend.cust_code
    whenever error call error_handler

    if p_ropend.ar_acct_no is null
      then let p_ropend.ar_acct_no = ar_acct_no end if
    if p_ropend.ar_department is null
      then let p_ropend.ar_department = ar_department end if

end function
# get_cust()

########################################################################
function amount_validate(amt_level)
########################################################################
# sets default values for amount fields, and then calls routines to
# validate values
    define
        amt_level smallint,
        old_balance like stropend.balance

# save the old balance for adjusting account balance
    if p_ropend.balance is null
      then let old_balance = 0
      else let old_balance = p_ropend.balance
    end if

    # set default values
        if amt_level >= 1 and p_ropend.orig_amount is null
          then let p_ropend.orig_amount = 0 end if
        if amt_level >= 2 and p_ropend.disc_amt is null
          then let p_ropend.disc_amt = 0 end if
        if amt_level >= 3 and p_ropend.balance is null
          then let p_ropend.balance = p_ropend.orig_amount end if
        if amt_level >= 4 and p_ropend.disc_bal is null
        then
            if p_ropend.orig_amount = 0
            then
                let p_ropend.disc_bal = 0
            else
                let p_ropend.disc_bal = al_round("a",
                    p_ropend.disc_amt *
                    (p_ropend.balance / p_ropend.orig_amount))
            end if
        end if

# check and set valid values, depending on whether this is a positive or
# negative open item.

    if p_ropend.orig_amount < 0
      then call amount_negative()
      else call amount_positive()
    end if

# adjust account balance
    if p_ropend.balance is not null
    then
        let p_ropend.acct_bal = p_ropend.acct_bal - old_balance +
            p_ropend.balance
    end if

# display any changes
    display by name
        p_ropend.on_acct_amt, p_ropend.acct_bal,
        p_ropend.orig_amount, p_ropend.disc_amt,
        p_ropend.balance, p_ropend.disc_bal

end function
# amount_validate()

########################################################################
function amount_positive()
########################################################################
# checks and adjusts all amount fields.  this is called by all amount
# fields when p_ropend.orig_amount is positive.

# fix the signs
    if p_ropend.disc_amt < 0
      then let p_ropend.disc_amt = p_ropend.disc_amt * -1 end if
    if p_ropend.balance < 0
      then let p_ropend.balance = p_ropend.balance * -1 end if
    if p_ropend.disc_bal < 0
      then let p_ropend.disc_bal = p_ropend.disc_bal * -1 end if

# fix the scale
    if p_ropend.disc_amt > p_ropend.orig_amount
      then let p_ropend.disc_amt = p_ropend.orig_amount end if
    if p_ropend.balance > p_ropend.orig_amount
      then let p_ropend.balance = p_ropend.orig_amount end if
    if p_ropend.disc_bal > p_ropend.disc_amt
      then let p_ropend.disc_bal = p_ropend.disc_amt end if
    if p_ropend.disc_bal > p_ropend.balance
      then let p_ropend.disc_bal = p_ropend.balance end if

end function
# amount_positive()

########################################################################
function amount_negative()
########################################################################
# checks and adjusts all amount fields.  this is called by all amount
# fields when p_ropend.orig_amount is negative.

# fix the signs
    if p_ropend.disc_amt > 0
      then let p_ropend.disc_amt = p_ropend.disc_amt * -1 end if
    if p_ropend.balance > 0
      then let p_ropend.balance = p_ropend.balance * -1 end if
    if p_ropend.disc_bal > 0
      then let p_ropend.disc_bal = p_ropend.disc_bal * -1 end if

# fix the scale
    if p_ropend.disc_amt < p_ropend.orig_amount
      then let p_ropend.disc_amt = p_ropend.orig_amount end if
    if p_ropend.balance < p_ropend.orig_amount
      then let p_ropend.balance = p_ropend.orig_amount end if
    if p_ropend.disc_bal < p_ropend.disc_amt
      then let p_ropend.disc_bal = p_ropend.disc_amt end if
    if p_ropend.disc_bal < p_ropend.balance
      then let p_ropend.disc_bal = p_ropend.balance end if

end function
# amount_negative()

