########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_opend.4gs/options.4gl  1.5  Delta: 9/4/90
########################################################################

globals "globals.4gl"

#######################################################################
function ring_options(ring_rowid, ring_cursor, ring_total)
# returning ring_rowid, ring_cursor, ring_total
#######################################################################
#  this is the function that is called when "Options" is selected
#  from the menu.  it is where custom menu items are inserted.
#
    define
        ring_rowid  integer,    # the rowid of the current document
                                # (or -1 if no document is displayed)
        ring_cursor integer,    # the absolute address of the open cursor
                                # (0 if document isn't part of the
                                # current cursor group)
        ring_total  integer,    # total number of elements in the cursor
        old_cust_code like strcustr.cust_code,
        old_on_acct like strcustr.on_acct_amt,
        in_zoom smallint

    # check to see if ok to run options
    if ok_options() = false
    then
        return ring_rowid, ring_cursor, ring_total
    end if
    let p_rcustr.cust_code = p_ropend.cust_code

    menu " Options"
      command key ("!")
        call ring_bang()
      command key (o)
        "On Account" " Change amount on account for a customer"
        if m_rcntrc.ar_balanced is not null and
               m_rcntrc.ar_balanced = "Y"
        then
            call fg_err(6) # Amount on account cannot be changed
            continue menu
        end if
        open window win3 at 2,3
            with form "screen2"
            attribute (border, blue)
        display "[ESC] to save  [DEL] to cancel" at 1,2
        display "======================================",
                "======================================" at 3,1
        if p_rcustr.cust_code is not null
        then
            select cust_code, bus_name, on_acct_amt, acct_bal, rowid
                into p_rcustr.*, cust_rowid
                from strcustr where cust_code = p_rcustr.cust_code
            if sqlca.sqlcode = notfound
            then
                let sqlca.sqlcode = 0
                initialize p_rcustr.* to null
            else
                call mlh_cust_lock()
                if sqlca.sqlcode != 0
                then
                    let sqlca.sqlcode = 0
                    initialize p_rcustr.* to null
                end if
            end if
        else
            initialize p_rcustr.* to null
        end if

        let in_zoom = false
        input p_rcustr.* without defaults from s_rcustr.*
            on key (control-e)
                call fg_err(0)
            on key (control-w)
                call fg_help(2)
            on key (control-z)
                if infield(cust_code)
                then
                    let in_zoom = true
                    let old_cust_code = p_rcustr.cust_code
                    call ar_custz() returning p_rcustr.cust_code
                    if p_rcustr.cust_code is null
                    then
                        let p_rcustr.cust_code = old_cust_code
                    end if
                    display by name p_rcustr.cust_code
                    next field cust_code
                end if
            before field cust_code
                display "" at 2,1
                display "Enter any customer code    " at 2,2
                if in_zoom
                then
                    let in_zoom = false
                else
                    let old_cust_code = p_rcustr.cust_code
                end if
            after field cust_code
                if p_rcustr.cust_code is null
                then
                    call fg_err(1) # Customer code must be entered
                    let p_rcustr.cust_code = old_cust_code
                    next field cust_code
                end if
                if p_rcustr.cust_code = old_cust_code
                then else
                    select cust_code,
                           bus_name,
                           on_acct_amt,
                           acct_bal,
                           rowid
                        into p_rcustr.*, cust_rowid
                        from strcustr
                        where cust_code = p_rcustr.cust_code
                    if sqlca.sqlcode = notfound
                    then
                        let sqlca.sqlcode = 0
                        call fg_err(3) # Invalid customer code
                        let p_rcustr.cust_code = old_cust_code
                        display by name p_rcustr.cust_code
                        next field cust_code
                    end if
                    call mlh_cust_lock()
                    if sqlca.sqlcode != 0
                    then
                        let sqlca.sqlcode = 0
                        call fg_err(10) # Customer is currently being updated.
                        let p_rcustr.cust_code = old_cust_code
                        display by name p_rcustr.cust_code
                        let old_cust_code = null
                        let in_zoom = true
                        next field cust_code
                    end if
                    display p_rcustr.* to s_rcustr.*
                end if
            before field on_acct_amt
                display "" at 2,1
                display "Enter new on account amount" at 2,2
                if p_rcustr.on_acct_amt is null
                then
                    let p_rcustr.on_acct_amt = 0
                    display by name p_rcustr.on_acct_amt
                end if
                let old_on_acct = p_rcustr.on_acct_amt
            after field on_acct_amt
                let p_rcustr.on_acct_amt = al_round( "a",
                    p_rcustr.on_acct_amt )
                if p_rcustr.acct_bal is null
                then
                    let p_rcustr.acct_bal = 0
                end if
                let p_rcustr.acct_bal = p_rcustr.acct_bal -
                    old_on_acct + p_rcustr.on_acct_amt
                display by name p_rcustr.acct_bal
        end input
        if not int_flag
        then
            update strcustr
                set on_acct_amt = p_rcustr.on_acct_amt,
                    acct_bal    = p_rcustr.acct_bal,
                    stmt_date   = 1,
                    stmt_amount = p_rcustr.on_acct_amt
            where rowid = cust_rowid
        else
            let int_flag = false
            if cust_rowid is not null and cust_rowid != 0
            then
                select cust_code,
                       bus_name,
                       on_acct_amt,
                       acct_bal,
                       rowid
                    into p_rcustr.*, cust_rowid
                    from strcustr
                    where rowid = cust_rowid
            else
                initialize p_rcustr.* to null
            end if
        end if
        call mlh_cust_unlock()
        close window win3
        if p_rcustr.cust_code = p_ropend.cust_code
        then
            let p_ropend.on_acct_amt = p_rcustr.on_acct_amt
            let p_ropend.acct_bal = p_rcustr.acct_bal
            display by name p_ropend.on_acct_amt, p_ropend.acct_bal
        end if
      command key (a)
        "Activity" " Display all customer activity"
        if p_rcustr.cust_code is null
        then
            continue menu
        end if
        call ar_actvz(p_rcustr.cust_code)
      command key (e,x,q)
        "Quit" " Return to the main menu"
        exit menu
      command key (interrupt)
        let int_flag = false
        exit menu
    end menu
    return ring_rowid, ring_cursor, ring_total
end function
# ring_options()

