##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_shipr.4gs/header.4gl  1.5  Last Delta: 9/17/90
##############################################################################

globals "globals.4gl"

#######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
#######################################################################
#
    input p_rshipr.* without defaults from s_rshipr.*
        on key (control-e)
            call fg_err(0)
        on key (control-w)
            call fg_help(1)
        on key (control-f)
            # add/update user defined fields...
            if m_rshipr.cust_code is null
              then call al_addlz("strshipr",p_rshipr.cust_code,p_rshipr.ship_to_code,"")
              else call al_addlz("strshipr",m_rshipr.cust_code,p_rshipr.ship_to_code,"")
            end if

        on key (control-z)
            case
                when infield(cust_code)
                    call ar_custz() returning p_rshipr.cust_code
                    display by name p_rshipr.cust_code
                    next field cust_code
                when infield(ship_to_code)
                    call ar_shipz(p_rshipr.cust_code)
                        returning p_rshipr.ship_to_code
                    display by name p_rshipr.ship_to_code
                    next field ship_to_code
            end case
        after field cust_code
            if p_rshipr.cust_code is null
            then
                initialize p_rcustr.* to null
                initialize m_rcustr.* to null
                display p_rcustr.* to s_rcustr.*
                call fg_err(1) # Customer code must be entered
                next field cust_code
            end if
            select * into m_rcustr.* from strcustr
                where cust_code = p_rshipr.cust_code
            if sqlca.sqlcode = notfound
            then
                call fg_err(2) # Invalid customer code
                next field cust_code
            else
                call llh_cust_prep()
                display p_rcustr.* to s_rcustr.*
            end if
            if p_rshipr.ship_to_code is null
            then
                next field ship_to_code
            else
                if dup_ship_to()
                then
                    next field ship_to_code
                end if
            end if
        after field ship_to_code
            if p_rshipr.ship_to_code is null
            then
                call fg_err(3) # Ship-to code must be entered
                next field ship_to_code
            end if
            if dup_ship_to()
            then
                call fg_err(4) # Duplicate ship-to code
                next field ship_to_code
            end if
    end input
    return 0
end function
# llh_input()

#######################################################################
function llh_chkinput()
#   returns true/false based upon good/bad data in screen
#######################################################################
#   this function is called upon exiting the input statement.
#   the "after input" clause in the input statement can't call
#   this because a tab (control-i) needs to run this function also.
#
#   if you have any must-fill type fields on the screen, you can use
#   the function "mustfill()" that comes with infourgen.  it's syntax is:
#       mustfill(variable_name,"description of that variable")
#           returning true/false based upon no_data/data in that field.
#   it's use in this context is:
#       if mustfill(p_gchrt.acct_no,"Account Number") then return false end if
#
    return true
end function
# llh_chkinput()

#######################################################################
function llh_display()
#######################################################################
#   - display all p_* variables onto the screen
#
    display p_rshipr.* to s_rshipr.*
    display p_rcustr.* to s_rcustr.*
end function
# llh_display()

#######################################################################
function llh_p_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    let p_rshipr.cust_code = m_rshipr.cust_code
    let p_rshipr.ship_to_code = m_rshipr.ship_to_code
    let p_rshipr.bus_name = m_rshipr.bus_name
    let p_rshipr.taxable = m_rshipr.taxable
    let p_rshipr.contact = m_rshipr.contact
    let p_rshipr.phone = m_rshipr.phone
    let p_rshipr.address1 = m_rshipr.address1
    let p_rshipr.address2 = m_rshipr.address2
    let p_rshipr.city = m_rshipr.city
    let p_rshipr.state = m_rshipr.state
    let p_rshipr.zip = m_rshipr.zip
    let p_rshipr.country = m_rshipr.country
    let p_rshipr.spec_shipping = m_rshipr.spec_shipping
    call llh_cust_prep()
end function
# llh_p_prep()

#######################################################################
function llh_cust_prep()
#######################################################################
#   - this function creates the p_* record from the m_* record
#
    let p_rcustr.bus_name = m_rcustr.bus_name
    let p_rcustr.taxable = m_rcustr.taxable
    let p_rcustr.contact = m_rcustr.contact
    let p_rcustr.phone = m_rcustr.phone
    let p_rcustr.address1 = m_rcustr.address1
    let p_rcustr.address2 = m_rcustr.address2
    let p_rcustr.city = m_rcustr.city
    let p_rcustr.state = m_rcustr.state
    let p_rcustr.zip = m_rcustr.zip
    let p_rcustr.country = m_rcustr.country
    let p_rcustr.spec_shipping = m_rcustr.spec_shipping
end function
# llh_cust_prep()

#######################################################################
function llh_m_prep()
#######################################################################
#   - this function creates the m_* record from the p_* record
#
    define
        scratch1 char(20),
        scratch2 char(20)

    # change key to user defined fields
    # if key was changed during input
    if  (  m_rshipr.cust_code is not null
       and m_rshipr.cust_code != p_rshipr.cust_code)
     or (  m_rshipr.ship_to_code is not null
       and m_rshipr.ship_to_code != p_rshipr.ship_to_code)
    then
        let scratch1 = m_rshipr.cust_code clipped,m_rshipr.ship_to_code
        let scratch2 = p_rshipr.cust_code clipped,p_rshipr.ship_to_code
        call al_addlnk("strshipr", scratch1, scratch2)
    end if

    let m_rshipr.cust_code = p_rshipr.cust_code
    let m_rshipr.ship_to_code = p_rshipr.ship_to_code
    let m_rshipr.bus_name = p_rshipr.bus_name
    let m_rshipr.taxable = p_rshipr.taxable
    let m_rshipr.contact = p_rshipr.contact
    let m_rshipr.phone = p_rshipr.phone
    let m_rshipr.address1 = p_rshipr.address1
    let m_rshipr.address2 = p_rshipr.address2
    let m_rshipr.city = p_rshipr.city
    let m_rshipr.state = p_rshipr.state
    let m_rshipr.zip = p_rshipr.zip
    let m_rshipr.country = p_rshipr.country
    let m_rshipr.spec_shipping = p_rshipr.spec_shipping
end function
# llh_m_prep()

#######################################################################
function llh_read(ring_rowid)
#######################################################################
#   - this function reads in all of the p_* variables from disk.
#   - it does not use a cursor, so it doesn't lock the row.
#
    define
        ring_rowid  integer     # rowid of record to read
    whenever error continue
    select * into m_rshipr.* from strshipr where rowid = ring_rowid
    select * into m_rcustr.* from strcustr
        where cust_code = m_rshipr.cust_code
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        return
    end if
    whenever error continue
    select * into m_rcustr.* from strcustr
        where cust_code = m_rshipr.cust_code
    whenever error call error_handler
    call llh_p_prep()
    return
end function
# llh_read()

#######################################################################
function llh_delete(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer,     # rowid passed
        scratch char(20)

    delete from strshipr
        where rowid = ring_rowid
    if sqlca.sqlcode = 0
    then
        # delete user defined fields
        let scratch = p_rshipr.cust_code clipped,p_rshipr.ship_to_code
        call al_addld("strshipr", scratch)
    end if
end function
# llh_delete()

#######################################################################
function llh_add()
#######################################################################
#   - insert a new reference record, and all n-lines associated with it.
#
    whenever error continue
    insert into strshipr values(m_rshipr.*)
    whenever error call error_handler
end function
# llh_add()

#######################################################################
function llh_update(ring_rowid)
#######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update strshipr set strshipr.* = m_rshipr.*
        where rowid = ring_rowid
end function
# llh_update()

#######################################################################
function dup_ship_to()
#   returns true/false based upon dup/no dup
#######################################################################
#   - This checks for duplicate ship codes in the strshipr table.
#

    define
        row_id integer  # something to select into
    if p_rshipr.cust_code = orig_cust_code and
       p_rshipr.ship_to_code = orig_ship_to_code
    then
        return false
    end if
    select rowid into row_id from strshipr
        where cust_code = p_rshipr.cust_code and
              ship_to_code = p_rshipr.ship_to_code
    if sqlca.sqlcode = notfound
    then
        let sqlca.sqlcode = 0
        return false
    else
        let sqlca.sqlcode = 0
        return true
    end if

end function
# dup_ship_to()
