########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_contrl.4gs/midlevel.4gl  1.3  Delta: 4/5/90
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    let ct.sel_join = "strcntrc.terms_code = strtermr.terms_code"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = ""
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from strcntrc, outer strtermr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "strcntrc.tax_pct, ",
            "strcntrc.terms_code, ",
            "strtermr.terms_desc, ",
            "strcntrc.disc_misc, ",
            "strcntrc.disc_frght, ",
            "strcntrc.disc_tax, ",
            "strcntrc.ar_acct_no, ",
            "strcntrc.ar_sales_acct_no, ",
            "strcntrc.ar_misc_acct_no, ",
            "strcntrc.ar_tax_acct_no, ",
            "strcntrc.ar_fc_acct_no, ",
            "strcntrc.ar_frght_acct_no, ",
            "strcntrc.cr_disc_acct_no, ",
            "strcntrc.cr_cash_acct_no, ",
            "strcntrc.age_datetype, ",
            "strcntrc.age_dsc1, ",
            "strcntrc.age_dsc2, ",
            "strcntrc.age_dsc3, ",
            "strcntrc.age_dsc4, ",
            "strcntrc.age_per1, ",
            "strcntrc.age_per2, ",
            "strcntrc.age_per3, ",
            "strcntrc.ar_balanced ",
        "from strcntrc, outer strtermr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    whenever error call error_handler
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.tax_pct = curs_next.tax_pct
    let curs.terms_code = curs_next.terms_code
    let curs.terms_desc = curs_next.terms_desc
    let curs.disc_misc = curs_next.disc_misc
    let curs.disc_frght = curs_next.disc_frght
    let curs.disc_tax = curs_next.disc_tax
    let curs.ar_acct_no = curs_next.ar_acct_no
    let curs.ar_sales_acct_no = curs_next.ar_sales_acct_no
    let curs.ar_misc_acct_no = curs_next.ar_misc_acct_no
    let curs.ar_tax_acct_no = curs_next.ar_tax_acct_no
    let curs.ar_fc_acct_no = curs_next.ar_fc_acct_no
    let curs.ar_frght_acct_no = curs_next.ar_frght_acct_no
    let curs.cr_disc_acct_no = curs_next.cr_disc_acct_no
    let curs.cr_cash_acct_no = curs_next.cr_cash_acct_no
    let curs.age_datetype = curs_next.age_datetype
    let curs.age_dsc1 = curs_next.age_dsc1
    let curs.age_dsc2 = curs_next.age_dsc2
    let curs.age_dsc3 = curs_next.age_dsc3
    let curs.age_dsc4 = curs_next.age_dsc4
    let curs.age_per1 = curs_next.age_per1
    let curs.age_per2 = curs_next.age_per2
    let curs.age_per3 = curs_next.age_per3
    let curs.ar_balanced = curs_next.ar_balanced
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Receivable Defaults"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

