#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_contrl.4gs/report.4gl  1.4  Delta: 12/10/89
#####################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            tax_pct like strcntrc.tax_pct,
            terms_code like strcntrc.terms_code,
            terms_desc like strtermr.terms_desc,
            disc_misc like strcntrc.disc_misc,
            disc_frght like strcntrc.disc_frght,
            disc_tax like strcntrc.disc_tax,
            ar_acct_no like strcntrc.ar_acct_no,
            ar_sales_acct_no like strcntrc.ar_sales_acct_no,
            ar_misc_acct_no like strcntrc.ar_misc_acct_no,
            ar_tax_acct_no like strcntrc.ar_tax_acct_no,
            ar_fc_acct_no like strcntrc.ar_fc_acct_no,
            ar_frght_acct_no like strcntrc.ar_frght_acct_no,
            cr_disc_acct_no like strcntrc.cr_disc_acct_no,
            cr_cash_acct_no like strcntrc.cr_cash_acct_no,
            age_datetype like strcntrc.age_datetype,
            age_dsc1 like strcntrc.age_dsc1,
            age_dsc2 like strcntrc.age_dsc2,
            age_dsc3 like strcntrc.age_dsc3,
            age_dsc4 like strcntrc.age_dsc4,
            age_per1 like strcntrc.age_per1,
            age_per2 like strcntrc.age_per2,
            age_per3 like strcntrc.age_per3,
            ar_balanced like strcntrc.ar_balanced
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80
        page length     66

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Receivable Defaults"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "======================================="

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "======================================="
            print
                column   1, "Receivable Defaults";
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        on every row
            need 17 lines
            print
                column  12, "Tax Percentage Rate: ",
                column  33, rpt.tax_pct
            print
                column  21, "Terms Code: ",
                column  33, rpt.terms_code,
                column  42, rpt.terms_desc
            print
                column   6, "Take Discount on:",
                column  27, "Misc: ",
                column  33, rpt.disc_misc,
                column  41, "Freight: ",
                column  50, rpt.disc_frght,
                column  59, "Tax: ",
                column  64, rpt.disc_tax
            print
                column   1, "----------------------------------------",
                column  41, "------------------------------------"
            print
                column  27, "Default Account Numbers"
            print
                column   4, "A/R: ",
                column   9, rpt.ar_acct_no using "######",
                column  21, "Sales: ",
                column  28, rpt.ar_sales_acct_no using "######",
                column  37, "Misc. Sales: ",
                column  50, rpt.ar_misc_acct_no using "######",
                column  65, "Tax: ",
                column  70, rpt.ar_tax_acct_no using "######"
            print
                column   3, "F.C.: ",
                column   9, rpt.ar_fc_acct_no using "######",
                column  19, "Freight: ",
                column  28, rpt.ar_frght_acct_no using "######",
                column  44, "Cash: ",
                column  50, rpt.cr_cash_acct_no using "######",
                column  60, "Discount: ",
                column  70, rpt.cr_disc_acct_no using "######"
            print
                column   1, "----------------------------------------",
                column  41, "------------------------------------"
            print
                column   4, "Age On: ",
                column  12, rpt.age_datetype,
                column  20, "D=Due Date",
                column  32, "I=Invoice Date"
            print
            print
                column  23, "Aging days - (Description, Days)"
            print
            print
                column   4, rpt.age_dsc1,
                column  22, rpt.age_dsc2,
                column  40, rpt.age_dsc3,
                column  58, rpt.age_dsc4
            print
                column   5, "---------------",
                column  23, "---------------",
                column  41, "---------------",
                column  59, "---------------"
            print
                column  13, rpt.age_per1,
                column  31, rpt.age_per2,
                column  49, rpt.age_per3
            print
                column   1, "----------------------------------------",
                column  41, "------------------------------------"
            print
                column  23, "Account Receivable Balanced?: ",
                column  53, rpt.ar_balanced

end report
# report1()

