########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_custbl.4gs/lowlevel.4gl  1.3  Delta: 5/25/90
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20),    # group identification
        save record
            on_acct_amt like strcustr.on_acct_amt,
            cust_code like strcustr.cust_code,
            bus_name like strcustr.bus_name,
            doc_no like stropend.doc_no,
            inv_no like stropend.inv_no,
            inv_date like stropend.inv_date,
            inv_desc like stropend.inv_desc,
            balance like stropend.balance
        end record

    if group_key = "first_row" then
        # insert "on first row" code here
        let rpt.tot_bal = 0
        return
    end if

    if group_key = "cust_code" then
        # insert "before group of cust_code" code here
        let rpt.acct_bal = 0
        if curs.on_acct_amt is not null and curs.on_acct_amt != 0
        then
          let save.* = curs.*
          let curs.inv_desc = "On Account"
          if curs.on_acct_amt is null then let curs.on_acct_amt = 0 end if
          let curs.balance = curs.on_acct_amt
          let curs.inv_date = ""
          let curs.doc_no = ""
          let curs.inv_no = ""
          call on_every_row()
          call ml_output()
          let curs.* = save.*
        end if
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    let rpt.on_acct_amt = curs.on_acct_amt
    let rpt.cust_code = curs.cust_code
    let rpt.bus_name = curs.bus_name
    let rpt.doc_no = curs.doc_no
    let rpt.inv_no = curs.inv_no
    let rpt.inv_date = curs.inv_date
    let rpt.inv_desc = curs.inv_desc
    let rpt.balance = curs.balance
    if rpt.balance is not null 
    then
      let rpt.acct_bal = rpt.acct_bal + rpt.balance
      let rpt.tot_bal = rpt.tot_bal + rpt.balance
    end if
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "cust_code" then
        # insert "after group of cust_code" code here
        return
    end if

    if group_key = "doc_no" then
        # insert "after group of doc_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()


