########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_custbl.4gs/midlevel.4gl  1.5  Delta: 5/25/90
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    let ct.sel_join =
        "strcustr.cust_code = stropend.cust_code and ",
        "stropend.balance != 0"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    call sel_cust() returning ct.sel_filter
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "strcustr.cust_code, stropend.doc_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "strcustr.on_acct_amt, ",
            "strcustr.cust_code, ",
            "strcustr.bus_name, ",
            "stropend.doc_no, ",
            "stropend.inv_no, ",
            "stropend.inv_date, ",
            "stropend.inv_desc, ",
            "stropend.balance ",
        "from strcustr, outer stropend ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    let ct.sel_stmt = ct.sel_stmt clipped, " into temp temp_table"
    whenever error continue
    prepare tmp_curs from ct.sel_stmt
    execute tmp_curs
    let ct.sel_stmt =
        "select count(*) ",
        "from temp_table ",
        "where (on_acct_amt != 0 and on_acct_amt is not null) ",
        "or balance is not null"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return

end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt = "select * from temp_table ",
                      "where (on_acct_amt != 0 and on_acct_amt is not null) ",
                      "or balance is not null ",
                      "order by cust_code, doc_no"
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    whenever error call error_handler
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.on_acct_amt = curs_next.on_acct_amt
    let curs.cust_code = curs_next.cust_code
    let curs.bus_name = curs_next.bus_name
    let curs.doc_no = curs_next.doc_no
    let curs.inv_no = curs_next.inv_no
    let curs.inv_date = curs_next.inv_date
    let curs.inv_desc = curs_next.inv_desc
    let curs.balance = curs_next.balance
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("cust_code")
        let no_break = false
    end if
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        call after_group("cust_code")
        let no_break = false
    end if
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Customer Open Items"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "10"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

