########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_custdt.4gs/midlevel.4gl  1.3  Delta: 4/5/90
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    let ct.sel_join =
        "strtermr.terms_code = strcustr.terms_code and ",
        "stxactgr.grp_key = strcustr.act_grp and ",
        "strshipr.cust_code = strcustr.cust_code"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    call sel_cust() returning ct.sel_filter
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "strcustr.cust_code, strshipr.ship_to_code"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let long_sel_stmt =
        "select count(*) ",
        "from strcustr, outer strtermr, outer stxactgr, outer strshipr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from long_sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let long_sel_stmt =
        "select ",
            "strcustr.cust_code, ",
            "strcustr.bus_name, ",
            "strcustr.contact, ",
            "strcustr.phone, ",
            "strcustr.address1, ",
            "strcustr.taxable, ",
            "strcustr.fin_chg, ",
            "strcustr.address2, ",
            "strcustr.credit_limit, ",
            "strcustr.acct_bal, ",
            "strcustr.city, ",
            "strcustr.state, ",
            "strcustr.zip, ",
            "strcustr.country, ",
            "strcustr.on_acct_amt, ",
            "strcustr.ar_acct_dflt, ",
            "strcustr.ar_department_dflt, ",
            "strcustr.terms_code, ",
            "strcustr.stmt_amount, ",
            "strcustr.stmt_cycle, ",
            "strcustr.act_grp, ",
            "strcustr.ar_type, ",
            "strcustr.stmt_date, ",
            "strcustr.last_pay_date, ",
            "strcustr.spec_shipping, ",
            "strcustr.spec_billing, ",
            "strtermr.terms_desc, ",
            "stxactgr.grp_desc, ",
            "strshipr.ship_to_code, ",
            "strshipr.bus_name, ",
            "strshipr.contact, ",
            "strshipr.address1, ",
            "strshipr.phone, ",
            "strshipr.address2, ",
            "strshipr.city, ",
            "strshipr.state, ",
            "strshipr.zip, ",
            "strshipr.country, ",
            "strshipr.taxable, ",
            "strshipr.spec_shipping ",
        "from strcustr, outer strtermr, outer stxactgr, outer strshipr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let long_sel_stmt = long_sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from long_sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    whenever error call error_handler
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.cust_code = curs_next.cust_code
    let curs.bus_name = curs_next.bus_name
    let curs.contact = curs_next.contact
    let curs.phone = curs_next.phone
    let curs.address1 = curs_next.address1
    let curs.taxable = curs_next.taxable
    let curs.fin_chg = curs_next.fin_chg
    let curs.address2 = curs_next.address2
    let curs.credit_limit = curs_next.credit_limit
    let curs.acct_bal = curs_next.acct_bal
    let curs.city = curs_next.city
    let curs.state = curs_next.state
    let curs.zip = curs_next.zip
    let curs.country = curs_next.country
    let curs.on_acct_amt = curs_next.on_acct_amt
    let curs.ar_acct_dflt = curs_next.ar_acct_dflt
    let curs.ar_department_dflt = curs_next.ar_department_dflt
    let curs.terms_code = curs_next.terms_code
    let curs.stmt_amount = curs_next.stmt_amount
    let curs.stmt_cycle = curs_next.stmt_cycle
    let curs.act_grp = curs_next.act_grp
    let curs.ar_type = curs_next.ar_type
    let curs.stmt_date = curs_next.stmt_date
    let curs.last_pay_date = curs_next.last_pay_date
    let curs.spec_shipping = curs_next.spec_shipping
    let curs.spec_billing = curs_next.spec_billing
    let curs.terms_desc = curs_next.terms_desc
    let curs.grp_desc = curs_next.grp_desc
    let curs.ship_to_code = curs_next.ship_to_code
    let curs.ship_bus_name = curs_next.ship_bus_name
    let curs.ship_contact = curs_next.ship_contact
    let curs.ship_address1 = curs_next.ship_address1
    let curs.ship_phone = curs_next.ship_phone
    let curs.ship_address2 = curs_next.ship_address2
    let curs.ship_city = curs_next.ship_city
    let curs.ship_state = curs_next.ship_state
    let curs.ship_zip = curs_next.ship_zip
    let curs.ship_country = curs_next.ship_country
    let curs.ship_taxable = curs_next.ship_taxable
    let curs.ship_spec_shipping = curs_next.ship_spec_shipping
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("cust_code")
        let no_break = false
    end if
    if no_break and curs.ship_to_code = curs_next.ship_to_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("ship_to_code")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        call after_group("cust_code")
        let no_break = false
    end if
    if no_break and curs.ship_to_code = curs_next.ship_to_code
    then else
        call after_group("ship_to_code")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Customer Information Detail"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "10"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

