#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/o_custdt.4gs/report.4gl  1.4  Delta: 12/1/89
#####################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            cust_code like strcustr.cust_code,
            bus_name like strcustr.bus_name,
            contact like strcustr.contact,
            phone like strcustr.phone,
            address1 like strcustr.address1,
            taxable like strcustr.taxable,
            fin_chg like strcustr.fin_chg,
            address2 like strcustr.address2,
            credit_limit like strcustr.credit_limit,
            acct_bal like strcustr.acct_bal,
            city like strcustr.city,
            state like strcustr.state,
            zip like strcustr.zip,
            country like strcustr.country,
            on_acct_amt like strcustr.on_acct_amt,
            ar_acct_dflt like strcustr.ar_acct_dflt,
            ar_department_dflt like strcustr.ar_department_dflt,
            terms_code like strcustr.terms_code,
            stmt_amount like strcustr.stmt_amount,
            stmt_cycle like strcustr.stmt_cycle,
            act_grp like strcustr.act_grp,
            ar_type like strcustr.ar_type,
            stmt_date like strcustr.stmt_date,
            last_pay_date like strcustr.last_pay_date,
            spec_shipping like strcustr.spec_shipping,
            spec_billing like strcustr.spec_billing,
            terms_desc like strtermr.terms_desc,
            grp_desc like stxactgr.grp_desc,
            ship_to_code like strshipr.ship_to_code,
            ship_bus_name like strshipr.bus_name,
            ship_contact like strshipr.contact,
            ship_address1 like strshipr.address1,
            ship_phone like strshipr.phone,
            ship_address2 like strshipr.address2,
            ship_city like strshipr.city,
            ship_state like strshipr.state,
            ship_zip like strshipr.zip,
            ship_country like strshipr.country,
            ship_taxable like strshipr.taxable,
            ship_spec_shipping like strshipr.spec_shipping
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.cust_code, rpt.ship_to_code

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Customer Information Detail"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Customer Information Detail";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.cust_code
            skip to top of page
            need 18 lines
            print
            print
                column   9, "Customer Code: ",
                column  24, rpt.cust_code
            print
                column   9, "Business Name: ",
                column  24, rpt.bus_name,
                column  58, "Taxable? ",
                column  67, rpt.taxable
            print
                column  15, "Contact: ",
                column  24, rpt.contact,
                column  48, "Phone: ",
                column  55, rpt.phone
            print
                column  13, "Address 1: ",
                column  24, rpt.address1
            print
                column  13, "Address 2: ",
                column  24, rpt.address2
            print
                column   6, "City, State, Zip: ",
                column  24, rpt.city,
                column  46, rpt.state,
                column  50, rpt.zip
            print
                column  15, "Country: ",
                column  24, rpt.country
            print
                column   2, "Ship-To Instructions: ",
                column  24, rpt.spec_shipping
            print
                column   5, "Open Item/Bal Fwd: ",
                column  24, rpt.ar_type,
                column  44, "Last Statement Date: ",
                column  65, rpt.stmt_date using "mm/dd/yy"
            print
                column   7, "Statement Cycle: ",
                column  24, rpt.stmt_cycle using "#",
                column  42, "Last Statement Amount: ",
                column  65, rpt.stmt_amount
            print
                column   7, "Finance Charges? ",
                column  24, rpt.fin_chg,
                column  46, "Last Payment Date: ",
                column  65, rpt.last_pay_date using "mm/dd/yy"
            print
                column  10, "Credit Limit: ",
                column  24, rpt.credit_limit,
                column  46, "On Account Amount: ",
                column  65, rpt.on_acct_amt
            print
                column   3, "Default A/R Account: ",
                column  24, rpt.ar_acct_dflt using "######",
                column  30, "-",
                column  31, rpt.ar_department_dflt,
                column  48, "Current Balance: ",
                column  65, rpt.acct_bal
            print
                column  12, "Terms Code: ",
                column  24, rpt.terms_code,
                column  33, rpt.terms_desc
            print
                column   9, "Account Group: ",
                column  24, rpt.act_grp,
                column  33, rpt.grp_desc
            print
                column   2, "Billing Instructions: ",
                column  24, rpt.spec_billing
            print
                column   1, "________________________________________",
                column  41, "________________________________________"

        on every row
            need 9 lines
            if
                rpt.ship_to_code is not null
            then
                print
                    column  14, "Ship-To",
                    column  22, "Code: ",
                    column  28, rpt.ship_to_code
            end if
            if
                rpt.ship_bus_name is not null
             or rpt.ship_taxable is not null
            then
                print
                    column  14, "Ship-To Name: ",
                    column  28, rpt.ship_bus_name,
                    column  62, "Taxable? ",
                    column  71, rpt.ship_taxable
            end if
            if
                rpt.ship_contact is not null
             or rpt.ship_phone is not null
            then
                print
                    column  19, "Contact: ",
                    column  28, rpt.ship_contact,
                    column  52, "Phone: ",
                    column  59, rpt.ship_phone
            end if
            if
                rpt.ship_address1 is not null
            then
                print
                    column  17, "Address 1: ",
                    column  28, rpt.ship_address1
            end if
            if
                rpt.ship_address2 is not null
            then
                print
                    column  17, "Address 2: ",
                    column  28, rpt.ship_address2
            end if
            if
                rpt.ship_city is not null
             or rpt.ship_state is not null
             or rpt.ship_zip is not null
            then
                print
                    column  10, "City, State, Zip: ",
                    column  28, rpt.ship_city,
                    column  50, rpt.ship_state,
                    column  54, rpt.ship_zip
            end if
            if
                rpt.ship_country is not null
            then
                print
                    column  19, "Country: ",
                    column  28, rpt.ship_country
            end if
            if
                rpt.ship_spec_shipping is not null
            then
                print
                    column   6, "Ship-To Instructions: ",
                    column  28, rpt.ship_spec_shipping
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()

