########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_crpost.4gs/lowlevel.4gl  1.13  Delta: 8/31/90
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "first_row" then
        if check_post = "POST"
        then
            begin work
                call auto_next("strcntrc","cr_post_no")
                    returning post_no
            commit work
            let rpt.post_seq = post_no using "Posting Sequence: <<<<<<"
        else
            let rpt.post_seq = ""
        end if
        return
    end if

    if group_key = "doc_no" then
    # For each document do the following:
    # - begin work
    # - grab next doc_no (if post)
    # - delete the document (if post)

        let post_gl.signed_amount = 0
        let post_gl.cr_accum = 0
        let post_gl.db_accum = 0
        let post_ar.ar_accum = 0
        let post_ar.disc_accum = 0

        let rpt.problm0 = ""
        let rpt.description = ""
        if check_post = "POST"
        then
            begin work
            if curs.ok_to_post != "Y"
            then
                rollback work
                call fg_err(3) # edit list hasn't been run on this document
                call end_report("The edit list hasn't been run on this document.")
            end if
            call auto_next("strcntrc","cr_doc_no")
                returning new_doc_no
            let rpt.txt_doc_no = new_doc_no using "<<<<<<<<<"
            let group_key = curs.doc_no using "<<<<<<<<<<", "-UNPOSTED"
            call al_addlnk("stxtranrCR",group_key,new_doc_no)
        else
            let rpt.txt_doc_no = "UNASSIGNED"
            let new_doc_no = curs.doc_no
        end if

        # delete the cash receipt...
        if check_post = "POST"
        then
            whenever error continue
            delete from strcashe 
                where doc_no = curs.doc_no
            if sqlca.sqlcode = 0
            then
                delete from strcashd 
                    where doc_no = curs.doc_no
            end if
            whenever error call error_handler
            if sqlca.sqlcode != 0
            then
                rollback work
                call fg_err(3) #An SQL error has occured while deleting strcashe
                call end_report("An SQL error has occured while deleting the previous document.")
            end if
        else
            whenever error continue
            update strcashe set ok_to_post = "Y"
                where doc_no = curs.doc_no
            whenever error call error_handler
            if sqlca.sqlcode != 0
            then
                call fg_err(2) # SQL error: cannot update strcashe
                call end_report("SQL error: cannot update strcashe")
            end if
        end if

        return
    end if

    if group_key = "due_date" then
        # insert "before group of due_date" code here
        return
    end if

    if group_key = "inv_doc_no" then
        # insert "before group of inv_doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    define
        signed_amt like strcashd.dist_amt,
        trx_type char(1)

    let rpt.doc_no = curs.doc_no
    let rpt.inv_doc_no = curs.inv_doc_no
    let rpt.inv_no = curs.inv_no
    let rpt.disc_acct = curs.disc_acct
    let rpt.disc_department = curs.disc_department
    let rpt.disc_amt = curs.disc_amt
    let rpt.disc_deb_cred = curs.disc_deb_cred
    let rpt.cash_acct = curs.cash_acct
    let rpt.cash_department = curs.cash_department
    let rpt.cash_deb_cred = curs.cash_deb_cred
    let rpt.oa_amt = curs.oa_amt
    let rpt.oa_acct = curs.oa_acct
    let rpt.oa_department = curs.oa_department
    let rpt.oa_deb_cred = curs.oa_deb_cred
#   let rpt.heading = (MUST SUPPLY)
#   let rpt.post_seq = (MUST SUPPLY)
#   let rpt.txt_doc_no = (MUST SUPPLY)
    let rpt.rcpt_date = curs.rcpt_date
    let rpt.check_no = curs.check_no
    let rpt.cust_code = curs.cust_code
    let rpt.bus_name = curs.bus_name
    let rpt.cash_amt = curs.cash_amt
    let rpt.doc_desc = curs.doc_desc
    let rpt.dist_acct = curs.dist_acct
    let rpt.dist_department = curs.dist_department
#   let rpt.description = (MUST SUPPLY)
    let rpt.dist_amt = curs.dist_amt
    let rpt.dist_deb_cred = curs.dist_deb_cred
#   let rpt.messg1 = (MUST SUPPLY)
#   let rpt.problm0 = (MUST SUPPLY)
#   let rpt.problm1 = (MUST SUPPLY)
#   let rpt.problm2 = (MUST SUPPLY)
#   let rpt.problm3 = (MUST SUPPLY)

    # on every row logic:
    # - if nothing to post, then return
    # - post to a/r
    # - post to g/l
    # - bring discount amt over to dist amt and call on_every_row recursively

    if curs.dist_amt is null
    then
        return
    end if

    # post to a/r (unless this is the check amt. line or a non a/r type doc.)
    if   curs.cust_code is not null
     and curs.dist_acct != curs.cash_acct
    then
        let signed_amt = curs.dist_amt * -1 # default to negative value
        if  curs.dist_acct = curs.disc_acct # this is the discount posting
        then
            let trx_type = "D"  # set to discount type
            if curs.disc_deb_cred = "CR"  # discount account is usually debited
            then let signed_amt = signed_amt * -1
            end if
        else
            let trx_type = "A"  # set to a/r type
            if curs.dist_deb_cred = "DB"  # ar account is usually credited
            then let signed_amt = signed_amt * -1
            end if
        end if
        if ar_post(
            check_post, "CR", new_doc_no, post_no, today, curs.rcpt_date,
            curs.cust_code, curs.doc_desc, curs.check_no,
            "CR", trx_type, curs.inv_doc_no, signed_amt,
            0,0,0,0,"0","0",0) = false
        then
            if check_post = "POST"
            then
                rollback work
                call fg_error("lib_all","ar_post",post_ar.status)
            end if
            call end_report(post_ar.description)
        end if
    end if  # post to a/r


    # post this guy to g/l...
    if gl_post(
            check_post, "CR", new_doc_no, post_no, today, curs.rcpt_date,
            curs.cust_code, curs.doc_desc, curs.check_no, curs.dist_acct,
            curs.dist_department, curs.dist_amt, curs.dist_deb_cred
    ) = false
    then
        if check_post = "POST"
        then
            rollback work
            call fg_error("lib_all","gl_post",post_gl.status)
        end if
        call end_report(post_gl.description)
    end if

    # - set rpt.description (if not already set)
    if rpt.description = "ON ACCOUNT" or curs.dist_acct  = curs.disc_acct
    then else
        if curs.cust_code is null or curs.dist_acct = curs.cash_acct
        then
            let rpt.description = post_gl.acct_desc  # from post_gl()
        else
            let rpt.description = "INVOICE: ",curs.inv_no,
               " DOC: ",curs.inv_doc_no using "<<<<<"
        end if
    end if
    
    # - bring discount amt over to dist amt and call on_every_row recursively
    if   curs.disc_amt  != 0
     and curs.dist_acct != curs.disc_acct
    then
        call ml_output() # send current row to report
        let curs.dist_acct = curs.disc_acct
        let curs.dist_department = curs.disc_department
        let curs.dist_amt = curs.disc_amt
        let curs.dist_deb_cred = curs.disc_deb_cred
        let rpt.description = "DISCOUNT ALLOWED"
        call on_every_row()       # recursive call
    end if
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        cr_signed_amt like strcashe.cash_amt,
        group_key   char(20)    # group identification

    if group_key = "doc_no" then
    # - print out the "on account" line
    # - print out the cash line
    # - check the g/l posting
    # - check the a/r posting
    
        # output the "on account" line
        if curs.oa_amt != 0
        then
            # output the current row (if any data in it)
            if curs.dist_amt is not null
            then call ml_output()
            end if
            # set the oa stuff to the dist_ portion of the cursor
            let curs.dist_acct = curs.oa_acct
            let curs.dist_department = curs.oa_department
            let curs.dist_amt = curs.oa_amt
            let curs.dist_deb_cred = curs.oa_deb_cred
            let rpt.description = "ON ACCOUNT"
            let curs.inv_doc_no = 0
            let curs.disc_acct = 0
            let curs.disc_department = "000"
            let curs.disc_amt = 0
            let curs.disc_deb_cred = 0
            # process it (it'll get output later)
            call on_every_row()
        end if

        # output the cash line
        if curs.cash_amt != 0
        then
            # output the current row (if any data in it)
            if curs.dist_amt is not null
            then call ml_output()
            end if
            # set the cash stuff to the dist_ portion of the cursor
            let curs.dist_acct = curs.cash_acct
            let curs.dist_department = curs.cash_department
            let curs.dist_amt = curs.cash_amt
            let curs.dist_deb_cred = curs.cash_deb_cred
            let rpt.description = ""
            let curs.disc_acct = 0
            let curs.disc_department = "000"
            let curs.disc_amt = 0
            let curs.disc_deb_cred = 0
            # process it (it'll get output later)
            call on_every_row()
        end if

        # test the g/l posting...
        if gl_last() = false
        then
            if check_post = "POST"
            then
                rollback work
                call fg_error("lib_all","gl_last",post_gl.status)
            end if
            call end_report(post_gl.description)
        end if

        if curs.cust_code is not null
        then
            # only run ar_last if posting to a/r
            let cr_signed_amt = curs.cash_amt
            if curs.cash_deb_cred = "CR"
            then
                let cr_signed_amt = curs.cash_amt * -1
            end if
            if ar_last(check_post, "CR", cr_signed_amt, curs.cust_code) = false
            then
                if check_post = "POST"
                then
                    rollback work
                    call fg_error("lib_all","ar_last",post_ar.status)
                end if
                call end_report(post_ar.description)
            end if
        end if
        if check_post = "POST"
        then
            commit work
        end if
        return
    end if

    if group_key = "due_date" then
        # insert "after group of due_date" code here
        return
    end if

    if group_key = "inv_doc_no" then
        # insert "after group of inv_doc_no" code here
        return
    end if

    if group_key = "last_row" then
        if rpt.problm1 is null
        then
            let rpt.problm1 = "***** End of report.  No errors detected."
        end if
        # insert "on last row" code here
        return
    end if

end function
# after_group()

#######################################################################
function end_report(why)
#######################################################################
#  this function calls the last line of the report for abnormal termination.
#
    define
        why char(80)

    if check_post = "POST"
    then
        let rpt.problm1 =
            "***** The posting has terminated for the following reason:"
        let rpt.problm2 = "***** ", why clipped
        let rpt.problm3 =
            "***** It HAS NOT been posted.  Documents prior to it HAVE been posted."
        call ml_output()
        finish report report1
        exit program(1)
    else
        let rpt.problm0 = "***** ",why clipped
        let rpt.problm1 = "***** THIS REPORT HAS ERRORS DETECTED"
    end if

end function
# end_report()

