########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_crpost.4gs/midlevel.4gl  1.4  Delta: 4/5/90
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    let quote = "\""
    let ct.sel_join =
        "strcustr.cust_code = strcashe.cust_code and ",
        "strcashe.doc_no = strcashd.doc_no and ",
        "(strcashd.dist_amt != 0 or ",
        "strcashd.disc_amt != 0)"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order =
        "strcashe.doc_no, ",
        "strcashd.due_date, ",
        "strcashd.inv_doc_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from strcashe, outer strcustr, outer strcashd ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "strcashe.ok_to_post, ",
            "strcashe.doc_no, ",
            "strcashd.inv_doc_no, ",
            "strcashd.inv_no, ",
            "strcashd.due_date, ",
            "strcashd.disc_acct, ",
            "strcashd.disc_department, ",
            "strcashd.disc_amt, ",
            "strcashd.disc_deb_cred, ",
            "strcashe.cash_acct, ",
            "strcashe.cash_department, ",
            "strcashe.cash_deb_cred, ",
            "strcashe.oa_amt, ",
            "strcashe.oa_acct, ",
            "strcashe.oa_department, ",
            "strcashe.oa_deb_cred, ",
            "strcashe.rcpt_date, ",
            "strcashe.check_no, ",
            "strcashe.cust_code, ",
            "strcustr.bus_name, ",
            "strcashe.cash_amt, ",
            "strcashe.doc_desc, ",
            "strcashd.dist_acct, ",
            "strcashd.dist_department, ",
            "strcashd.dist_amt, ",
            "strcashd.dist_deb_cred ",
        "from strcashe, outer strcustr, outer strcashd ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    create temp table curs_temp (
        ok_to_post char(1),
        doc_no integer,
        inv_doc_no integer,
        inv_no char(10),
        due_date date,
        disc_acct integer,
        disc_department char(3),
        disc_amt decimal(10),
        disc_deb_cred char(2),
        cash_acct integer,
        cash_department char(3),
        cash_deb_cred char(2),
        oa_amt decimal(10),
        oa_acct integer,
        oa_department char(3),
        oa_deb_cred char(2),
        rcpt_date date,
        check_no char(10),
        cust_code char(6),
        bus_name char(30),
        cash_amt decimal(10),
        doc_desc char(30),
        dist_acct integer,
        dist_department char(3),
        dist_amt decimal(10),
        dist_deb_cred char(2))
    foreach rpt_cursor into curs.*
        insert into curs_temp values(curs.*)
    end foreach
    close rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    select * into curs_next.* from curs_temp
        where rowid = ct.cur_row + 1
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.ok_to_post = curs_next.ok_to_post
    let curs.doc_no = curs_next.doc_no
    let curs.inv_doc_no = curs_next.inv_doc_no
    let curs.inv_no = curs_next.inv_no
    let curs.due_date = curs_next.due_date
    let curs.disc_acct = curs_next.disc_acct
    let curs.disc_department = curs_next.disc_department
    let curs.disc_amt = curs_next.disc_amt
    let curs.disc_deb_cred = curs_next.disc_deb_cred
    let curs.cash_acct = curs_next.cash_acct
    let curs.cash_department = curs_next.cash_department
    let curs.cash_deb_cred = curs_next.cash_deb_cred
    let curs.oa_amt = curs_next.oa_amt
    let curs.oa_acct = curs_next.oa_acct
    let curs.oa_department = curs_next.oa_department
    let curs.oa_deb_cred = curs_next.oa_deb_cred
    let curs.rcpt_date = curs_next.rcpt_date
    let curs.check_no = curs_next.check_no
    let curs.cust_code = curs_next.cust_code
    let curs.bus_name = curs_next.bus_name
    let curs.cash_amt = curs_next.cash_amt
    let curs.doc_desc = curs_next.doc_desc
    let curs.dist_acct = curs_next.dist_acct
    let curs.dist_department = curs_next.dist_department
    let curs.dist_amt = curs_next.dist_amt
    let curs.dist_deb_cred = curs_next.dist_deb_cred
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.due_date = curs_next.due_date
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("due_date")
        let no_break = false
    end if
    if no_break and curs.inv_doc_no = curs_next.inv_doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("inv_doc_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.due_date = curs_next.due_date
    then else
        call after_group("due_date")
        let no_break = false
    end if
    if no_break and curs.inv_doc_no = curs_next.inv_doc_no
    then else
        call after_group("inv_doc_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint    # working number

    # initialize some globals
    initialize post_gl.* to null
    initialize post_ar.* to null

    # default to edit list
    let check_post = "CHECK"
    for n = 1 to num_args()
        if arg_val(n) = "-e"
        then
            let check_post = "CHECK"
        end if
        if arg_val(n) = "-p"
        then
            let check_post = "POST"
        end if
    end for

    if check_post = "CHECK"
    then
        let ct.prcname = "Cash Receipts Listing"
        let ct.allow_int = "Y"
    else
        let ct.prcname = "Cash Receipts Posting List"
        let ct.allow_int = "N"
    end if
    let rpt.heading = ct.prcname
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "1"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

