##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_crpost.4gs/report.4gl  1.4  Last Delta: 10/20/89
##############################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            doc_no like strcashe.doc_no,
            inv_doc_no like strcashd.inv_doc_no,
            inv_no like strcashd.inv_no,
            disc_acct like strcashd.disc_acct,
            disc_department like strcashd.disc_department,
            disc_amt like strcashd.disc_amt,
            disc_deb_cred like strcashd.disc_deb_cred,
            cash_acct like strcashe.cash_acct,
            cash_department like strcashe.cash_department,
            cash_deb_cred like strcashe.cash_deb_cred,
            oa_amt like strcashe.oa_amt,
            oa_acct like strcashe.oa_acct,
            oa_department like strcashe.oa_department,
            oa_deb_cred like strcashe.oa_deb_cred,
            heading char(40),
            co_name like stxcntrc.co_name,
            post_seq char(40),
            txt_doc_no char(10),
            rcpt_date like strcashe.rcpt_date,
            check_no like strcashe.check_no,
            cust_code like strcashe.cust_code,
            bus_name like strcustr.bus_name,
            cash_amt like strcashe.cash_amt,
            doc_desc like strcashe.doc_desc,
            dist_acct like strcashd.dist_acct,
            dist_department like strcashd.dist_department,
            description char(30),
            dist_amt like strcashd.dist_amt,
            dist_deb_cred like strcashd.dist_deb_cred,
            messg1 char(80),
            problm0 char(80),
            problm1 char(80),
            problm2 char(80),
            problm3 char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.doc_no, rpt.inv_doc_no

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                ;
                let scratch = rpt.post_seq
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.heading;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.doc_no
            if
                rpt.dist_acct is not null
             or rpt.dist_department is not null
             or rpt.description is not null
             or rpt.dist_amt is not null
             or rpt.dist_deb_cred is not null
            then
                let dynamic = true
                need 5 lines
            else
                let dynamic = false
                need 3 lines
            end if

            print
                column   4, "Document Number: " clipped,
                            " ", rpt.txt_doc_no,
                column  35, "Date: ",
                column  41, rpt.rcpt_date using "mm/dd/yy",
                column  54, "Check Number: " clipped,
                            " ", rpt.check_no
            print
                column  11, "Customer: " clipped,
                            " ", rpt.cust_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name[1,22],
                column  54, "Check Amount: " clipped,
                            " ", rpt.cash_amt using "<<<<<<<<.&&"
            print
                column   8, "Description: ",
                column  21, rpt.doc_desc
            if dynamic
            then
                print
            end if
            if dynamic
            then
                print
                    column   7, "Account",
                    column  59, "Amount"
            end if

        on every row
            if
                rpt.dist_acct is not null
             or rpt.dist_department is not null
             or rpt.description is not null
             or rpt.dist_amt is not null
             or rpt.dist_deb_cred is not null
            then
                print
                    column   2, rpt.dist_acct using "######",
                    column   9, "- ",
                    column  11, rpt.dist_department,
                    column  17, rpt.description,
                    column  48, rpt.dist_amt using "(((,(((,(((.&&)",
                    column  65, rpt.dist_deb_cred
            end if

        after group of rpt.doc_no
            need 2 lines
            if
                rpt.problm0 is not null
            then
                print
                    column   1, rpt.problm0
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 9 lines
            print
                column  18, "Total Debits",
                column  46, "Total Credits"
            print
                column  13, sum( rpt.dist_amt )
                            where rpt.dist_deb_cred = "DB"
                            using "((,(((,(((,(((.&&)",
                column  42, sum( rpt.dist_amt )
                            where rpt.dist_deb_cred = "CR"
                            using "((,(((,(((,(((.&&)"
            print
            if
                rpt.messg1 is not null
            then
                print
                    column   1, rpt.messg1
            end if
            print
            if
                rpt.problm1 is not null
            then
                print
                    column   1, rpt.problm1
            end if
            if
                rpt.problm2 is not null
            then
                print
                    column   1, rpt.problm2
            end if
            if
                rpt.problm3 is not null
            then
                print
                    column   1, rpt.problm3
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()

