#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_delete.4gs/lowlevel.4gl  1.7  Delta: 11/27/89
#####################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "first_row" then
        # insert "on first row" code here
        let ct.sel_stmt = "select stropend.balance ",
                "from stractvd, outer stropend ",
                    "where stractvd.orig_journal = ? and ",
                          "stractvd.doc_no = ? and ", 
                          "stractvd.inv_doc_no = stropend.doc_no"
        prepare select_curs from ct.sel_stmt
        declare ar_cursor cursor for select_curs
        let ct.sel_stmt = "select stxtranr.orig_journal, ",
                                 "stxtranr.doc_no, ",
                                 "stxtranr.doc_date, ",
                                 "stxtranr.ref_code, ",
                                 "strtranr.inv_chk_no, ",
                                 "stractvd.inv_doc_no, ",
                                 "stractvd.amount ",
                          "from stxtranr, strtranr, stractvd ",
                "where stxtranr.orig_journal = strtranr.orig_journal and ",
                      "stxtranr.doc_no = strtranr.doc_no and ",
                      "strtranr.orig_journal = stractvd.orig_journal and ",
                      "strtranr.doc_no = stractvd.doc_no and ",
                      "stxtranr.orig_journal = ? and stxtranr.doc_no = ?" 
        prepare out_curs from ct.sel_stmt
        declare trx_cur cursor for out_curs
        return
    end if

    if group_key = "orig_journal" then
        # insert "before group of orig_journal" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    let rpt.orig_journal = curs.orig_journal
    let rpt.doc_no = curs.doc_no
    let rpt.post_no = curs.post_no
    let rpt.post_date = curs.post_date
    let rpt.doc_date = curs.doc_date
    let rpt.ref_code = curs.ref_code
    let rpt.doc_desc = curs.doc_desc
    let rpt.inv_chk_no = curs.inv_chk_no
    let rpt.doc_type = curs.doc_type
#   let rpt.heading = (MUST SUPPLY)
    let rpt.co_name = m_xcntrc.co_name
#   let rpt.data = (MUST SUPPLY)
    if ok_to_delete()
    then
        call remove_them()
    end if
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "orig_journal" then
        # insert "after group of orig_journal" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()

##############################################################
function ok_to_delete()
# returns false if open balances for document is not null or 0
#   or if g/l transaction has not been posted
##############################################################
# this function checks to see if this document has any open
# item.

define
    p_balance like stropend.balance, # holder for open item balance
    gl_count smallint          # number of unposted gl documents

    open ar_cursor using curs.orig_journal, curs.doc_no

    foreach ar_cursor into p_balance
        if p_balance is not null and p_balance != 0
        then
            return false
        end if
    end foreach

    close ar_cursor

    select count(*) into gl_count from 
        stgtranr where stgtranr.orig_journal = curs.orig_journal and
                       stgtranr.doc_no = curs.doc_no and stgtranr.status != "P"

    if gl_count > 0  # gl transaction is not posted.
    then
        return false
    end if

    return true

end function
# ok_to_delete()

##################################################################
function remove_them()
##################################################################
#
# delete documents from tables
#
    define
        p_trx record
            orig_journal like stxtranr.orig_journal,
            doc_no like stxtranr.doc_no,
            doc_date like stxtranr.doc_date,
            ref_code like stxtranr.ref_code,
            inv_chk_no like strtranr.inv_chk_no,
            inv_doc_no like stractvd.inv_doc_no,
            amount like stractvd.amount
        end record

    open trx_cur using curs.orig_journal, curs.doc_no

    begin work
    foreach trx_cur into p_trx.*   # update archive balance, delete open item
        if p_trx.inv_doc_no = 0    # on account amount
        then
            update strcustr set arch_bal = arch_bal + p_trx.amount
                where cust_code = p_trx.ref_code
        end if 
        delete from stropend where stropend.doc_no = p_trx.inv_doc_no
        let rpt.data = p_trx.orig_journal, "      ", 
                       p_trx.doc_no using "######", "    ",
                       p_trx.doc_date, "    ",
                       p_trx.ref_code, "     ",
                       p_trx.inv_chk_no, "      ",
                       p_trx.inv_doc_no using "######", "   ",
                       p_trx.amount using "----------&.&&"
        call ml_output()
    end foreach

    close trx_cur
  
    let rpt.data = null

    delete from strtranr where
        strtranr.orig_journal = rpt.orig_journal and
        strtranr.doc_no = rpt.doc_no
    delete from stractvd where
        stractvd.orig_journal = rpt.orig_journal and
        stractvd.doc_no = rpt.doc_no
    delete from stgtranr where
        stgtranr.orig_journal = rpt.orig_journal and
        stgtranr.doc_no = rpt.doc_no
    delete from stgactvd where
        stgactvd.orig_journal = rpt.orig_journal and
        stgactvd.doc_no = rpt.doc_no
    call del_trx(rpt.orig_journal, rpt.doc_no)
    commit work

end function
# remove_them()

