##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_delete.4gs/midlevel.4gl  1.4  Last Delta: 8/8/89
##############################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    let quote = "\""
    let ct.sel_join = "stxtranr.orig_journal = strtranr.orig_journal and ",
                      "stxtranr.doc_no = strtranr.doc_no and ",
                      "(stxtranr.orig_journal = ",quote,"CR",quote,
                  "  or stxtranr.orig_journal = ",quote,"AR",quote,")"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    let quote = "\""
    let ct.sel_filter = "stxtranr.doc_date <= ", quote, p_arc_date, quote
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "stxtranr.orig_journal, stxtranr.doc_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stxtranr, strtranr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stxtranr.orig_journal, ",
            "stxtranr.doc_no, ",
            "stxtranr.post_no, ",
            "stxtranr.post_date, ",
            "stxtranr.doc_date, ",
            "stxtranr.ref_code, ",
            "stxtranr.doc_desc, ",
            "strtranr.inv_chk_no, ",
            "strtranr.doc_type ",
        "from stxtranr, strtranr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    whenever error call error_handler
    create temp table curs_temp (
        orig_journal char(2),
        doc_no integer,
        post_no integer, 
        post_date date, 
        doc_date date, 
        ref_code char(6), 
        doc_desc char(30), 
        inv_chk_no char(10), 
        doc_type char(2))
    foreach rpt_cursor into curs.*
        insert into curs_temp values(curs.*)
    end foreach
    close rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    select * into curs_next.* from curs_temp
        where rowid = ct.cur_row + 1
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.orig_journal = curs_next.orig_journal
    let curs.doc_no = curs_next.doc_no
    let curs.post_no = curs_next.post_no
    let curs.post_date = curs_next.post_date
    let curs.doc_date = curs_next.doc_date
    let curs.ref_code = curs_next.ref_code
    let curs.doc_desc = curs_next.doc_desc
    let curs.inv_chk_no = curs_next.inv_chk_no
    let curs.doc_type = curs_next.doc_type
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.orig_journal = curs_next.orig_journal
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("orig_journal")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.orig_journal = curs_next.orig_journal
    then else
        call after_group("orig_journal")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint,   # working number
        arg_flag char(1),   # archive type d=date, m=month, p=prompt user
        arc_month smallint,
        quote char(1)

    let arg_flag = "P"

    for n = 1 to num_args()
        if arg_val(n) = "-date"
        then
            let p_arc_date = arg_val(n+1)
            let arg_flag = "D"
            exit for
        end if
        if arg_val(n) = "-month"
        then
            let arc_month = arg_val(n+1)
            let arg_flag = "M"
            exit for
        end if
    end for
    if arg_flag = "P"
    then
        open window selwin at 6, 6 with 14 rows, 70 columns
                attribute (border, blue)
        call menu_line()
        while arg_flag != "M" and arg_flag != "D"
            prompt "Archive by (M)onth or by (D)ate? " for arg_flag 
            if arg_flag is null then let arg_flag = "p" end if
            if int_flag != 0
            then
                exit program(1)
            end if 
            let arg_flag = upshift(arg_flag)
            if arg_flag != "M" and arg_flag !="D"
            then
                call fg_err(1) #Enter a "M" for Month  or a "D" for Date
            end if
        end while
        if upshift(arg_flag) = "M" 
        then
            let arg_flag = "P"
            while arg_flag != "M"
                prompt "Enter the Number of Months before today to archive: " 
                    for arc_month
                if int_flag != 0
                then
                    exit program(1)
                end if 
                if status = 0
                then
                    let arg_flag = "M"
                else
                    let status = 0
                    call fg_err(2) #Enter a valid number
                end if
            end while
        else 
            let arg_flag = "P"
            while arg_flag != "D"
                prompt "Enter the Archive Date: " 
                    for p_arc_date
                if int_flag != 0
                then
                    exit program(1)
                end if 
                if status = 0
                then
                    let arg_flag = "D"
                else
                    let status = 0
                    call fg_err(3) #Enter a valid date
                end if
             end while
        end if
        close window selwin
    end if
    if arg_flag = "M"
    then
        call prev_month(arc_month,today) returning p_arc_date
    end if 
    let quote = "\""
    let rpt.heading = "Delete A/R Activity on or before " , p_arc_date
    let ct.prcname = "Delete Old A/R Activity"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.quiet = "1"
    let ct.allow_int = "N"
    let ct.prc_only = "N"
    let ct.destin = "report.out"
end function
# ml_defaults()

