##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_delete.4gs/report.4gl  1.2  Last Delta: 8/8/89
##############################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            orig_journal like stxtranr.orig_journal,
            doc_no like stxtranr.doc_no,
            post_no like stxtranr.post_no,
            post_date like stxtranr.post_date,
            doc_date like stxtranr.doc_date,
            ref_code like stxtranr.ref_code,
            doc_desc like stxtranr.doc_desc,
            inv_chk_no like strtranr.inv_chk_no,
            doc_type like strtranr.doc_type,
            heading char(60),
            co_name like stxcntrc.co_name,
            data char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     0
        bottom margin  0
        left margin    0
        right margin   80
        page length    66

    order external by rpt.orig_journal

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "OJ",
                column   8, "Doc. No",
                column  19, "Doc.Date",
                column  29, "Ref Code",
                column  41, "Inv.Chk.No.",
                column  57, "Inv.Doc.No",
                column  75, "Amount"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.heading;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        on every row
            if
                rpt.data is not null
            then
                print
                    column   1, rpt.data
            end if

end report
# report1()

