########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_invpst.4gs/midlevel.4gl  1.6  Delta: 5/11/90
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    let quote = "\""
    let ct.sel_join =
        "strcustr.cust_code = strinvce.cust_code and ",
        "strinvce.posted != ", quote, "Y", quote, " and ",
        "strinvce.doc_no = strinvcd.doc_no and ",
        "strinvcd.line_no > 0"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "strinvce.doc_no, strinvcd.line_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from strcustr, strinvce, outer strinvcd ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    whenever error continue
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    whenever error call error_handler
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "strinvce.ok_to_post, ",
            "strinvce.file_type, ",
            "strinvce.ref_no, ",
            "strinvcd.debit_credit, ",
            "strinvcd.line_no, ",
            "strinvce.due_date, ",
            "strinvce.disc_date, ",
            "strinvce.po_no, ",
            "strinvce.po_date, ",
            "strinvce.doc_no, ",
            "strinvce.inv_date, ",
            "strinvce.cust_code, ",
            "strcustr.bus_name, ",
            "strinvce.inv_no, ",
            "strinvce.inv_desc, ",
            "strinvcd.acct_no, ",
            "strinvcd.department, ",
            "strinvcd.description, ",
            "strinvcd.amount ",
        "from strcustr, strinvce, outer strinvcd ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    whenever error continue
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    create temp table curs_temp (
            ok_to_post char(1),
            file_type char(1),
            ref_no integer,
            debit_credit char(2),
            line_no smallint,
            due_date date,
            disc_date date,
            po_no char(10),
            po_date date,
            doc_no integer,
            inv_date date,
            cust_code char(6),
            bus_name char(30),
            inv_no char(10),
            inv_desc char(30),
            acct_no integer,
            department char(3),
            description char(20),
            amount decimal(10))
    foreach rpt_cursor into curs.*
        insert into curs_temp values(curs.*)
    end foreach
    close rpt_cursor
    whenever error call error_handler
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    select * into curs_next.* from curs_temp
        where rowid = ct.cur_row + 1
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.ok_to_post = curs_next.ok_to_post
    let curs.file_type = curs_next.file_type
    let curs.ref_no = curs_next.ref_no
    let curs.debit_credit = curs_next.debit_credit
    let curs.line_no = curs_next.line_no
    let curs.due_date = curs_next.due_date
    let curs.disc_date = curs_next.disc_date
    let curs.po_no = curs_next.po_no
    let curs.po_date = curs_next.po_date
    let curs.doc_no = curs_next.doc_no
    let curs.inv_date = curs_next.inv_date
    let curs.cust_code = curs_next.cust_code
    let curs.bus_name = curs_next.bus_name
    let curs.inv_no = curs_next.inv_no
    let curs.inv_desc = curs_next.inv_desc
    let curs.acct_no = curs_next.acct_no
    let curs.department = curs_next.department
    let curs.description = curs_next.description
    let curs.amount = curs_next.amount
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.line_no = curs_next.line_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("line_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.line_no = curs_next.line_no
    then else
        call after_group("line_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint    # working number

    # initialize some globals
    initialize post_gl.* to null
    initialize post_ar.* to null

    # default to edit list
    let check_post = "CHECK"
    for n = 1 to num_args()
        if arg_val(n) = "-e"
        then
            let check_post = "CHECK"
        end if
        if arg_val(n) = "-p"
        then
            let check_post = "POST"
        end if
    end for

    if check_post = "CHECK"
    then
        let ct.prcname = "Receivable Listing"
        let ct.allow_int = "Y"
    else
        let ct.prcname = "Receivable Documents Posting List"
        let ct.allow_int = "N"
    end if
    let rpt.heading = ct.prcname
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "1"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

