##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_invpst.4gs/report.4gl  1.6  Last Delta: 4/23/90
##############################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            doc_no like strinvce.doc_no,
            file_type like strinvce.file_type,
            ref_no like strinvce.ref_no,
            debit_credit like strinvcd.debit_credit,
            line_no like strinvcd.line_no,
            due_date like strinvce.due_date,
            disc_date like strinvce.disc_date,
            po_no like strinvce.po_no,
            po_date like strinvce.po_date,
            heading char(40),
            co_name like stxcntrc.co_name,
            post_seq char(40),
            txt_doc_no char(10),
            inv_date like strinvce.inv_date,
            inv_type char(14),
            cust_code like strinvce.cust_code,
            bus_name like strcustr.bus_name,
            inv_no like strinvce.inv_no,
            inv_desc like strinvce.inv_desc,
            ref_verb char(10),
            ref_code char(10),
            acct_no like strinvcd.acct_no,
            department like strinvcd.department,
            description char(30),
            amount like strinvcd.amount,
            messg1 char(80),
            problm0 char(80),
            problm1 char(80),
            problm2 char(80),
            problm3 char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.doc_no, rpt.line_no

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                ;
                let scratch = rpt.post_seq
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.heading;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.doc_no
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                let dynamic = true
                need 5 lines
            else
                let dynamic = false
                need 3 lines
            end if

            print
                column   4, "Document Number: " clipped,
                            " ", rpt.txt_doc_no,
                column  35, "Date: ",
                column  41, rpt.inv_date using "mm/dd/yy",
                column  61, "Type: ",
                column  67, rpt.inv_type
            print
                column  11, "Customer: " clipped,
                            " ", rpt.cust_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name,
                column  59, "Number: ",
                column  67, rpt.inv_no
            print
                column   8, "Description: ",
                column  21, rpt.inv_desc,
                column  57, rpt.ref_verb clipped,
                            " ", rpt.ref_code
            if dynamic
            then
                print
            end if
            if dynamic
            then
                print
                    column   7, "Account",
                    column  60, "Amount"
            end if

        on every row
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                print
                    column   7, rpt.acct_no using "######",
                    column  14, "- ",
                    column  16, rpt.department,
                    column  22, rpt.description,
                    column  50, rpt.amount using "(((,(((,(((.&&)",
                    column  67, rpt.debit_credit
            end if

        after group of rpt.doc_no
            need 2 lines
            if
                rpt.problm0 is not null
            then
                print
                    column   1, rpt.problm0
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 9 lines
            print
                column  18, "Total Debits",
                column  46, "Total Credits"
            print
                column  13, sum( rpt.amount )
                            where rpt.debit_credit = "DB"
                            using "((,(((,(((,(((.&&)",
                column  42, sum( rpt.amount )
                            where rpt.debit_credit = "CR"
                            using "((,(((,(((,(((.&&)"
            print
            if
                rpt.messg1 is not null
            then
                print
                    column   1, rpt.messg1
            end if
            print
            if
                rpt.problm1 is not null
            then
                print
                    column   1, rpt.problm1
            end if
            if
                rpt.problm2 is not null
            then
                print
                    column   1, rpt.problm2
            end if
            if
                rpt.problm3 is not null
            then
                print
                    column   1, rpt.problm3
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()

